{$A+,B-,D+,E+,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
unit comp;
interface
var  ERROR:byte;
     errpoz,poz:word;
     const MaERROR=1;
           SynERROR=2;
           GoERROR=4;
           NeERROR=6;
           ArgERROR=8;
           ComERROR=10;
           MemERROR=12;
           DimERROR=14;
           StkERROR=16;
           SysERROR=18;
     grapherror:boolean=false;
     graphmode:boolean=false;
     radix:byte=10;
type
     pnumero=^tnumero;
     tnumero=record
     case mode:byte of
     0:(x:double);
     1:(sign:shortint;int,cit,jmen:longint)
     end;
     string21=string[21];
const nummode:byte=1;
     type strproc=function(f:tnumero):string21;
     const zeronum:tnumero=(mode:0;x:0);
           onenum:tnumero=(mode:0;x:1);

var numtostr:strproc;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure seterror(e:byte);
procedure fractonum(var f:tnumero);
procedure setdeg;
procedure fromdeg(var f:tnumero);
procedure setrad;
procedure fromrad(var f:tnumero);
procedure torad(var f:tnumero);
procedure setgra;
procedure fromgra(var f:tnumero);
procedure todefault(var f:tnumero);
procedure sin(var f:tnumero);
procedure cos(var f:tnumero);
procedure tan(var f:tnumero);
procedure asin(var f:tnumero);
procedure acos(var f:tnumero);
procedure atan(var f:tnumero);
procedure sinh(var f:tnumero);
procedure cosh(var f:tnumero);
procedure tanh(var f:tnumero);
procedure asinh(var f:tnumero);
procedure acosh(var f:tnumero);
procedure atanh(var f:tnumero);
procedure fact(var f:tnumero);
procedure ln(var f:tnumero);
procedure e(var f:tnumero);
procedure log(var f:tnumero);
procedure exp10(var f:tnumero);
procedure sqrt(var x,y:tnumero);
procedure sqr(var x,y:tnumero);
procedure sqrt3(var f:tnumero);
procedure pow(var f,e:tnumero);
procedure root(var f,e:tnumero);
procedure plus(var x,y:tnumero);
procedure minus(var x,y:tnumero);
procedure rekrat(var x,y:double);
procedure krat(var x,y:tnumero);
procedure redeleno(var x,y:double);
procedure deleno(var x,y:tnumero);
procedure abs(var x,y:tnumero);
procedure arg(var x,y:tnumero);
procedure fakan(var x:tnumero);
procedure perm(var x,y:tnumero);
procedure komb(var x,y:tnumero);
procedure int(var x:tnumero);
procedure frac(var x:tnumero);
procedure intg(var x:tnumero);
procedure ran(var x:tnumero);
function atan2 (X,Y:double):double;
procedure inv(var x,y:tnumero);
procedure neg(var x:tnumero);
procedure bnot(var x:tnumero);
procedure lnot(var x:tnumero);
function zero(x:tnumero):boolean;
procedure rovno(var x,y:tnumero);
procedure nerovno(var x,y:tnumero);
procedure mensi(var x,y:tnumero);
procedure vetsi(var x,y:tnumero);
procedure mensirov(var x,y:tnumero);
procedure vetsirov(var x,y:tnumero);
procedure band(var x,y:tnumero);
procedure land(var x,y:tnumero);
procedure bor(var x,y:tnumero);
procedure lor(var x,y:tnumero);
procedure bxor(var x,y:tnumero);
procedure bxnor(var x,y:tnumero);
function getexp(x:double):double;
function numtofrac(var x:tnumero):boolean;
function zarovnej21(s:string21):string21;
procedure setdec;
procedure sethex;
procedure setbin;
procedure setoct;
procedure setfix(c:word);
procedure setsci(c:word);
procedure setnorm;
var ex:array[-99..99]of double;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
implementation
var degu,radu,gradu:double;
const  iseng:boolean=false;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure seterror(e:byte);
begin
if boolean(error) then exit;
if(e=MaERROR)and graphmode then begin grapherror:=true;exit;end;
error:=e;errpoz:=poz;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function max(a,b:longint):longint;begin if a>b then max:=a else max:=b;end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function min(a,b:longint):longint;begin if a<b then min:=a else min:=b;end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function testl(x:tnumero):boolean;
begin
if system.abs(system.int(x.x))>maxlongint then seterror(MaERROR);
testl:=ERROR=MaERROR;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure fractonum(var f:tnumero);
begin
if f.mode=0 then exit;
f.mode:=0;f.x:=f.sign*(f.int+f.cit/f.jmen);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function signum(a:double):integer;
begin
if a<0 then signum:=-1 else signum:=1;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function numtofrac(var x:tnumero):boolean;
var a:longint;
begin
numtofrac:=true;
if x.mode=1 then exit;
numtofrac:=false;
if(x.x<>system.int(x.x))or(system.abs(x.x)>1e9)then exit;
numtofrac:=true;
a:=trunc(x.x);x.mode:=1;x.jmen:=1;x.cit:=0;
x.sign:=signum(a);x.int:=a;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function zero(x:tnumero):boolean;
begin
fractonum(x);zero:=x.x=0;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function getexp(x:double):double;
begin
x:=system.abs(x);
if x=0 then getexp:=1e-99 else
getexp:=ex[trunc(system.ln(x)/system.ln(10))];
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function krouh(x,n:double):double;
begin
n:=getexp(n)/1e14;
krouh:=system.int(x/n+0.5)*n;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function round(x:double):double;
begin
round:=krouh(x,getexp(x));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setdeg;
begin
degu:=1;radu:=180/pi;gradu:=0.9;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure fromdeg(var f:tnumero);
begin
fractonum(f);
f.x:=round(f.x*degu);
if system.abs(f.x)>=1e100 then seterror(MaERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setrad;
begin
degu:=pi/180;radu:=1;gradu:=pi/200;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure fromrad(var f:tnumero);
begin
fractonum(f);
f.x:=round(f.x*radu);
if system.abs(f.x)>=1e100 then seterror(MaERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure torad(var f:tnumero);
begin
fractonum(f);
f.x:=f.x/radu;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setgra;
begin
degu:=10/9;radu:=200/pi;gradu:=1;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure fromgra(var f:tnumero);
begin
fractonum(f);
f.x:=round(f.x*gradu);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure todefault(var f:tnumero);
begin
f.x:=round(f.x*radu);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure sin(var f:tnumero);
begin
fractonum(f);torad(f);
if system.abs(f.x)>=5e7*pi then seterror(MaERROR) else
f.x:=round(system.sin(f.x));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure cos(var f:tnumero);
begin
fractonum(f);torad(f);
if system.abs(f.x)>=5e7*pi then seterror(MaERROR) else
f.x:=round(system.cos(f.x));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure tan(var f:tnumero);
var x,y:double;
begin
fractonum(f);torad(f);
if system.abs(f.x)>=5e7*pi then begin seterror(MaERROR);exit;end;
x:=system.sin(f.x);y:=system.cos(f.x);
if system.abs(y)<=1e-100 then seterror(MaERROR)
else begin
     f.x:=x/y;
     if system.abs(f.x)>1e100 then seterror(MaERROR);
     end;
f.x:=round(f.x);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure asin(var f:tnumero);
begin
fractonum(f);
if system.abs(f.x)>1 then begin seterror(MaERROR);exit;end;
if f.x=1 then begin f.x:=90*degu;exit;end;
if f.x=-1 then begin f.x:=-90*degu;exit;end;
f.x:=arctan(f.x/system.sqrt((1-f.x)*(1+f.x)));
todefault(f);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure acos(var f:tnumero);
begin
fractonum(f);
if system.abs(f.x)>1 then begin seterror(MaERROR);exit;end;
if f.x=0 then begin f.x:=180*degu;exit;end;
f.x:=arctan(system.sqrt((1-f.x)*(1+f.x))/f.x);
todefault(f);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure atan(var f:tnumero);
begin
fractonum(f);
f.x:=arctan(f.x);
todefault(f);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure sinh(var f:tnumero);
begin
fractonum(f);
if system.abs(f.x)>=230.2585 then seterror(MaERROR) else
f.x:=round(0.5*(system.exp(f.x)-system.exp(-f.x)));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure cosh(var f:tnumero);
begin
fractonum(f);
if system.abs(f.x)>=230.2585 then seterror(MaERROR) else
f.x:=round(0.5*(system.exp(f.x)+system.exp(-f.x)));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure tanh(var f:tnumero);
begin
fractonum(f);
if system.abs(f.x)>=17 then begin
if f.x>0 then f.x:=1 else f.x:=-1;exit;end;
f.x:=round((system.exp(f.x)-system.exp(-f.x))/(system.exp(f.x)+system.exp(-f.x)));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure asinh(var f:tnumero);
begin
fractonum(f);
f.x:=round(system.ln(system.sqrt(system.sqr(f.x)+1)+f.x));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure acosh(var f:tnumero);
begin
fractonum(f);
if f.x<1 then begin seterror(MaERROR);exit;end;
f.x:=round(2*system.ln(system.sqrt(f.x+1)+system.sqrt(f.x-1))-system.ln(2));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure atanh(var f:tnumero);
begin
fractonum(f);
if system.abs(f.x)>=1 then seterror(MaERROR) else
f.x:=round(0.5*(system.ln(f.x+1)-system.ln(1-f.x)));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure fact(var f:tnumero);
var
i:byte;s:double;
begin
fractonum(f);s:=0;
if (f.x<0)or(f.x>69)or(f.x<>system.int(f.x))then
   begin seterror(MaERROR);exit;end;
for i:=2 to trunc(f.x) do s:=s+system.ln(i);
f.x:=round(system.exp(f.x));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure ln(var f:tnumero);
begin
fractonum(f);
if (f.x<=0)then begin seterror(MaERROR);exit;end;
f.x:=round(system.ln(f.x));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure e(var f:tnumero);
begin
fractonum(f);
if (f.x<230.2585)then begin seterror(MaERROR);exit;end;
f.x:=round(system.exp(f.x));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure log(var f:tnumero);
begin
fractonum(f);
if (f.x<=0)then begin seterror(MaERROR);exit;end;
f.x:=round(system.ln(f.x)/system.ln(10));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure exp10(var f:tnumero);
begin
fractonum(f);
if (f.x>=100)then begin seterror(MaERROR);exit;end;
f.x:=round(system.exp(f.x*system.ln(10)));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function atan2 (X,Y:double):double;
begin
if X>0 then atan2:=system.arctan(Y/X)
else if Y>0 then atan2:=pi/2
     else if Y<0 then atan2:=-pi/2
            else atan2:=pi;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure sqrt(var x,y:tnumero);
var abs,ang:double;
begin
fractonum(x);fractonum(y);
abs:=system.sqrt(system.sqrt(system.sqr(x.x)+system.sqr(y.x)));
ang:=atan2(x.x,y.x)/2;
x.x:=round(abs*system.cos(ang));
y.x:=round(abs*system.sin(ang));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure sqr(var x,y:tnumero);
var abs,ang:double;
begin
fractonum(x);fractonum(y);
abs:=system.sqr(x.x)+system.sqr(y.x);
ang:=2*atan2(x.x,y.x);
x.x:=krouh(abs*system.cos(ang),abs);
y.x:=krouh(abs*system.sin(ang),abs);
if (x.x>=1e100)or(y.x>=1e100) then seterror(MaERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure sqrt3(var f:tnumero);
begin
fractonum(f);
if f.x=0 then exit;
if f.x<0 then f.x:=round(-system.exp(system.ln(-f.x)/3))
         else f.x:=round(system.exp(system.ln(f.x)/3));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure pow(var f,e:tnumero);
var abs,ang:double;
begin
fractonum(f);fractonum(e);
if f.x=0 then begin
         if e.x=0 then begin seterror(MaERROR);exit;end
         else exit;end;
if e.x=0 then begin f.x:=1;exit;end;
abs:=system.exp(system.ln(system.abs(f.x))*e.x);
ang:=atan2(f.x,0)*e.x;
f.x:=krouh(abs*system.cos(ang),abs);
if (system.sin(ang)/abs)>1e13 then seterror(MaERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure root(var f,e:tnumero);
var abs,ang:double;
begin
fractonum(e);if e.x=0 then begin seterror(MaERROR);exit;end;
fractonum(f);
if f.x=0 then exit;
abs:=system.exp(system.ln(system.abs(f.x))/e.x);
ang:=atan2(f.x,0)/e.x;
f.x:=krouh(abs*system.cos(ang),abs);
if krouh(system.sin(ang),abs)<>0 then seterror(MaERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function nsd(a,b:longint):longint;
begin
while (a>0)and(b>0)and(a<>b) do
if a<b then b:=b mod a else a:=a mod b;
if a=0 then nsd:=b else nsd:=a;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure dofrac(var x:tnumero;a,aa:double);
var  b,c:longint;
begin
if aa=0 then begin seterror(MaERROR);exit;end;
if (system.abs(a)>1e9)or(system.abs(aa)>1e9) then begin
x.mode:=0;x.x:=a/aa;exit;end;
x.mode:=1;
x.sign:=signum(a/aa);
a:=system.abs(a);
c:=trunc(system.abs(aa));
b:=nsd(trunc(a),c);a:=a/b;c:=c div b;
x.int:=trunc(a/c);
x.cit:=trunc(a)-c*x.int;
x.jmen:=c;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure plus(var x,y:tnumero);
var a:double;
begin
if numtofrac(x)and numtofrac(y) then
begin
a:=x.sign*y.jmen*(x.int*x.jmen+x.cit)+y.sign*x.jmen*(y.int*y.jmen+y.cit);
dofrac(x,a,x.jmen*y.jmen);exit;end;
fractonum(x);fractonum(y);x.x:=round(x.x+y.x);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure minus(var x,y:tnumero);
begin
neg(y);plus(x,y);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure rekrat(var x,y:double);
begin
x:=round(x*y);
if system.abs(x)>=1e100 then seterror(MaERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure krat(var x,y:tnumero);
var a:double;
begin
if numtofrac(x)and numtofrac(y) then
begin
a:=x.sign*(x.int*x.jmen+x.cit)*y.sign*(y.int*y.jmen+y.cit);
dofrac(x,a,x.jmen*y.jmen);exit;end;
fractonum(x);fractonum(y);rekrat(x.x,y.x);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure redeleno(var x,y:double);
begin
x:=round(x/y);
if system.abs(x)>=1e100 then seterror(MaERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure deleno(var x,y:tnumero);
var a,aa:double;
begin
if zero(y)then begin seterror(MaERROR);exit;end;
if numtofrac(x)and numtofrac(y) then
begin
a:=x.sign*y.sign*(x.int*x.jmen+x.cit)*y.jmen;
aa:=(y.int*y.jmen+y.cit)*x.jmen;dofrac(x,a,aa);exit;end;
fractonum(x);fractonum(y);redeleno(x.x,y.x);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure abs(var x,y:tnumero);
begin
fractonum(x);fractonum(y);
x.x:=round(system.sqrt(system.sqr(x.x)+system.sqr(y.x)));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure arg(var x,y:tnumero);
begin
fractonum(x);fractonum(y);
if (x.x=0)and(y.x=0) then seterror(MaERROR) else x.x:=round(atan2(x.x,y.x));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure fakan(var x:tnumero);
var i,s:byte;
begin
fractonum(x);
if (system.int(x.x)<>x.x)or(x.x<0)or(x.x>69)then begin seterror(MaERROR);exit;end;
s:=trunc(x.x);x.x:=1;
for i:=2 to s do x.x:=x.x*i;
x.x:=round(x.x);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure perm(var x,y:tnumero);
var i,s:longint;
begin
fractonum(x);fractonum(y);
if (y.x<0)or(x.x<y.x)or(x.x>=1e10)or(system.int(x.x)<>x.x)or(system.int(y.x)<>y.x)
   then begin seterror(MaERROR);exit;end;
s:=trunc(x.x);i:=trunc(x.x-y.x+1);x.x:=1;
for i:=i to s do
begin x.x:=x.x*i;
if x.x>1e100 then begin seterror(MaERROR);exit;end;
end;
x.x:=round(x.x);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure komb(var x,y:tnumero);
var i,s,a,b:longint;
begin
fractonum(x);fractonum(y);
if (y.x<0)or(x.x<y.x)or(x.x>=1e10)or(system.int(x.x)<>x.x)or(system.int(y.x)<>y.x)
   then begin seterror(MaERROR);exit;end;
s:=trunc(x.x);i:=max(trunc(x.x-y.x),trunc(y.x));
b:=min(trunc(x.x-y.x),trunc(y.x));x.x:=1;
a:=2;
for i:=i+1 to s do begin
x.x:=x.x*i;
if a<=b then x.x:=x.x/a;
inc(a);
end;
x.x:=round(x.x);
if x.x>1e100 then seterror(MaERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure int(var x:tnumero);
begin
fractonum(x);x.x:=system.int(x.x);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure frac(var x:tnumero);
begin
fractonum(x);x.x:=system.frac(x.x);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure intg(var x:tnumero);
var c:double;
begin
fractonum(x);c:=system.int(x.x);
if c<x.x then c:=c-1;
x.x:=c;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure ran(var x:tnumero);
begin
x.mode:=0;x.x:=random;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure neg(var x:tnumero);
begin
case x.mode of
0:x.x:=-x.x;
1:x.sign:=-x.sign;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure bnot(var x:tnumero);
begin
fractonum(x);
if testl(x) then exit;
x.x:=not(trunc(x.x));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure lnot(var x:tnumero);
begin
x.x:=byte(x.x<>0);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure inv(var x,y:tnumero);
var a,b,c,d,jm:tnumero;
begin
numtofrac(x);numtofrac(y);
jm:=x;krat(jm,jm);
a:=y;krat(a,a);minus(jm,a);
neg(y);deleno(y,jm);deleno(x,jm);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure rovno(var x,y:tnumero);
begin
fractonum(x);fractonum(y);
x.x:=byte((round(x.x)=round(y.x)));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure nerovno(var x,y:tnumero);
begin
fractonum(x);fractonum(y);
x.x:=byte((round(x.x)<>round(y.x)));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure mensi(var x,y:tnumero);
begin
fractonum(x);fractonum(y);
x.x:=byte((round(x.x)<round(y.x)));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure vetsi(var x,y:tnumero);
begin
fractonum(x);fractonum(y);
x.x:=byte((round(x.x)>round(y.x)));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure mensirov(var x,y:tnumero);
begin
fractonum(x);fractonum(y);

x.x:=byte((round(x.x)<=round(y.x)));
x.x:=x.x;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure vetsirov(var x,y:tnumero);
begin
fractonum(x);fractonum(y);
x.x:=byte((round(x.x)>=round(y.x)));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure band(var x,y:tnumero);
begin
fractonum(x);fractonum(y);
if testl(x) or testl(y) then exit;
x.x:=trunc(x.x)and trunc(y.x);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure land(var x,y:tnumero);
begin
fractonum(x);fractonum(y);
x.x:=byte((x.x<>0)and(y.x<>0));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure bor(var x,y:tnumero);
begin
fractonum(x);fractonum(y);
if testl(x) or testl(y) then exit;
x.x:=trunc(x.x)or trunc(y.x);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure lor(var x,y:tnumero);
begin
fractonum(x);fractonum(y);
x.x:=byte((x.x<>0)or(y.x<>0));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure bxor(var x,y:tnumero);
begin
fractonum(x);fractonum(y);
if testl(x) or testl(y) then exit;
x.x:=trunc(x.x)xor trunc(y.x);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure bxnor(var x,y:tnumero);
begin
fractonum(x);fractonum(y);
if testl(x) or testl(y) then exit;
x.x:=trunc(x.x)xor trunc(y.x);
bnot(x);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function normstr(f:tnumero):string21;far;
var e:integer;
sm,se:string21;
label zlomek;
begin
if f.mode=1 then goto zlomek;
if f.x=0 then e:=0 else e:=trunc(system.ln(system.abs(f.x))/system.ln(10));
if(e<10)and(e>-(7*nummode-4))then e:=0;if e<0 then dec(e);
str(system.abs(f.x/ex[e]):11:11,sm);
while (sm[0]>#1)and not((sm[byte(sm[0])]>'0')and(sm[byte(sm[0])]<':'))and(sm[byte(sm[0])]<>'.')do dec(sm[0]);
if sm[byte(sm[0])]='.' then dec(sm[0]);
if f.x<0 then sm:='-'+sm;
if e=0 then begin normstr:=sm;exit;end;
str(system.abs(e):2,se);if se[1]=' ' then se[1]:='0';
sm:=sm+#131;
if e<0 then sm:=sm+'-'else sm:=sm+'+';
normstr:=sm+se;
exit;

zlomek:    sm:='';
if f.int<>0 then str(f.int,sm);
if f.cit<>0 then begin str(f.cit,se);
if f.int<>0 then sm:=sm+#1+se else sm:=se;
str(f.jmen,se);sm:=sm+#1+se;end;
if sm='' then begin normstr:='0';exit;end;
if f.sign<0 then sm:='-'+sm;
normstr:=sm;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function fixstr(f:tnumero):string21;far;
var e,i:integer;
sm,se:string21;
label zlomek;
begin
if f.mode=1 then goto zlomek;

f.x:=system.int(f.x/ex[-nummode]+0.5)*ex[-nummode];

if system.abs(f.x)<1e10 then e:=0 else e:=trunc(system.ln(system.abs(f.x))/system.ln(10));
str(system.abs(f.x/ex[e]):11:11,sm);
for i:=1 to byte(sm[0]) do if sm[i]='.' then
begin sm[0]:=chr(min(byte(sm[0]),i+nummode));break;end;

if sm[byte(sm[0])]='.' then dec(sm[0]);
if f.x<0 then sm:='-'+sm;
if e=0 then begin fixstr:=sm;exit;end;
str(system.abs(e):2,se);if se[1]=' ' then se[1]:='0';
sm:=sm+#131;
if e<0 then sm:=sm+'-'else sm:=sm+'+';
fixstr:=sm+se;
exit;

zlomek:    sm:='';
if f.int<>0 then str(f.int,sm);
if f.cit<>0 then begin str(f.cit,se);
if f.int<>0 then sm:=sm+#1+se else sm:=se;
str(f.jmen,se);sm:=sm+#1+se;end;
if sm='' then begin fixstr:='0';exit;end;
if f.sign<0 then sm:='-'+sm;
fixstr:=sm;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function scistr(f:tnumero):string21;far;
var e,i:integer;
sm,se:string21;
label zlomek;
begin
if f.mode=1 then goto zlomek;

if f.x=0 then e:=0 else e:=trunc(system.ln(system.abs(f.x))/system.ln(10));
if e<0 then dec(e);
if boolean(nummode) then
f.x:=system.int(f.x/ex[e-nummode+1]+0.5)*ex[-nummode+1];
if f.x>=10 then begin f.x:=f.x/10;inc(e);end;


str(system.abs(f.x):11:11,sm);
if boolean(nummode) then
for i:=1 to byte(sm[0]) do if sm[i]='.' then
begin sm[0]:=chr(min(byte(sm[0]),i+nummode));break;end;
if boolean(nummode) then sm[0]:=char(nummode+1) else sm[0]:=#11;
if f.x<0 then sm:='-'+sm;
str(system.abs(e):2,se);if se[1]=' ' then se[1]:='0';
sm:=sm+#131;
if e<0 then sm:=sm+'-'else sm:=sm+'+';
scistr:=sm+se;
exit;
zlomek:    sm:='';
if f.int<>0 then str(f.int,sm);
if f.cit<>0 then begin str(f.cit,se);
if f.int<>0 then sm:=sm+#1+se else sm:=se;
str(f.jmen,se);sm:=sm+#1+se;end;
if sm='' then begin scistr:='0';exit;end;
if f.sign<0 then sm:='-'+sm;
scistr:=sm;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function nbasestr(f:tnumero):string21;far;
var l:longint;
i:byte;
sm:string21;
var conv:array[0..15]of char;
posun:byte;
begin
fractonum(f);conv:='0123456789ABCDEF';
if (f.x>maxlongint)or(f.x<-maxlongint-1) then begin seterror(MaERROR);exit;end;
l:=system.trunc(f.x);
if radix=10 then begin str(l,sm);nbasestr:=sm;exit;end;
case radix of
2:if (l>maxint)or(l<-maxint-1) then begin seterror(MaERROR);exit;end else posun:=1;
8:posun:=3;16:posun:=4;end;
if radix=2 then if(f.x>maxint)or(f.x<-maxint-1) then begin seterror(MaERROR);exit;end;
sm:='';
for i:=1 to 32 div posun + byte(posun=3)-16*byte(radix=2) do begin
sm:=conv[l and(radix-1)]+sm;
l:=l shr posun;
end;
nbasestr:=sm;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function zarovnej21(s:string21):string21;
var i,j:byte;
    ss:string21;
begin
ss:='';for j:=1 to 21-byte(s[0]) do ss:=ss+#32;
zarovnej21:=ss+s;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setdec;
begin
numtostr:=nbasestr;
radix:=10;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure sethex;
begin
numtostr:=nbasestr;
radix:=16;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setbin;
begin
numtostr:=nbasestr;
radix:=2;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setoct;
begin
numtostr:=nbasestr;
radix:=8;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setfix(c:word);
begin
numtostr:=fixstr;
nummode:=c;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setsci(c:word);
begin
numtostr:=scistr;
if c=0 then c:=10;
nummode:=c;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setnorm;
const norm:byte=1;
begin
if @numtostr=@normstr then norm:=3-norm else numtostr:=normstr;
nummode:=norm;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure init;
var i:integer;
begin
numtostr:=normstr;
ex[-99]:=1e-99;
for i:=-98 to 99 do ex[i]:=10*ex[i-1];
end;
begin
setdeg;
init;
end.
  tnumarr=array[0..1] of tnumero;
     tlist=record  dim:word;data:pnumarr;  end;
     tmat=record   lines,columns:byte; data:pnumarr;  end;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
(*procedure det(var r:tresult);
var w,n,i,j,k:byte;
    a,pom:tnumero;
    znova:boolean;
begin
if r.mode<>2 then begin seterror(SysERROR);exit;end;
n:=r.mat.lines;
if(n=0)or(r.mat.columns<>n)then begin seterror(DimERROR);exit;end;
for w:=0 to n*n-1 do fractonum r.Mat.data^[J+J*n])
znova:=false;
For I:=1 To n-1 do
For J:=0 To I-1 do
If not(comp.zero(r.Mat.data^[J+J*n])) then begin
a:=r.Mat.data^[J+I*n];comp.neg(a);comp.deleno(a,r.Mat.data^[J+J*n]);
{A:=-Mat[I,J]/Mat[J,J];}
For K:=0 To N-1 do begin
pom:=a;comp.krat(pom,r.Mat.data^[J*n+K]);comp.plus(r.Mat.data^[I*n+K],pom);
{Mat[I,K]:=Mat[I,K]+A*Mat[J,K]}
end;
end else znova:=true;

if znova then
for I:=n-2 downto 0 do
for J:=n-1 downto I+1 do
If not(comp.zero(r.Mat.data^[J+J*n])) then begin
a:=r.Mat.data^[J+I*n];comp.neg(a);comp.deleno(a,r.Mat.data^[J+J*n]);
{A:=-Mat[I,J]/Mat[J,J];}
For K:=0 To N do
begin
pom:=a;comp.krat(pom,r.Mat.data^[J*n+K]);comp.plus(r.Mat.data^[I*n+K],pom);
{Mat[I,K]:=Mat[I,K]+A*Mat[J,K]}
end;
end;
A:=onenum;
For I:=0 To n-1 do
comp.krat(a,r.mat.data^[I+n*I]);
free(r);r.mode:=0;r.im:=zeronum;r.re:=a;
end;*)
