{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
unit disparr;
interface
uses parser,chroust,executer;
procedure dispmat(var r:tdisp);{zobrazi seznam /matici}
procedure disptable(var r:tdisp);{zobrazi tabulku}
procedure editbuf(com:pcomm);    {prompt pro zadani cisel. hodnot}
procedure traceplot;             {graficky kursor}
implementation
uses enexecut,graf,comp,crt,font;
type string12=string[12];
{popis fontu pro zobrazeni matic}
{0..9,'.','-',E,i,+,' ',gama,leva gama,leva|,prava|,L,_I,[,]}
const minus=#11;plus=#14;expon=#12;tecka=#10;mezera=#15;
      gama=16;levagama=17;levat=18;pravat=19;level=20;pravel=21;
      levakramle=22;pravakramle=23;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function min(a,b:integer):integer;
begin
min:=a;if a>b then min:=b;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function max(a,b:integer):integer;
begin
max:=a;if a<b then max:=b;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function fstr(f:double;k:byte):string12;
var e:integer;
sm,se:string;
begin
if f=0 then e:=0 else e:=trunc(0.0001+system.ln(system.abs(f))/system.ln(10));
if(e<min(k-byte(f<0),10))and(e>-2)then e:=0;if e<0 then dec(e);
if e>-100 then f:=f/ex[e];
str(system.abs(f):0:k,sm);
while (sm[0]>#1)and(sm[byte(sm[0])]='0')do dec(sm[0]);
if sm[0]>char(k) then sm[0]:=char(k);
if sm[byte(sm[0])]='.' then dec(sm[0]);
if f<0 then begin
   if sm[0]>chr(k-1) then sm[0]:=chr(k-1);
   if sm[byte(sm[0])]='.' then dec(sm[0]);
   sm:=minus+sm;end;
if e=0 then begin fstr:=sm;exit;end;
if sm[0]>char(3-byte(e<0)) then begin
   sm[0]:=char(3-byte(e<0));
   if sm[byte(sm[0])]='.' then dec(sm[0]);
end;
str(system.abs(e):2,se);if se[1]=' ' then se[1]:='0';

if e<0 then sm:=sm+expon+minus else sm:=sm+expon;
fstr:=sm+se;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function zarovnej(s:string12;k:byte):string12;
var i,j:byte;
    ss:string12;
begin
ss:='';if k>byte(s[0])then for j:=1 to k-byte(s[0]) do ss:=ss+mezera;
for i:=1 to byte(s[0]) do
case s[i] of
'0'..'9':dec(s[i],48);
'.':s[i]:=tecka;
end;
zarovnej:=ss+s;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure prmat(x,y:word;f:double;k:byte);
var i:byte;s:string12;
begin
s:=zarovnej(fstr(f,k),k);
for i:=1 to k do mattextxy(matwinx+x+(i-1)shl 2,matwiny+y,byte(s[i]));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure prmattext(x,y:word;s:string12);
var i:byte;
begin
while s[0]<#3 do s:=#32+s;
x:=x+matwinx;inc(y,matwiny+1);
for i:=1 to byte(s[0])  do
grmattextxy(x,y,byte(s[i]));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure prmattextinv(x,y:word;s:string12);
var i:byte;
begin
x:=x+matwinx;inc(y,matwiny+1);
for i:=1 to byte(s[0]) do
invgrmattextxy(x,y,byte(s[i]));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure prnum(x,y:word;f:tnumero);
var i:byte;s:string21;
begin
s:=numtostr(f);
if s[1]='-' then s[1]:='-';
s:=zarovnej21(s);
for i:=1 to 21 do numtextxy(matwinx+x+(i-1)*6,matwiny+y,byte(s[i]));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure prinv(x,y:word;f:double;k:byte);
var i:byte;s:string12;
begin
s:=zarovnej(fstr(f,k),k);
for i:=1 to k do invmattextxy(matwinx+x+(i-1)shl 2,matwiny+y,byte(s[i]));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function getkey:word;assembler;
asm
    mov	 ah,10h
    int	 16h
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure dispmat(var r:tdisp);
var ismat:boolean;
    dimx,dimy:byte;
    data:pnumarr;
    lastx,lasty,i,j,pravax:word;
    vpravo:boolean;f:tnumero;
    pozx,pozy,selx,sely:byte;
    begin
case r.mode of
2:begin ismat:=false;dimx:=1;dimy:=r.l^.dim;data:=r.l^.data;disp.name:=0;end;
3:begin ismat:=true;dimx:=r.m^.columns;dimy:=r.m^.lines;data:=r.m^.data;end;
else begin seterror(SysERROR);exit;end;{lze volat jen na pole/matice}
end;
graf.clrmat;
matzahlavi(disp.name);
pozx:=1;pozy:=1;
selx:=0;sely:=0;
repeat
lastx:=min(dimx,pozx+3);
if ismat then for i:=pozx to lastx do prmat(20+28*(i-pozx),0,i,3);

lasty:=min(dimy,pozy+4);

vpravo:=lastx=dimx;
pravax:=12+28*(lastx-pozx+1);
for i:=pozy to lasty do
begin
prmat(0,8*(i-pozy+1),i,3);

for j:=pozx to lastx do
begin
f:=data^[(j-1)*dimy+i-1];
fractonum(f);prmat(16+28*(j-pozx),8+8*(i-pozy),f.x,6);
end;

if i=1 then if lasty=i then j:=levakramle else j:=gama
            else if dimy=i then j:=level else j:=levat;
mattextxy(matwinx+12,matwiny+8*(i-pozy+1),j);
if vpravo then begin
if i=1 then if lasty=i then j:=pravakramle else j:=levagama
            else if dimy=i then j:=pravel else j:=pravat;
mattextxy(matwinx+pravax,matwiny+8*(i-pozy+1),j);
end else mattextxy(matwinx+pravax,matwiny+8*(i-pozy+1),15);
{      gama=16;levagama=17;levat=18;pravat=19;level=20;pravel=21;
      levakramle=22;pravakramle=23;}


end;
f:=data^[(pozx+selx-1)*dimy+pozy+sely-1];
prnum(0,50,f);
fractonum(f);
prinv(16+28*selx,8+8*sely,f.x,6);
case getkey of
19936:if selx<min(dimx-pozx,3) then inc(selx) else if pozx+3<dimx then inc(pozx)
       else if sely<min(dimy-pozy,4) then begin selx:=0;pozx:=1;inc(sely);end
       else if pozy+4<dimy then begin selx:=0;pozx:=1;inc(pozy);end;

19424:if selx>0 then dec(selx) else if pozx>1 then dec(pozx) else
       if sely>0 then begin selx:=min(dimx-1,3);pozx:=dimx-selx;dec(sely);end
       else if pozy>1 then begin selx:=min(dimx-1,3);pozx:=dimx-selx;dec(pozy);end;
20704:if sely<min(dimy-pozy,4) then inc(sely) else if pozy+4<dimy then inc(pozy);
18656:if sely>0 then dec(sely) else if pozy>1 then dec(pozy);
7181:begin graf.clrmat;exit;end;
283:dispbreak;
end;
until false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure disptable(var r:tdisp);
var dimx,dimy:byte;
    lastx,lasty,i,j,pravax:word;
    vpravo:boolean;f:tnumero;
    pozx,pozy,selx,sely:byte;
    dalsi:ptable;
begin
dimy:=r.p^.dim;
dimx:=1;
dalsi:=r.p;
while dalsi^.next<>nil do begin
dalsi:=dalsi^.next;inc(dimx);
if dalsi^.dim<>dimy then begin seterror(SysERROR);exit;end;
end;

pozx:=1;pozy:=1;
selx:=0;sely:=0;
repeat
lastx:=min(dimx,pozx+3);
lasty:=min(dimy,pozy+4);
vpravo:=lastx=dimx;
pravax:=12+28*(lastx-pozx+1);
dalsi:=r.p;
graf.clrmat;
for j:=pozy to lasty do
begin
f:=dalsi^.data^[j-1];
if f.mode<2 then begin fractonum(f);prmat(16,8+8*(j-pozy),f.x,6);end
else prmattext(16,8+8*(j-pozy),' ERROR');
end;
prmattext(20,0,dalsi^.head);
for j:=pozy to lasty do
begin
if j=1 then if lasty=j then i:=levakramle else i:=gama
            else if dimy=j then i:=level else i:=levat;
mattextxy(matwinx+12,matwiny+8*(j-pozy+1),i);
if vpravo then begin
if j=1 then if lasty=j then i:=pravakramle else i:=levagama
            else if dimy=j then i:=pravel else i:=pravat;
mattextxy(matwinx+pravax,matwiny+8*(j-pozy+1),i);
end else mattextxy(matwinx+pravax,matwiny+8*(j-pozy+1),15);
end;
for i:=1 to pozx do dalsi:=dalsi^.next;
for i:=pozy to lasty do prmat(0,8*(i-pozy+1),i,3);
for j:=pozx+1 to lastx do
begin
prmattext(20+28*(j-pozx),0,dalsi^.head);
for i:=pozy to lasty do
begin
f:=dalsi^.data^[i-1];
if f.mode<2 then begin fractonum(f);prmat(16+28*(j-pozx),8+8*(i-pozy),f.x,6);end
else prmattext(16+28*(j-pozx),8+8*(i-pozy),' ERROR');
end;
dalsi:=dalsi^.next;
end;

dalsi:=r.p;for i:=2 to pozx+selx do dalsi:=dalsi^.next;
f:=dalsi^.data^[pozy+sely-1];
prnum(0,50,f);
if f.mode<2 then begin fractonum(f);prinv(16+28*selx,8+8*sely,f.x,6);end
else prmattextinv(16+28*selx,8+8*sely,' ERROR');

case getkey of
19936:if selx<min(dimx-pozx,3) then inc(selx) else if pozx+3<dimx then inc(pozx)
       else if sely<min(dimy-pozy,4) then begin selx:=0;pozx:=1;inc(sely);end
       else if pozy+4<dimy then begin selx:=0;pozx:=1;inc(pozy);end;
19424:if selx>0 then dec(selx) else if pozx>1 then dec(pozx) else
       if sely>0 then begin selx:=min(dimx-1,3);pozx:=dimx-selx;dec(sely);end
       else if pozy>1 then begin selx:=min(dimx-1,3);pozx:=dimx-selx;dec(pozy);end;
20704:if sely<min(dimy-pozy,4) then inc(sely) else if pozy+4<dimy then inc(pozy);
18656:if sely>0 then dec(sely) else if pozy>1 then dec(pozy);
7181:begin graf.clrmat;exit;end;
283:dispbreak;
end;
until false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure updatecoord;
var i:byte;s:string12;
    w:word;
begin
w:=1;
grtextxy(w,58,byte('X'));grtextxy(w,58,byte('='));
s:=zarovnej(fstr(graf.getx(0),12),0);inc(w);
for i:=1 to byte(s[0])do coordxy(w+(i-1)shl 2,58,byte(s[i]));
w:=65;
grtextxy(w,58,byte('Y'));grtextxy(w,58,byte('='));inc(w);
s:=zarovnej(fstr(graf.gety(0),12),0);
for i:=1 to byte(s[0])do coordxy(w+(i-1)shl 2,58,byte(s[i]));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure traceplot;
var p:ppict;
    w:word;
x:byte absolute graf.lx;
y:byte absolute graf.ly;
begin
undoplot;
if graf.coordon then begin new(p);storepict(p);end;
repeat
if graf.coordon then begin graf.putpict(p);updatecoord;end;
graf.traceplot(x,y);
w:=getkey;
graf.traceplot(x,y);
case w of
19936:if x<127 then inc(x);
19424:if x>1   then dec(x);
20704:if y>1   then dec(y);
18656:if y<63  then inc(y);
283  :begin fertig:=true;totalfertig:=true;w:=7181;end;
end;
until w=7181;
if coordon then begin graf.putpict(p);dispose(p);end;
with variables^[23] do begin
im:=zeronum;re.x:=0;re.x:=getx(x);
end;
with variables^[24] do begin
im:=zeronum;re.x:=0;re.x:=gety(y);
end;
redoplot;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function gettok:byte;
var ch:char;c:byte;
begin c:=0;
repeat
repeat
ch:=readkey;while  ch=#0 do begin readkey;ch:=readkey;end;
until ch in [#8,#13,'[',']','{','}','(',')',',','^','.',
             #48..#57,#65..#90,'e','p','+','-','*','/'];
case ch of
'e':c:=15;
'p':c:=208;
'+':c:=137;
'-':c:=153;
'*':c:=169;
'/':c:=185;
#13:c:=255;
'^':c:=168;
else c:=byte(ch);
end;
until c<>0;
gettok:=c;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure editbuf(com:pcomm);
var poz,i,c:word;
begin
I:=0;
repeat
c:=gettok;
if c<>8 then begin
 if(c=255)then if(i<>0)then begin comm^[i]:=c;tx:=500;exit;end else continue;
   if i<20 then begin comm^[i]:=c;inc(i);textln(byte(znak[c,1]));end;
   end else if i<>0 then begin
   dec(tx,6);textln(32);dec(tx,6);dec(i);end;
until false;
end;
end.
