{$A+,B-,D+,E+,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
unit enexecut;
interface
uses chroust;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
type tlooprec=record                    {zasobnik pro cykly}
              poz:word;                 {efektivni zacatek cyklu}
              looptype:byte;            {typ:for/while/do}
              end;
     tloopstack=array[byte] of tlooprec;
     ploopstack=^tloopstack;
     tifstack=array[0..1023] of byte;  {zasobnik pro ify}
     pifstack=^tifstack;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
var loopstack:ploopstack;
    lspoz:byte;
    ifstack:pifstack;
    ifspoz:word;
const
     tbvarrange:boolean=true;{zdroj poc. hodnot pro tabulky}
     tblist:plist=nil;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setPLorange;
procedure setPLBlue;
procedure setPLGreen;
procedure doOrangeG;
procedure doBlueG;
procedure doGreenG;
procedure mulrow;
procedure mulrowplus;
procedure rowplus;
procedure Swap;
procedure fill;
procedure doif;
procedure doElse;
procedure Ifend;
procedure doFor;
procedure Next;
procedure doWhile;
procedure WhileEnd;
procedure doDo;
procedure LpWhile;
procedure Return;
procedure dobreak;
procedure Stop;
procedure Locate;
procedure Send;
procedure Receive;
procedure ClrText;
procedure ClrGraph;
procedure ClrList;
procedure DrawDyna;
procedure DrawStat;
procedure DrawFTGCon;
procedure DrawFTGPlt;
procedure DrawRCon;
procedure DrawRPlt;
procedure DrawRSumCon;
procedure DrawRSumPlt;
procedure DrawWeb;
procedure DispFTbl;
procedure DispRTbl;
procedure AutoSimp;
procedure ManSimp;
procedure Variable1;
procedure Variable2;
procedure SGph1;
procedure SGph2;
procedure SGph3;
procedure SWindAuto;
procedure SWindMan;
procedure selgraphType;
procedure GConnect;
procedure GPlot;
procedure DualGraph;
procedure DualGtoT;
procedure DualTG;
procedure DualOff;
procedure BGNone;
procedure BGPict;
procedure GridOff;
procedure GridDot;
procedure GridLine;
procedure GridOn;
procedure Dvar;
procedure NrmSpeed;
procedure FastSpeed;
procedure SlowSpeed;
procedure StopGo;
procedure DynaCon;
procedure DynaStop;
procedure VarRange;
procedure Simul;
procedure Poly;
procedure anType;
procedure an1Type;
procedure an2Type;
procedure StoPict;
procedure RclPict;
procedure StoGMEM;
procedure RclGMEM;
procedure StoVWin;
procedure RclVWin;
procedure Tangent;
procedure Normal;
procedure Inverse;
procedure Vertical;
procedure Horizontal;
procedure Text;
procedure Circle;
procedure FLine;
procedure PlotOn;
procedure PlotOff;
procedure PlotChg;
procedure PxlOn;
procedure PxlOff;
procedure PxlChg;
procedure PxlLine;
procedure PxlTest;
procedure SortA;
procedure SortD;
procedure VarList;
procedure setFile;
procedure FuncOn;
procedure SimulOn;
procedure AxesOn;
procedure CoordOn;
procedure LabelOn;
procedure DerivOn;
procedure LocusOn;
procedure sumdispOn;
procedure GSelOn;
procedure TSelOn;
procedure DSelOn;
procedure RSelOn;
procedure DrawOn;
procedure FuncOff;
procedure SimulOff;
procedure AxesOff;
procedure CoordOff;
procedure LabelOff;
procedure DerivOff;
procedure LocusOff;
procedure sumdispOff;
procedure GSelOff;
procedure TSelOff;
procedure DSelOff;
procedure RSelOff;
procedure DrawOff;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
const {cyklove tokeny}
cif     =512;
cthen   =513;
celse   =514;
cifend  =515;
cfor    =516;
cforto  =517;
cstep   =518;
cnext   =519;
cwhile  =520;
cwhend  =521;
cdo     =522;
clpwhile=523;

implementation
uses crt,font,comp,parser,graf,executer;
const dynavar:pvar=nil;
      dynadelay:word=500;
      dyna10:boolean=true;
type tvwin=array[0..5]of array[0..8] of double;
var vwindata:tvwin;
var stographvars:array[0..5]of array[0..29]of tgrvar;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure cleartable(var t:ptable);
var p:ptable;
begin
while t<>nil do begin
p:=t;
t:=t^.next;
oldnumero(p^.data,p^.dim);
freememory(p,sizeof(ttable));
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure newtable(var t:ptable;dim:word);
begin
getmemory(t,sizeof(ttable));
if boolean(error)then exit;
t^.next:=nil;
t^.dim:=0;
newnumero(t^.data,dim);
if boolean(error)then exit;
t^.dim:=dim;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setPLorange;
begin
testend;
plcolor:=graf.corange;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setPLBlue;
begin
testend;
plcolor:=graf.cblue;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setPLGreen;
begin
testend;
plcolor:=graf.cgreen;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure doOrangeG;
var i:word;
begin
getcom;
i:=trunc(nnumber(10));testend;
if(i<1)or(i>30)then seterror(SynERROR);
if not boolean(error)then graphvars[i-1].color:=graf.corange;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure doBlueG;
var i:word;
begin
getcom;
i:=trunc(nnumber(10));testend;
if(i<1)or(i>30)then seterror(SynERROR);
if not boolean(error)then graphvars[i-1].color:=graf.cblue;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure doGreenG;
var i:word;
begin
getcom;
i:=trunc(nnumber(10));testend;
if(i<1)or(i>30)then seterror(SynERROR);
if not boolean(error)then graphvars[i-1].color:=graf.cgreen;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure mulrow;
var m,r:word;
t:tnumero;
begin
getcom;
getnumero(t);
if getcom<>byte(',')then seterror(SynERROR);
if boolean(error)then exit;
m:=getcom;
case m of
65..90:dec(m,64);
cans:m:=0;
else begin seterror(SynERROR);exit;end;
end;
if getcom<>byte(',')then seterror(SynERROR);
r:=intparam;testend;
if boolean(error)then exit;
chroust.mulrow(@matrix[m],t,r);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure mulrowplus;
var m,r1,r2:word;
t:tnumero;
begin
getcom;
getnumero(t);
if getcom<>byte(',')then seterror(SynERROR);
if boolean(error)then exit;
m:=getcom;
case m of
65..90:dec(m,64);
cans:m:=0;
else begin seterror(SynERROR);exit;end;
end;
if getcom<>byte(',')then seterror(SynERROR);
r1:=intparam;
if getcom<>byte(',')then seterror(SynERROR);
r2:=intparam;testend;
if boolean(error)then exit;
chroust.mulrowplus(@matrix[m],t,r1,r2);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure rowplus;
var m,r1,r2:word;
begin
getcom;
m:=getcom;
case m of
65..90:dec(m,64);
cans:m:=0;
else begin seterror(SynERROR);exit;end;
end;
if getcom<>byte(',')then seterror(SynERROR);
r1:=intparam;
if getcom<>byte(',')then seterror(SynERROR);
r2:=intparam;testend;
if boolean(error)then exit;
chroust.plusrow(@matrix[m],r1,r2);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Swap;
var m,r1,r2:word;
begin
getcom;
m:=getcom;
case m of
65..90:dec(m,64);
cans:m:=0;
else begin seterror(SynERROR);exit;end;
end;
if getcom<>byte(',')then seterror(SynERROR);
r1:=intparam;
if getcom<>byte(',')then seterror(SynERROR);
r2:=intparam;testend;
if boolean(error)then exit;
chroust.swap(@matrix[m],r1,r2);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure fill;
var r:tresult;
c:word;
begin
getcom;parse13(r);
if getcom<>byte(',')then begin seterror(SynERROR);exit;end;
case testcom of
cmat:begin getcom;c:=getcom;
           if(c<65)or(c>90)then begin seterror(SynERROR);exit;end;
           fillm(matrix[c-64],r);
      end;
clist:begin getcom;c:=getcom;
           if(c<49)or(c>54)then begin seterror(SynERROR);exit;end;
           filll(lists^[c-49],r);
      end;
49..54:filll(lists^[getcom-49],r);
else seterror(ArgERROR);
end;
if testcom=byte(')')then getcom;
testend;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure skip(cin,cout:word;nakonci:boolean);
label st,nc,vp,ok,okp;
var vnoreni,c:word;
begin
vnoreni:=1;
goto nc;
st:c:=getcomnorm;
   case c of
   12,13,58  :goto nc;
   255       :goto okp;
   byte('"') :goto vp;
   else goto st;
   end;

nc:c:=getcomnorm;
   if c=cout then begin dec(vnoreni);if not nakonci then testend;
             if vnoreni=0 then goto ok;goto nc;end;
   if c=cin then begin inc(vnoreni);goto st;end;
   case c of
   12,13,58  :goto nc;
   255       :goto okp;
   byte('"') :goto vp;
   else goto st;
   end;

vp:c:=getcomnorm;
   case c of
   255       :goto okp;
   byte('"') :goto st;
   else goto vp;
   end;

okp:fertig:=true;exit;
ok:if nakonci then while (c or 1<>13)and(c<>58) do c:=getcomnorm;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function skipif:boolean;
label st,nc,vp,ok,okp;
var vnoreni,c:word;
begin
vnoreni:=0;skipif:=false;
goto nc;
st:c:=getcomnorm;
   case c of
   12,13,58  :goto nc;
   255       :goto okp;
   byte('"') :goto vp;
   else goto st;
   end;

nc:c:=getcomnorm;
   case c of
   12,13,58  :goto nc;
   255       :goto okp;
   cif       :begin inc(vnoreni);goto st;end;
   cthen     :goto nc;
   celse     :if vnoreni=0 then goto ok else goto nc;
   cifend    :begin
              if vnoreni=0 then begin testend;skipif:=true;exit;end;
              dec(vnoreni);goto nc;end;
   byte('"') :goto vp;
   else goto st;
   end;

vp:c:=getcomnorm;
   case c of
   255       :goto okp;
   byte('"') :goto st;
   else goto vp;
   end;

okp:fertig:=true;exit;
ok:
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure doif;       {if je paskalske klicove slovo }
var p:double;
    c:word;
begin
getcom;
if ifspoz=1023 then begin seterror(MemERROR);exit;end;
p:=param;c:=getcom;
if(c or 1<>13)and(c<>58)then seterror(SynERROR);
if getcom<>cthen then seterror(SynERROR);
if boolean(error)then exit;
if p<>0 then begin
ifstack^[ifspoz]:=1;inc(ifspoz);
exit;
end;
ifstack^[ifspoz]:=8;
if not skipif then inc(ifspoz);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure doElse;
begin
getcom;if ifspoz=0 then begin seterror(SynERROR);
exit;end;
if ifstack^[ifspoz-1]=8 then begin seterror(SynERROR);
exit;end;
if not skipif then begin seterror(SynERROR);
exit;end;
dec(ifspoz);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Ifend;
begin
getcom;testend;
if ifspoz=0 then begin
seterror(SynERROR);
exit;end;
dec(ifspoz);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure doFor;
var start,cil,krok:double;
c:word;
begin
getcom;
start:=param;
if getcom<>cto then begin seterror(SynERROR);exit;end;
if lspoz=255 then begin seterror(MemERROR);exit;end;
loopstack^[lspoz].poz:=poz;loopstack^[lspoz].looptype:=1;inc(lspoz);
c:=getcom;
case c of
byte('A')..byte('Z'):with variables^[c-65] do begin
                     re.mode:=0;re.x:=start;
                     im.mode:=0;im.x:=0;
                     end;
cr:with varr do begin
                     re.mode:=0;re.x:=start;
                     im.mode:=0;im.x:=0;
                end;
cfi:with varfi do begin
                     re.mode:=0;re.x:=start;
                     im.mode:=0;im.x:=0;
                  end;
else begin seterror(SynERROR);exit;end;
end;
if getcom<>cforto then begin seterror(SynERROR);exit;end;
cil:=param;krok:=1;
if testcom=cstep then begin getcom;krok:=param;
   if krok=0 then begin seterror(ArgERROR);exit;end;end;
testend;
if (cil-start)*krok>=0 then exit;

skip(cfor,cnext,false);
dec(lspoz);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Next;
var start,cil,krok:double;
oldpoz,c:word;
count:pvar;
begin
getcom;testend;
if lspoz=0 then begin seterror(SynERROR);exit;end;
if loopstack^[lspoz-1].looptype<>1 then begin seterror(SynERROR);exit;end;
oldpoz:=poz;poz:=loopstack^[lspoz-1].poz;

c:=getcom;
case c of
byte('A')..byte('Z'):count:=@variables^[c-65];
cr:count:=@varr;
cfi:count :=@varfi;
else begin seterror(SynERROR);exit;end;
end;

if getcom<>cforto then begin seterror(SynERROR);exit;end;
cil:=param;krok:=1;
if testcom=cstep then begin getcom;krok:=param;
   if krok=0 then begin seterror(ArgERROR);exit;end;end;
testend;
with count^ do begin
  fractonum(re);fractonum(im);
  if im.x<>0 then begin poz:=oldpoz;seterror(SynERROR);exit;end;
start:=re.x+krok;
if (cil-start)*krok>-1e-10 then begin re.x:=start;fertig:=false;end
                       else begin dec(lspoz);poz:=oldpoz;end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure doWhile;
var x:double;
    p,c:word;
begin
getcom;p:=poz;
x:=param;
testend;
if x<>0 then
begin
 if lspoz=255 then begin seterror(MemERROR);exit;end;
 loopstack^[lspoz].poz:=p;loopstack^[lspoz].looptype:=2;inc(lspoz);end
else skip(cwhile,cwhend,false);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure WhileEnd;
var x:double;
oldpoz:word;
begin
getcom;testend;
if lspoz=0 then begin seterror(SynERROR);exit;end;
if loopstack^[lspoz-1].looptype<>2 then begin seterror(SynERROR);exit;end;
oldpoz:=poz;poz:=loopstack^[lspoz-1].poz;
x:=param;
if x<>0 then begin fertig:=false;testend;exit;end;
dec(lspoz);
poz:=oldpoz;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure doDo;
begin
getcom;testend;
 if lspoz=255 then begin seterror(MemERROR);exit;end;
 loopstack^[lspoz].poz:=poz;loopstack^[lspoz].looptype:=3;inc(lspoz);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure LpWhile;
var x:double;
begin
getcom;
x:=param;
testend;
if lspoz=0 then begin seterror(SynERROR);exit;end;
if loopstack^[lspoz-1].looptype<>3 then begin seterror(SynERROR);exit;end;
if x<>0 then
begin poz:=loopstack^[lspoz-1].poz;fertig:=false;end
else
dec(lspoz);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Return;
begin
if lspoz>0 then seterror(SynERROR) else fertig:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure dobreak;
begin
getcom;testend;if boolean(error) then exit;
if lspoz=0 then begin seterror(SynERROR);exit;end;
dec(lspoz);
case loopstack^[lspoz].looptype of
1:skip(cfor,cnext,false);
2:skip(cwhile,cwhend,false);
3:skip(cdo,clpwhile,true);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Stop;
begin
fertig:=true;totalfertig:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Locate;
var xx:double;
    t:tnumero;
    x,y,c,i:word;
    s:string21;
begin
getcom;
xx:=param;
if getcom<>byte(',') then seterror(SynERROR);
xx:=system.int(xx+0.002);
if(xx<1)or(xx>21)then seterror(ArgERROR);
if boolean(error) then exit;
x:=round(xx);
xx:=param;
if getcom<>byte(',') then seterror(SynERROR);
xx:=system.int(xx+0.002);
if(xx<1)or(xx>7)then seterror(ArgERROR);
if boolean(error) then exit;
y:=round(xx);
if testcom<>byte('"')then begin
getnumero(t);testend;if boolean(error) then exit;
s:=numtostr(t);dec(x);
for i:=1 to byte(s[0])do textxy(x+i,y,byte(s[i]));
exit;
end;
getcom;
while (testcom<>byte('"'))and(testcom<>13)and(testcom<>255) do
begin c:=getcom;
for i:=1 to byte(font.znak[c,0]) do
begin textxy(x,y,byte(font.znak[c,i]));inc(x);end;
end;
if testcom=byte('"') then getcom;
testend;

end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Send;
begin
getcom;
seterror(ComERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Receive;
begin
getcom;
seterror(ComERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure ClrText;
begin
getcom;testend;
graf.clrtext;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure ClrGraph;
begin
getcom;testend;
graf.cls;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure ClrList;
var i:byte;
begin
getcom;testend;
for i:=0 to 5 do
begin oldnumero(lists^[i].data,lists^[i].dim);end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DrawDyna;
var pict:array[0..15]of ppict;
i,j,k:byte;
c:char;
label padla;
begin
getcom;testend;if boolean(error)then exit;
if dpitch=0 then begin seterror(MaERROR);exit;end;
if(dend-dstart)/dpitch<0 then dpitch:=-dpitch;
if trunc((dend-dstart)/dpitch)>15 then begin seterror(MaERROR);exit;end;
i:=trunc((dend-dstart)/dpitch);
dynavar^.im:=zeronum;
dynavar^.re.mode:=0;
dynavar^.re.x:=dstart;
for j:=0 to i do begin
if maxavail<128*64 then begin seterror(MemERROR);exit;end;
getmemory(pict[j],128*64);if boolean(error)then exit;
kresligrafy(4);if boolean(error) then exit;
graf.storepict(pict[j]);
dynavar^.re.x:=dynavar^.re.x+dpitch;
end;
repeat
for k:=0 to 9 do
begin
for j:=0 to i do
begin
graf.putpict(pict[j]);
if dynadelay<>0 then
begin if keypressed then if readkey=#27 then goto padla;delay(dynadelay);end
 else repeat c:=readkey;if c=#27 then goto padla;until c=#13;
end;
for j:=i downto 0 do
begin
graf.putpict(pict[j]);
if dynadelay<>0 then begin if keypressed then if readkey=#27 then goto padla;delay(dynadelay);end
else repeat c:=readkey;if c=#27 then goto padla;until c=#13;
end;
end;
until dyna10;
padla:
for j:=0 to i do freememory(pict[j],128*64);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DrawStat;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DrawFTGCon;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DrawFTGPlt;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DrawRCon;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DrawRPlt;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DrawRSumCon;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DrawRSumPlt;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DrawWeb;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure zaklad(var t:ptable;start,cil,krok:double);
var d:double;
    i:byte;
begin
cleartable(t);
d:=(cil-start)/krok;
if d<0 then begin d:=-d;krok:=-krok;end;
if d>=255 then begin seterror(DimERROR);exit;end;
i:=trunc(d)+1;
newtable(t,i);
if boolean(error) then exit;

for i:=0 to t^.dim-1 do begin
  t^.data^[i].mode:=0;t^.data^[i].x:=start;start:=start+krok;end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure listzaklad(var t:ptable);
var i:byte;
begin
cleartable(t);
newtable(t,tblist^.dim);
if boolean(error) then exit;
for i:=0 to t^.dim-1 do t^.data^[i]:=tblist^.data^[i];
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure tbderiv(var t:tnumero;v:pvar;poz:word);
var r:tresult;
start,krok:tnumero;
begin
grapherror:=false;
start:=v^.re;
krok:=start;fractonum(krok);if zero(krok) then krok.x:=1e-12 else krok.x:=krok.x*1e-10;
zderivuj(r,v,start,krok,poz);
if grapherror then t.mode:=2 else t:=r.re;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure ysloupec(var t:ptable;i:byte);
var tt,tderiv:ptable;
    h:string[2];
    num:tnumero;
    r:tresult;
begin
newtable(tt,t^.dim);
if boolean(error)then exit;
t^.next:=tt;t:=tt;
str(i+1,h);
tt^.head:='Y'+h;
if graf.derivon then begin
 newtable(tderiv,t^.dim);
 if boolean(error)then exit;
 t^.next:=tderiv;t:=tderiv;
 tderiv^.head:=tt^.head+'''';
end;
comm:=graphvars[i].data;
variables^[23].im:=zeronum;
for i:=0 to ftable^.dim-1 do begin
poz:=0;
variables^[23].re:=ftable^.data^[i];
grapherror:=false;
getnumero(num);
if grapherror then num.mode:=2;
tt^.data^[i]:=num;
if graf.derivon then begin
tbderiv(num,@variables^[23],0);
tderiv^.data^[i]:=num;
end;
if boolean(error) then exit;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure rsloupec(var t:ptable;i:byte);
var tt,tderiv:ptable;
    h:string[2];
    num:tnumero;
    r:tresult;
begin
newtable(tt,t^.dim);
if boolean(error)then exit;
t^.next:=tt;t:=tt;
str(i+1,h);
tt^.head:='r'+h;
if graf.derivon then begin
 newtable(tderiv,t^.dim);
 if boolean(error)then exit;
 t^.next:=tderiv;t:=tderiv;
 tderiv^.head:=tt^.head+'''';
end;
comm:=graphvars[i].data;
varfi.im:=zeronum;
for i:=0 to ftable^.dim-1 do begin
poz:=0;
varfi.re:=ftable^.data^[i];
grapherror:=false;
getnumero(num);
if grapherror then num.mode:=2;
tt^.data^[i]:=num;
if graf.derivon then begin
tbderiv(num,@varfi,0);
tderiv^.data^[i]:=num;
end;
if boolean(error) then exit;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure paramsloupec(var t:ptable;i:byte);
var tx,ty,tdx,tdy,tdxy:ptable;
    h:string[2];
    num:tnumero;
    r:tresult;
begin
newtable(tx,t^.dim);
if boolean(error)then exit;
t^.next:=tx;t:=tx;
newtable(ty,t^.dim);
if boolean(error)then exit;
t^.next:=ty;t:=ty;
str(i+1,h);
tx^.head:='Xt'+h;
ty^.head:='Yt'+h;

if graf.derivon then begin
 newtable(tdx,t^.dim);
 if boolean(error)then exit;
 t^.next:=tdx;t:=tdx;
 tdx^.head:=tx^.head+'''';
 newtable(tdy,t^.dim);
 if boolean(error)then exit;
 t^.next:=tdy;t:=tdy;
 tdy^.head:=ty^.head+'''';
 newtable(tdxy,t^.dim);
 if boolean(error)then exit;
 t^.next:=tdxy;t:=tdxy;
 tdxy^.head:='dY/dX';
end;
comm:=graphvars[i].data;
variables^[19].im:=zeronum;
for i:=0 to ftable^.dim-1 do begin
poz:=0;
variables^[19].re:=ftable^.data^[i];
grapherror:=false;
getnumero(num);
if grapherror then num.mode:=2;
tx^.data^[i]:=num;
if getcom<>246 then begin seterror(SynERROR);exit;end;

grapherror:=false;
getnumero(num);
if grapherror then num.mode:=2;
ty^.data^[i]:=num;

if graf.derivon then begin
tbderiv(num,@variables^[19],0);
tdx^.data^[i]:=num;getcom;
tbderiv(num,@variables^[19],poz);
tdy^.data^[i]:=num;
if(tdx^.data^[i].mode=2)or(num.mode=2)then tdxy^.data^[i].mode:=2 else
begin
 comp.deleno(num,tdx^.data^[i]);
 if grapherror then tdxy^.data^[i].mode:=2 else tdxy^.data^[i]:=num;
end;
end;
if boolean(error) then exit;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{grtype+611:- cYtype=611;crtype=612;cParamType=613;cXcType=615;
cYvType=618;cYmType=619;cYvrType=620;cYmrType=621;}
procedure DispFTbl;
var oldpoz:word;
    oldcomm:pcomm;
    t:ptable;
begin
getcom;testend;oldpoz:=poz;oldcomm:=comm;
if boolean(error) then exit;
if tbvarrange then zaklad(ftable,fstart,fend,fpitch)else listzaklad(ftable);
case graphtype of
1:ftable^.head:='';
2:ftable^.head:='T';
else ftable^.head:='X';
end;
graphmode:=true;t:=ftable;

for i:=0 to 29 do
with graphvars[i] do
if(selected and 2<>0)and(size<>0)then begin
comm:=data;
case graphtype of
1: if grtype=1 then rsloupec(t,i);
2: if grtype=2 then paramsloupec(t,i);
else case grtype of 0,3,7,8,9,10:ysloupec(t,i);end;
end;
if boolean(error)then exit;
end;

graphmode:=false;
disp.mode:=6;
disp.p:=ftable;
poz:=oldpoz;
comm:=oldcomm;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DispRTbl;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure AutoSimp;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure ManSimp;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Variable1;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Variable2;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure SGph1;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure SGph2;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure SGph3;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure SWindAuto;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure SWindMan;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure selgraphtype;
begin
graphtype:=getcom-611;testend;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure GConnect;
begin
getcom;testend;
graf.connect:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure GPlot;
begin
getcom;testend;
graf.connect:=false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DualGraph;
begin
getcom;testend;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DualGtoT;
begin
getcom;testend;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DualTG;
begin
getcom;testend;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DualOff;
begin
getcom;testend;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure BGNone;
begin
getcom;testend;background:=0;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure BGPict;
var c:word;
begin
getcom;c:=getcom;testend;
if(c<49)or(c>54)then seterror(SynERROR)else background:=c-48;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure GridOff;
begin
getcom;
testend;
graf.gridon:=false;
graf.cls;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure GridDot;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure GridLine;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure GridOn;
begin
getcom;
testend;
graf.gridon:=true;
graf.cls;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Dvar;
var i:word;
begin
getcom;i:=getcom;
case i of
65..90:dynavar:=@variables^[i-65];
cr:dynavar:=@varr;
cfi:dynavar:=@varfi;
else begin seterror(SynERROR);exit;end;
end;
testend;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure NrmSpeed;
begin
getcom;testend;
dynadelay:=500;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure FastSpeed;
begin
getcom;testend;
dynadelay:=250;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure SlowSpeed;
begin
getcom;testend;
dynadelay:=1000;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure StopGo;
begin
getcom;testend;
dynadelay:=0;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DynaCon;
begin
getcom;testend;
dyna10:=false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DynaStop;
begin
getcom;testend;
dyna10:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure VarRange;
begin
getcom;
testend;
tbvarrange:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Simul;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Poly;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure anType;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure an1Type;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure an2Type;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure StoPict;
var c:word;
begin
getcom;
c:=getcom;if(c<49)or(c>54)then begin seterror(ArgERROR);exit;end;
testend;
c:=c-49;
if pictures[c]=nil then new(pictures[c]);
graf.storepict(pictures[c]);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure RclPict;
var c:word;
begin
getcom;
c:=getcom;if(c<49)or(c>54)then begin seterror(ArgERROR);exit;end;
testend;
c:=c-49;
if pictures[c]=nil then exit;
graf.rclpict(pictures[c]);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure StoGMEM;
var c:word;
i,j:integer;
begin
getcom;
c:=getcom;if(c<49)or(c>54)then begin seterror(ArgERROR);exit;end;
testend;
c:=c-49;
for i:=0 to 29 do begin
freememory(stographvars[c,i].data,stographvars[c,i].size);
stographvars[c,i]:=graphvars[i];
getmemory(stographvars[c,i].data,stographvars[c,i].size);if boolean(error)then exit;
for j:=0 to graphvars[i].size-1 do
stographvars[c,i].data^[j]:=graphvars[i].data^[j];
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure RclGMEM;
var c:word;
i,j:integer;
begin
getcom;
c:=getcom;if(c<49)or(c>54)then begin seterror(ArgERROR);exit;end;
testend;
c:=c-49;
for i:=0 to 29 do begin
if stographvars[c,i].size=0 then continue;
freememory(graphvars[i].data,graphvars[i].size);
graphvars[i]:=stographvars[c,i];
getmemory(graphvars[i].data,graphvars[i].size);if boolean(error)then exit;
for j:=0 to graphvars[i].size-1 do
graphvars[i].data^[j]:=stographvars[c,i].data^[j];
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure StoVWin;
var c:word;
begin
getcom;
c:=getcom;if(c<49)or(c>54)then begin seterror(ArgERROR);exit;end;
testend;
c:=c-49;
vwindata[c,0]:=graf.xmin;
vwindata[c,1]:=graf.xmax;
vwindata[c,2]:=graf.xscl;
vwindata[c,3]:=graf.ymin;
vwindata[c,4]:=graf.ymax;
vwindata[c,5]:=graf.yscl;
vwindata[c,6]:=graf.tmin;
vwindata[c,7]:=graf.tmax;
vwindata[c,8]:=graf.tptch;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure RclVWin;
var c:word;
begin
getcom;
c:=getcom;if(c<49)or(c>54)then begin seterror(ArgERROR);exit;end;
testend;
c:=c-49;
graf.xmin:=vwindata[c,0];
graf.xmax:=vwindata[c,1];
graf.xscl:=vwindata[c,2];
graf.ymin:=vwindata[c,3];
graf.ymax:=vwindata[c,4];
graf.yscl:=vwindata[c,5];
graf.tmin:=vwindata[c,6];
graf.tmax:=vwindata[c,7];
graf.tptch:=vwindata[c,8];
graf.cls;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Tangent;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Normal;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Inverse;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Vertical;
var x:double;
begin
getcom;
x:=param;
testend;
if boolean(error) then exit;
graf.vertical(x);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Horizontal;
var x:double;
begin
getcom;
x:=param;
testend;
if boolean(error) then exit;
graf.horisontal(x);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Text;
var xx:double;
    t:tnumero;
    x,y,c,i:word;
    s:string21;
begin
getcom;
xx:=param;
if getcom<>byte(',') then seterror(SynERROR);
xx:=system.int(xx);
if(xx<1)or(xx>63)then seterror(ArgERROR);
if boolean(error) then exit;
y:=round(xx);
xx:=param;
if getcom<>byte(',') then seterror(SynERROR);
xx:=system.int(xx);
if(xx<1)or(xx>127)then seterror(ArgERROR);
if boolean(error) then exit;
x:=round(xx);
if testcom<>byte('"')then begin
getnumero(t);testend;if boolean(error) then exit;
s:=numtostr(t);
for i:=1 to byte(s[0])do grtextxy(x,y,byte(s[i]));
exit;
end;
getcom;
while (testcom<>byte('"'))and(testcom<>13)and(testcom<>255) do
begin c:=getcom;
for i:=1 to byte(font.znak[c,0]) do grtextxy(x,y,byte(font.znak[c,i]));
end;
if testcom=byte('"') then getcom;
testend;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Circle;
var x,y,r:double;
begin
getcom;
x:=param;
if getcom<>byte(',') then seterror(SynERROR);
if boolean(error) then exit;
y:=param;
if getcom<>byte(',') then seterror(SynERROR);
if boolean(error) then exit;
r:=param;
testend;
if boolean(error) then exit;
graf.circle(x,y,r);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure FLine;
var x,y,xx,yy:double;
begin
getcom;
x:=param;
if getcom<>byte(',') then seterror(SynERROR);
if boolean(error) then exit;
y:=param;
if getcom<>byte(',') then seterror(SynERROR);
if boolean(error) then exit;
xx:=param;
if getcom<>byte(',') then seterror(SynERROR);
if boolean(error) then exit;
yy:=param;
testend;
if boolean(error) then exit;
graf.fline(x,y,xx,yy);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure PlotOn;
var x,y:double;
begin
getcom;
x:=param;
if getcom<>byte(',') then seterror(SynERROR);
if boolean(error) then exit;
y:=param;
testend;
if boolean(error) then exit;
if graf.ploton(x,y) then begin
with variables^[23] do begin
im:=zeronum;re.x:=0;re.x:=x;
end;
with variables^[24] do begin
im:=zeronum;re.x:=0;re.x:=y;
end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure PlotOff;
var x,y:double;
begin
getcom;
x:=param;
if getcom<>byte(',') then seterror(SynERROR);
if boolean(error) then exit;
y:=param;
testend;
if boolean(error) then exit;
if graf.plotoff(x,y) then begin
with variables^[23] do begin
im:=zeronum;re.x:=0;re.x:=x;
end;
with variables^[24] do begin
im:=zeronum;re.x:=0;re.x:=y;
end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure PlotChg;
var x,y:double;
begin
getcom;
x:=param;
if getcom<>byte(',') then seterror(SynERROR);
if boolean(error) then exit;
y:=param;
testend;
if boolean(error) then exit;
if graf.plotchg(x,y) then begin
with variables^[23] do begin
im:=zeronum;re.x:=0;re.x:=x;
end;
with variables^[24] do begin
im:=zeronum;re.x:=0;re.x:=y;
end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure PxlOn;
var x,y:integer;
begin
getcom;
y:=intparam;
if getcom<>byte(',') then seterror(SynERROR);
if(y<1)or(y>63)then seterror(ArgERROR);
if boolean(error) then exit;
x:=intparam;
if(x<1)or(x>127)then seterror(ArgERROR);
testend;
if boolean(error) then exit;
graf.pixon(x,y);
with variables^[23] do begin
im:=zeronum;re.x:=0;re.x:=getx(x);
end;
with variables^[24] do begin
im:=zeronum;re.x:=0;re.x:=gety(y);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure PxlOff;
var x,y:integer;
begin
getcom;
y:=intparam;
if getcom<>byte(',') then seterror(SynERROR);
if(y<1)or(y>63)then seterror(ArgERROR);
if boolean(error) then exit;
x:=intparam;
if(x<1)or(x>127)then seterror(ArgERROR);
testend;
if boolean(error) then exit;
graf.pixoff(x,y);
with variables^[23] do begin
im:=zeronum;re.x:=0;re.x:=getx(x);
end;
with variables^[24] do begin
im:=zeronum;re.x:=0;re.x:=gety(y);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure PxlChg;
var x,y:integer;
begin
getcom;
y:=intparam;
if getcom<>byte(',') then seterror(SynERROR);
if(y<1)or(y>63)then seterror(ArgERROR);
if boolean(error) then exit;
x:=intparam;
if(x<1)or(x>127)then seterror(ArgERROR);
testend;
if boolean(error) then exit;
graf.pixchg(x,y);
with variables^[23] do begin
im:=zeronum;re.x:=0;re.x:=getx(x);
end;
with variables^[24] do begin
im:=zeronum;re.x:=0;re.x:=gety(y);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure PxlLine;
begin
getcom;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure PxlTest;
var x,y:integer;
begin
getcom;
y:=intparam;
if getcom<>byte(',') then seterror(SynERROR);
if(y<1)or(y>63)then seterror(ArgERROR);
if boolean(error) then exit;
x:=intparam;
if(x<1)or(x>127)then seterror(ArgERROR);
testend;
if boolean(error) then exit;
varans.im:=zeronum;
varans.re.mode:=0;
varans.re.x:=graf.pixtest(x,y);
with variables^[23] do begin
im:=zeronum;re.x:=0;re.x:=getx(x);
end;
with variables^[24] do begin
im:=zeronum;re.x:=0;re.x:=gety(y);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure Sort(down:boolean);
var i:byte;
    c:word;
    l:tsort;
begin
i:=0;
repeat
getcom;
if getcom<>clist then begin seterror(SynERROR);exit;end;
c:=getcom;
if(c<49)or(c>54)then begin seterror(SynERROR);exit;end;
l[i]:=@lists^[c-49];
inc(i);
until testcom<>byte(',');
if testcom=byte(')') then getcom;
testend;
for c:=i to 5 do l[c]:=nil;
chroust.sort(l,down);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure SortA;
begin
Sort(false);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure SortD;
begin
Sort(true);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure VarList;
begin
tblist:=@lists^[getcom-690];
tbvarrange:=false;
testend;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setFile;
begin
lists:=@files[getcom-696];
testend;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure FuncOn;
begin
getcom;testend;
graf.funcon:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure SimulOn;
begin
getcom;testend;
graf.simulon:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure AxesOn;
begin
getcom;testend;
graf.axeson:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure CoordOn;
begin
getcom;testend;
graf.coordon:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure LabelOn;
begin
getcom;testend;
graf.labelon:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DerivOn;
begin
getcom;testend;
graf.derivon:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure LocusOn;
begin
getcom;testend;
graf.locuson:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure sumdispOn;
begin
getcom;testend;
graf.sumdispon:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure SelOnOff(bit:byte;on:boolean);
var i:word;{1=graph,2=table,4=dyna}
begin
getcom;
i:=intparam;
testend;
if(i>30)or(i<1)then seterror(ArgERROR);
if boolean(error)then exit;
with graphvars[i-1] do
if not on then selected:=selected and not bit
else if size>0 then selected:=selected or bit else selected:=0;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure GSelOn;
begin
selonoff(1,true);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure TSelOn;
begin
selonoff(2,true);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DSelOn;
begin
selonoff(4,true);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure RSelOn;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DrawOn;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure FuncOff;
begin
getcom;testend;
graf.funcon:=false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure SimulOff;
begin
getcom;testend;
graf.simulon:=false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure AxesOff;
begin
getcom;testend;
graf.axeson:=false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure CoordOff;
begin
getcom;testend;
graf.coordon:=false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure LabelOff;
begin
getcom;testend;
graf.labelon:=false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DerivOff;
begin
getcom;testend;
graf.derivon:=false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure LocusOff;
begin
getcom;testend;
graf.locuson:=false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure sumdispOff;
begin
getcom;testend;
graf.sumdispon:=false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure GSelOff;
begin
selonoff(1,false);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure TSelOff;
begin
selonoff(1,false);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DSelOff;
begin
selonoff(2,false);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure RSelOff;
begin
selonoff(4,false);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DrawOff;
begin
getcom;seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
var i,j:byte;
begin
for i:=0 to 5 do begin
vwindata[i,0]:=-6.3;vwindata[i,1]:=6.3;vwindata[i,2]:=1;
vwindata[i,3]:=-3.1;vwindata[i,4]:=3.1;vwindata[i,5]:=1;
vwindata[i,6]:=0;vwindata[i,7]:=360;vwindata[i,8]:=3.6;
for j:=0 to 29 do with stographvars[i,j]do begin
     grtype:=0;color:=graf.cblue;selected:=0;
     data:=nil;size:=0;end;
end;
end.