{$A+,B-,D+,E+,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
unit graf;
interface
type tfont=array[0..2047] of byte;
     pfont=^tfont;
     tmatfont=array[0..191] of byte;
     pmatfont=^tmatfont;
     tpict=array[0..128*64-1]of byte;
     ppict=^tpict;

var xmin,dx,xscl,ymin,dy,yscl,xmax,ymax,tmin,tmax,tptch:double;
    rightxmin,rightxscl,rightymin,rightyscl,rightxmax,rightymax,righttmin,righttmax,righttptch:double;
    xfct,yfct:double;
lx,ly,blx,bly:word;
var screen:array[0..199,0..319]of byte absolute $A000:$0000;

var i,j:word;
    font,grfont:pfont;
    matfont:pmatfont;
const
      cclear=128;                       {barevne hladiny}
      corange=8;
      cblue=4;
      cgreen=2;
      cfillorange=1;
      barvy:array[0..7]of byte=(4,4,4,4,4,4,4,4); {barvy radku}
      color:byte=cblue;                   {aktivni barva}
      plcolor:byte=1;                     {barva pro plot/line}
      size=127;                           {sirka okna}
      tx:word=132;                        {text. okno}
      ty:word=2;
      debugtx:word=132;                   {debug. okno}
      debugty:word=69;
      matwinx=2;                          {okno zbrazuj. pole}
      matwiny=69;
      connect:boolean=true;
      ploted:boolean=false;
      filling:boolean=true;

FuncOn:boolean=false;                   {nastaveni displaye}
SimulOn:boolean=false;
AxesOn:boolean=true;
GridOn:boolean=false;
CoordOn:boolean=true;
LabelOn:boolean=false;
DerivOn:boolean=false;
LocusOn:boolean=false;
sumdispOn:boolean=false;
graphtype:byte=0;                       {typ grafu Y=/ r=/..}
pictures:array[0..5]of ppict=(nil,nil,nil,nil,nil,nil);
background:byte=0;                      {cislo obrazku jako pozadi}
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure initgraph;
procedure init;
procedure closegraph;
procedure setrgb(Barva,Red,Green,Blue:byte);
procedure plot(x,y:double);            {bod k danemu range}
procedure intplot(x,y:double);         {spojnice k ose x}
procedure plotx(y,x:double);           {sourdnice opacne}
procedure traceplot(x,y:byte);         {trasovaci krizek}
procedure plotm(x,y:double);           {bod k danemu range + }
procedure plotv(x,y:double);           {+vybarveni pro Graph  Y<,..}
procedure clear(x:double);             {odmaze sloupec bodu}
procedure line;
procedure range(x1,x2,x3,y1,y2,y3,t1,t2,t3:double);
procedure factor(x,y:double);
procedure cls;                         {maze graf}
procedure clrmat;                            {okno poli}
procedure clrtext;                           {textu}
procedure scroll;
procedure debugscroll;
procedure textln(ch:byte);             {vypis na akt. souradnici}
procedure newline;
procedure textxy(x,y:word;ch:byte);    {vypis na danou souradnici}
procedure grtextxy(var x:word;y:word;ch:byte);{totez do grafu}
procedure grmattextxy(var x:word;y:word;ch:byte);{do okna poli-cislice}
procedure invgrmattextxy(var x:word;y:word;ch:byte);{inversne}
procedure mattextxy(x,y:word;ch:byte);              {text}
procedure invmattextxy(x,y:word;ch:byte);           {inversne}
procedure matzahlavi(ch:byte);                      {zahlavi: Ans/A..Z}
procedure numtextxy(x,y:word;ch:byte);
procedure putline(x1,y1,x2,y2,c:word);
procedure putpixel(x,y,c:word);
procedure horisontal(y:double);
procedure vertical(x:double);
procedure fline(x1,y1,x2,y2:double);
procedure circle(x,y,r:double);
function plotchg(var x,y:double):boolean;{vraci uspesnost operace}
function plotoff(var x,y:double):boolean;{t.j. je-li to v range}
function ploton(var x,y:double):boolean;
procedure pixchg(x,y:word);             {absolut. souradnice=>}
procedure pixoff(x,y:word);             {musi byt v 1,1..127,63}
procedure pixon(x,y:word);
function pixtest(x,y:word):byte;
procedure debugtextln(ch:byte);
procedure clrdebug;
procedure coordxy(x,y:word;ch:byte);
procedure debugnewline;
procedure storepict(var p:ppict);
procedure putpict(var p:ppict);{mov put}
procedure rclpict(var p:ppict);{or put}
function  getx(v:byte):double;{absolutni na vzhledem k range}
function  gety(v:byte):double;
procedure undoplot;           {pro trace}
procedure redoplot;
implementation
var unplot,replot:byte;
    osax:byte;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure initpal;
var i:byte;
begin
{
                   7   6   5   4   3   2   1  0
                ͻ
   Color                                
                ͼ
    =1=>caswin                      
             UN                  Orange fill
              U            Green
              S      Blue
              E                   Orange
              D
}
setrgb(128,50,50,63);
setrgb(129,63,00,00);
for i:=130 to 131 do setrgb(i,00,40,00);
for i:=132 to 135 do setrgb(i,00,00,40);
for i:=136 to 143 do setrgb(i,63,00,00);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure initgraph;assembler;
asm
   MOV AX,13H
   INT 10H
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure init;
var i:word;
begin
initgraph;
initpal;clrtext;cls;clrmat;clrdebug;
putline(0,0,261,0,7);
putline(0,1,261,1,7);
putline(0,66,261,66,7);
putline(0,67,261,67,7);
putline(0,68,261,68,7);
putline(0,133,261,133,7);

putline(0,0,0,133,7);
putline(1,0,1,133,7);
putline(261,0,261,133,7);
putline(260,0,260,133,7);
putline(130,0,130,133,7);
putline(131,0,131,133,7);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure closegraph;assembler;
asm
   MOV AX,3H
   INT 10H
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setrgb(Barva,Red,Green,Blue:byte);assembler;
Asm
 MOV DX,03C8H
 XOR AX,AX
 MOV AL,Barva
 OUT DX,AL
 INC DX
 MOV AL,Red
 OUT DX,AL
 MOV AL,Green
 OUT DX,AL
 MOV AL,Blue
 OUT DX,AL
End;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure putpixel(x,y,c:word);
begin
screen[y,x]:=screen[y,x]or c;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure putline(x1,y1,x2,y2,c:word);
var i:word;
d,x,y:double;
begin
x:=0.+x1-x2;y:=0.+y1-y2;
d:=sqrt(sqr(x)+sqr(y));
if d=0 then begin putpixel(x1,y1,c);exit;end;
for i:=0 to round(d) do
putpixel(round(x2+i*x/d),round(y2+i*y/d),c);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure pixon(x,y:word);
begin
screen[2+y,x+2]:=screen[2+y,x+2] or color;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure pixoff(x,y:word);
begin
screen[2+y,x+2]:=cclear;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function pixtest(x,y:word):byte;
begin
pixtest:=byte(screen[2+y,x+2]<>cclear);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure storepict(var p:ppict);
var i,j:byte;
begin
for j:=0 to 63 do
for i:=0 to 127 do
p^[128*j+i]:=screen[2+j,i+2];
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure rclpict(var p:ppict);
var i,j:byte;
begin
for j:=0 to 63 do
for i:=0 to 127 do
screen[2+j,i+2]:=p^[128*j+i]or screen[2+j,i+2];
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure putpict(var p:ppict);
var i,j:byte;
begin
for j:=0 to 63 do
for i:=0 to 127 do
screen[2+j,i+2]:=p^[128*j+i];
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function convert(const x,y:double;var xx,yy:word):boolean;
var pom:double;
begin
convert:=false;
pom:=system.int((x-xmin)/dx+0.5)+1;
if (pom<=0)or(pom>size)then exit;
xx:=trunc(pom);
pom:=system.int((y-ymin)/dy+0.5)+1;
if (pom<=0)or(pom>63)then exit;
yy:=trunc(pom);
convert:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function  getx(v:byte):double;
begin
if v=0 then v:=lx;
getx:=(v-1)*dx+xmin;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function  gety(v:byte):double;
begin
if v=0 then v:=ly;
gety:=(v-1)*dy+ymin;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure plot(x,y:double);
var xx,yy:word;
begin
ploted:=false;
if not convert(x,y,xx,yy) then exit;
blx:=lx;bly:=ly;replot:=color;
lx:=xx;ly:=yy;
ploted:=true;
unplot:=screen[66-yy,xx+2];
screen[66-yy,xx+2]:=unplot or color;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure intplot(x,y:double);       {spojnice k ose x, pro grafy integralu}
var xx,yy,yyy:integer;
pom:double;
ok:boolean;
i:integer;
begin
ploted:=false;
pom:=system.int((x-xmin)/dx+0.5)+1;
if (pom<=0)or(pom>size)then exit;
xx:=trunc(pom);
pom:=system.int((y-ymin)/dy+0.5)+1;
if (pom>0)and(pom<64) then begin
yy:=trunc(pom);
blx:=lx;bly:=ly;
lx:=xx;ly:=yy;
ploted:=true;
screen[66-yy,xx+2]:=screen[66-yy,xx+2]or color;
end else if pom<=0 then yy:=0 else yy:=64;
if yy=osax then exit;
if yy<osax then
for i:=yy+1 to osax-byte(osax=64) do screen[66-i,xx+2]:=screen[66-i,xx+2]or color
else for i:=osax+byte(osax=0) to yy-1 do screen[66-i,xx+2]:=screen[66-i,xx+2]or color;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure undoplot;
begin
screen[66-ly,lx+2]:=unplot;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure redoplot;
begin
screen[66-ly,lx+2]:=screen[66-ly,lx+2]or replot;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure plotx(y,x:double);
var xx,yy:word;
begin
ploted:=false;
if not convert(x,y,xx,yy) then exit;
blx:=lx;bly:=ly;
lx:=xx;ly:=yy;
ploted:=true;
screen[66-yy,xx+2]:=screen[66-yy,xx+2]or color;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure traceplot(x,y:byte);
var x1,x2,y1,y2,i:integer;
begin
x1:=x-2;if x1<0 then x1:=0;
x2:=x+2;if x2>size then x2:=size;
y1:=y-2;if y1<=0 then y1:=1;
y2:=y+2;if y2>64 then y2:=64;
for i:=x1 to x2 do
screen[66-y,i+2]:=screen[66-y,i+2]xor corange;
for i:=y1 to y2 do
screen[66-i,x+2]:=screen[66-i,x+2]xor corange;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure plotm(x,y:double);
var xx,yy:integer;
pom:double;
ok:boolean;
i:integer;
begin
ploted:=false;
pom:=system.int((x-xmin)/dx+0.5)+1;
if (pom<=0)or(pom>size)then exit;
xx:=trunc(pom);
pom:=system.int((y-ymin)/dy+0.5)+1;
if (pom>0)and(pom<64) then begin
yy:=trunc(pom);
blx:=lx;bly:=ly;
lx:=xx;ly:=yy;
ploted:=true;
screen[66-yy,xx+2]:=screen[66-yy,xx+2]or color;
end else if pom<=0 then yy:=0 else yy:=64;
if filling then for i:=yy+1 to 63 do screen[66-i,xx+2]:=screen[66-i,xx+2]or cfillorange
else for i:=1 to yy-1 do screen[66-i,xx+2]:=screen[66-i,xx+2]and not cfillorange;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure plotv(x,y:double);
var xx,yy:integer;
pom:double;
ok:boolean;
i:integer;
begin
ploted:=false;
pom:=system.int((x-xmin)/dx+0.5)+1;
if (pom<=0)or(pom>size)then exit;
xx:=trunc(pom);
pom:=system.int((y-ymin)/dy+0.5)+1;
if (pom>0)and(pom<64) then begin
yy:=trunc(pom);
blx:=lx;bly:=ly;
lx:=xx;ly:=yy;
ploted:=true;
screen[66-yy,xx+2]:=screen[66-yy,xx+2]or color;
end else if pom<=0 then yy:=0 else yy:=64;
if filling then for i:=1 to yy-1 do screen[66-i,xx+2]:=screen[66-i,xx+2]or cfillorange
else for i:=yy+1 to 63 do screen[66-i,xx+2]:=screen[66-i,xx+2]and not cfillorange;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function ploton(var x,y:double):boolean;
var xx,yy:word;
begin
ploton:=false;
if not convert(x,y,xx,yy) then exit;
screen[66-yy,xx+2]:=screen[66-yy,xx+2]or color;
x:=getx(xx);y:=gety(yy);
ploton:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function plotoff(var x,y:double):boolean;
var xx,yy:word;
begin
plotoff:=false;
if not convert(x,y,xx,yy) then exit;
screen[66-yy,xx+2]:=screen[66-yy,xx+2]or color;
x:=getx(xx);y:=gety(yy);
plotoff:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function plotchg(var x,y:double):boolean;
var xx,yy:word;
begin
plotchg:=false;
if not convert(x,y,xx,yy) then exit;
screen[66-yy,xx+2]:=screen[66-yy,xx+2]or color;
x:=getx(xx);y:=gety(yy);
plotchg:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure pixchg(x,y:word);
begin
screen[2+y,x+2]:=cclear or color*(byte(screen[2+y,x+2]=cclear));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure clear(x:double);
var xx:integer;
pom:double;
i:byte;
begin
pom:=system.int((x-xmin)/dx+0.5)+1;
if (pom<=0)or(pom>size)then exit;
xx:=trunc(pom)+2;
for i:=1 to 63 do screen[66-i,xx]:=screen[66-i,xx]and not cfillorange;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure line;
begin
if lx*blx*ly*bly=0 then exit;
putline(blx+2,66-bly,lx+2,66-ly,color or cclear);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure fline(x1,y1,x2,y2:double);
var a,b,c,d:word;
begin
if convert(x1,y1,a,b) then if convert(x2,y2,c,d)
then putline(a+2,66-b,c+2,66-d,color or cclear);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure circle(x,y,r:double);
var i,lx,ly,llx,lly:word;
    b:boolean;
    t:double;
begin
b:=false;t:=0;
for i:=0 to 200 do
begin
if convert(x+r*system.cos(t),y+r*system.sin(t),lx,ly) then
begin
if b then putline(2+lx,66-ly,2+llx,66-lly,color);b:=true;
llx:=lx;lly:=ly;
end else b:=false;
t:=t+pi/100;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure range(x1,x2,x3,y1,y2,y3,t1,t2,t3:double);
begin
xmin:=x1;xmax:=x2;xscl:=x3;
dx:=(xmax-xmin)/(size-1);
ymin:=y1;ymax:=y2;yscl:=y3;
dy:=(ymax-ymin)/62;
tmin:=t1;tmax:=t2;tptch:=t3;
x1:=system.int((-ymin)/dy+0.5)+1;
if (x1>0)and(x1<64) then osax:=trunc(x1)
else if x1<=0 then osax:=0 else osax:=64;
cls;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure factor(x,y:double);
var xst,yst,xsz,ysz:double;
begin
xst:=(xmin+xmax)/2;yst:=(ymin+ymax)/2;
xsz:=x*(xmin-xmax)/2;ysz:=y*(ymin-ymax)/2;
range(xst+xsz,xst-xsz,xscl,
      yst+ysz,yst-ysz,yscl,
      tmin,tmax,tptch);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure osy;
var xx,yy:integer;
    p,pom:double;
begin
color:=cgreen;
horisontal(0);
vertical(0);

if xscl<>0 then begin
pom:=system.int(-ymin/dy+0.5)+1;
if (pom<=0)then yy:=1 else if(pom>63)then yy:=63 else
begin yy:=trunc(pom)+1;if yy=64 then yy:=62;end;

pom:=xscl*trunc((getx(0)/xscl));
repeat
p:=system.int((pom-xmin)/dx+0.5)+1;
pom:=pom+xscl;
if p<1 then continue;
if p>size then break;
pixon(trunc(p),64-yy);
until false;
end;
if yscl=0 then exit;


pom:=system.int(-xmin/dx+0.5)+1;
if (pom<=0)then xx:=1 else if(pom>size)then xx:=size else
begin xx:=trunc(pom)+1;if xx=size+1 then dec(xx,2);end;

pom:=yscl*trunc((gety(0)/yscl));
repeat
p:=system.int((pom-ymin)/dy+0.5)+1;
pom:=pom+yscl;
if p<1 then continue;
if p>63 then break;
pixon(xx,64-trunc(p));
until false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure grid;
var p,px,pom,pomx:double;
begin
color:=cgreen;
if (xscl=0)or(yscl=0)then exit;
pomx:=xscl*trunc((getx(0)/xscl));
repeat
px:=system.int((pomx-xmin)/dx+0.5)+1;
pomx:=pomx+xscl;
if px<1 then continue;
if (px>size) then break;
pom:=yscl*trunc((gety(0)/yscl));
repeat
p:=system.int((pom-ymin)/dy+0.5)+1;
pom:=pom+yscl;
if p<1 then continue;
if p>63 then break;
pixon(trunc(px),64-trunc(p));
until false;
until false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure cls;
var i,j:word;
begin
dx:=(xmax-xmin)/(size-1);
dy:=(ymax-ymin)/62;
lx:=0;ly:=0;filling:=true;
for i:=0 to size do
for j:=0 to 63 do
screen[j+2,i+2]:=cclear;
if boolean(background) then rclpict(pictures[background-1]);
if AxesOn then osy;
if GridOn then grid;
color:=cblue;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure clrmat;
var i,j:word;
begin
for i:=matwinx to size+matwinx do
for j:=matwiny to 63+matwiny do
screen[j,i]:=cclear;
color:=cblue;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure clrtext;
var i,j:word;
begin
for i:=132 to 132+size do
for j:=0 to 63 do
screen[j+2,i]:=cclear;
for i:=0 to 7 do barvy[i]:=4;
tx:=132;
ty:=2;


end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure clrdebug;
var i,j:word;
begin
for i:=132 to 132+size do
for j:=0 to 63 do
screen[j+matwiny,i]:=cclear;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure scroll;
var i,j:word;
begin
for j:=0 to 55 do
for i:=128 to 256 do
screen[j+2,i+4]:=screen[j+10,i+4];
for j:=0 to 6 do barvy[j]:=barvy[j+1];
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure debugscroll;
var i,j:word;
begin
for j:=0 to 55 do
for i:=128 to 256 do
screen[j+69,i+4]:=screen[j+77,i+4];
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure textln(ch:byte);
var i,j,k:byte;
begin
if tx>=126+size then newline;
barvy[(ty-2)shr 3+1]:=color;
for k:=0 to 7 do
  begin i:=64;
  for j:=0 to 5 do
    begin
    screen[ty+k,tx+j]:=cclear or color*byte((i and font^[(ch shl 3)+k])=i);
    i:=i shr 1;
    end;
  end;
inc(tx,6);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure debugnewline;
begin
debugtx:=132;
if debugty<117 then inc(debugty,8) else debugscroll;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure debugtextln(ch:byte);
var i,j,k:byte;
begin
if debugtx>=126+size then debugnewline;
for k:=0 to 7 do
  begin i:=64;
  for j:=0 to 5 do
    begin
    screen[debugty+k,debugtx+j]:=cclear or color*byte((i and font^[(ch shl 3)+k])=i);
    i:=i shr 1;
    end;
  end;
inc(debugtx,6);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure newline;
begin
tx:=132;
if ty<50 then inc(ty,8) else scroll;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure textxy(x,y:word;ch:byte);
var xx,yy:word;
    ind,i,j,k:byte;
begin
ind:=y;
if(x<1)or(y<1)or(x>21)or(y>7)then exit;
x:=126+6*x;y:=8*y-6;
for k:=0 to 7 do
  begin i:=64;
  for j:=0 to 5 do
    begin
    screen[y+k,x+j]:=cclear or barvy[ind]*byte((i and font^[(ch shl 3)+k])=i);
    i:=i shr 1;
    end;
  end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure grtextxy(var x:word;y:word;ch:byte);
var i,j,k:byte;
begin
if x+grfont^[ch shl 3+7] >127 then exit;
for k:=0 to 5 do
  begin i:=128;
  for j:=0 to grfont^[ch shl 3+7]-1 do
    begin
    if y+k>63 then break;
    screen[y+k+2,x+j+2]:=screen[y+k+2,x+j+2] and not color or color*byte((i and grfont^[(ch shl 3)+k])=i);
    i:=i shr 1;
    end;
  end;
  x:=x+grfont^[ch shl 3+7];

end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure grmattextxy(var x:word;y:word;ch:byte);
var i,j,k:byte;
begin
for k:=0 to 5 do
  begin i:=128;
  for j:=0 to grfont^[ch shl 3+7]-1 do
    begin
    screen[y+k,x+j]:=cclear or color*byte((i and grfont^[(ch shl 3)+k])=i);
    i:=i shr 1;
    end;
  end;
  x:=x+grfont^[ch shl 3+7];
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure invgrmattextxy(var x:word;y:word;ch:byte);
var i,j,k:byte;
begin
for k:=0 to 5 do
  begin i:=128;
  for j:=0 to grfont^[ch shl 3+7]-1 do
    begin
    screen[y+k,x+j]:=cclear or color*byte((i and grfont^[(ch shl 3)+k])=0);
    i:=i shr 1;
    end;
  end;
  x:=x+grfont^[ch shl 3+7];
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure numtextxy(x,y:word;ch:byte);
var i,j,k:byte;
begin
for k:=0 to 7 do
  begin i:=64;
  for j:=0 to 5 do
    begin
    screen[y+k,x+j]:=cclear or color*byte((i and font^[(ch shl 3)+k])=i);
    i:=i shr 1;
    end;
  end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure matzahlavi(ch:byte);
var
    i,j,k:byte;
    var color:byte;
begin
if ch>0 then begin
ch:=ch+64;
for k:=0 to 7 do
  begin i:=64;
  for j:=0 to 5 do
    begin
    screen[matwiny+k,matwinx+j]:=cclear or cblue*byte((i and font^[(ch shl 3)+k])=i);
    i:=i shr 1;
    end;
  end;
exit;end;
for k:=0 to 7 do
 begin i:=128;
 for j:=0 to 7 do
   begin
  screen[matwiny+7-k,matwinx+j]:=cclear or cblue*byte((i and matfont^[192+k])=i);
  screen[matwiny+7-k,matwinx+j+8]:=cclear or cblue*byte((i and matfont^[200+k])=i);
   i:=i shr 1;
   end;
 end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure mattextxy(x,y:word;ch:byte);
var i,j,k:byte;
    var color:byte;
begin
color:=cblue;if ch>15 then color:=cgreen;
for k:=0 to 7 do
  begin i:=8;
  for j:=0 to 3 do
    begin
    screen[y+7-k,x+j]:=cclear or color*byte((i and matfont^[(ch shl 3)+k])=i);
    i:=i shr 1;
    end;
  end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure coordxy(x,y:word;ch:byte);
var i,j,k:byte;
begin
for k:=0 to 6 do
  begin i:=8;
  for j:=0 to 3 do
    begin
    screen[y+7-k,x+j]:=cclear or cgreen*byte((i and matfont^[(ch shl 3)+k])=i);
    i:=i shr 1;
    end;
  end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure invmattextxy(x,y:word;ch:byte);
var xx,yy:word;
    i,j,k:byte;
begin
for k:=0 to 7 do
  begin i:=8;
  for j:=0 to 3 do
    begin
    screen[y+7-k,x+j]:=cclear+cblue*byte((i and matfont^[(ch shl 3)+k])<>i);
    i:=i shr 1;
    end;
  end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure horisontal(y:double);
var xx,yy:word;
begin
yy:=round((y-ymin)/dy)+1;
if (yy<=0)or(yy>63)then exit;
for xx:=1 to 127 do screen[66-yy,xx+2]:=screen[66-yy,xx+2]or color;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure vertical(x:double);
var xx,yy:word;
begin
xx:=round((x-xmin)/dx)+1;
if (xx<=0)or(xx>size)then exit;
for yy:=1 to 63 do screen[66-yy,xx+2]:=screen[66-yy,xx+2]or color;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure loadfont;
var f:file;
i:integer;
s:string;
begin
getmem(font,2048);
s:=paramstr(0);dec(s[0],8);
assign(f,s+'cfx9850G.fnt');reset(f,2048);
if ioresult<>0 then begin
writeln('File not found: cfx9850G.fnt');halt;end;
blockread(f,font^,1,i);
if i<1 then begin
writeln('Fontfile too short: cfx9850G.fnt');halt;end;

getmem(matfont,208);
s:=paramstr(0);dec(s[0],8);
assign(f,s+'matrix.fnt');reset(f,208);
if ioresult<>0 then begin
writeln('File not found: matrix.fnt');halt;end;
blockread(f,matfont^,1,i);
if i<1 then begin
writeln('Fontfile too short: matrix.fnt');halt;end;

getmem(grfont,2048);
s:=paramstr(0);dec(s[0],8);
assign(f,s+'grtext.fnt');reset(f,2048);
if ioresult<>0 then begin
writeln('File not found: grtext.fnt');halt;end;
blockread(f,grfont^,1,i);
if i<1 then begin
writeln('Fontfile too short: grtext.fnt');halt;end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin
range(1,127,0,1,63,0,0,360,3.6);
lx:=0;blx:=0;ly:=0;bly:=0;
loadfont;
end.
{
                   7   6   5   4   3   2   1  0
                ͻ
   Color                                
                ͼ
    =1=>caswin                      
             UN                  Orange fill
              U            Green
              S      Blue
              E                   Orange
              D
}
