{$A+,B-,D+,E+,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
unit parser;
interface
uses crt,font,comp,chroust,tokconst,keyboard;
type tcharcomm=array [0..32767]of char;
     tcomm=array [0..32767]of byte;{buffer pro program}
     pcomm=^tcomm;
     tvariables=array[0..1525]of tvar;{promenne A..Z[1500]}
const shifted:set of byte=[127,247];  {shiftovaci tokeny}
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
    defined:word=25;                 {horni index pro Z[index]}
var variables:^tvariables;{25=Z}
    varr,varfi,varans:tvar;          {promenne r,theta,Ans}
    dstart,dend,dpitch:double;       {promenne}
    fstart,fend,fpitch:double;
    rstart,rend,rpitch:double;
    ra0,ra1,ra2,rb0,rb1,rb2:double;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
var files:array[0..5] of tlists;     {6 souboru seznamu}
    listans:tlist;
const lists:plists=@files[0];        {aktualni soubor}
var matrix:array[0..26] of tmat;     {matice Ans,A..Z}
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
 type tgrvar=record                  {pamet vzorcu pro grafy,tabulky,..}
      grtype,color,selected:byte;
      data:pcomm;size:word;
      end;
 var graphvars:array[0..29]of tgrvar;
 {XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
type trecurvar=record                {pamet vzorcu pro rekursi}
     rectype,color,selected:byte;
     data:pcomm;size:word;
     end;
var recurvars:array[0..1]of trecurvar;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
var comm:pcomm;                 {ukazatel na programovy buffer}
type getcomproc = function:word;{cteni tokenu}

     ptable=^ttable;            {tabulka hodnot}
     ttable=record
     head:string[8];
     next:ptable;
     dim:word;
     data:pnumarr;
     end;

const ftable:ptable=nil;
      rtable:ptable=nil;

var getcom:getcomproc;
procedure setdebug;
function testcom:word;
function testdisp:boolean;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function number:double;{realne cislo popr. vola nnumber}
function nnumber(radix:byte):double;{integer, dle radix, 0 je realne}
function param:double;
function intparam:integer;
procedure getnumero(var t:tnumero);
function selectvar:integer;
procedure parse0(var r:tresult);  {rekursivni sestup}
procedure parse1(var r:tresult);
procedure parse2(var r:tresult);
procedure parse3(var r:tresult);
procedure parse4(var r:tresult);
procedure parse5(var r:tresult);
procedure parse6(var r:tresult);
procedure parse7(var r:tresult);
procedure parse8(var r:tresult);
procedure parse9(var r:tresult);
procedure parse10(var r:tresult);
procedure parse11(var r:tresult);
procedure parse12(var r:tresult);
procedure parse13(var r:tresult);
procedure getfunc(var r:tresult;fn:byte);{funkce f1..f6}
procedure getgraphfunc(var r:tresult);  {funkce Y/r.. 1 az 30}
procedure parselist(var r:tresult);     (* napr.{1,2,3}  *)
procedure parsematrix(var r:tresult);   {napr. [[1,2,3][6,5,4]]}
function getlistindex:word;
function getmatindex:word;
function getcomdebug:word;far;
function getcomnorm:word;far;
procedure zderivuj(var r:tresult;v:pvar;var start,krok:tnumero;pozs:word);
procedure integral(var r:tresult);
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
const                    {nektere tokeny, zbytek v tokconst.pas}
cexp=15;
cmin=153;
csmin=135;
cplus=137;
ca=26;
cb=27;
cc=28;
cd=29;
ce=30;
cf=31;
cr=205;
cfi=206;
cf1=20;
cf2=21;
cf3=22;
cf4=23;
cf5=24;
cf6=25;
cpol=128;
crec=160;
cfemto =    1;
cpico =    2;
cnano =    3;
cmicro =    4;
cmilli =    5;
ckilo =    6;
cmega =    7;
cgiga =    8;
ctera =    9;
cpeta =   10;
cexa =   11;
csqr =  139;
cinv =  155;
cfakan =  171;
cdms=  140;
cna =  168;
cnroot =  184;
czlomek =  187;
csin =  129;
ccos =  130;
ctan =  131;
crh =  132;
cln =  133;
csqrt =  134;
casin =  145;
cacos =  146;
catan =  147;
crd =  148;
clog =  149;
c3rt =  150;
cabs =  151;
csinh =  161;
ccosh =  162;
ctanh =  163;
cro =  164;
cena =  165;
cint =  166;
cnot =  167;
casinh =  177;
cacosh =  178;
catanh =  179;
crb =  180;
c10 =  181;
cfrac =  182;
cneg =  183;

cperm =  136;
ccomb =  152;
ckrat =  169;
cdeln =  185;

cor =  170;
cmensir=16;
cnerov=17;
cvetsir=18;

cto =   14;
cans =  192;
cpi  =  208;
cimpl = 19;
cran  = 193;
cxnor=138;
cxor = 154;
cbor = 170;
cband= 186;

cland= 432;
clor = 433;
clnot= 435;
clist= 337;
cmat = 320;
cseq = 300;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
implementation
uses graf;
const funct:array[0..5] of pcomm=(nil,nil,nil,nil,nil,nil);{fce f1..f6}
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function getcomnorm:word;
var a:word;
begin
asm mov a,sp end;
if a<4096 then begin seterror(StkERROR);exit;end;
a:=byte(comm^[poz]);if a<>255 then inc(poz);
if a in shifted then
begin
case a of
127:a:=256+byte(comm^[poz]);
247:a:=512+byte(comm^[poz]);
end;
if a and 255<>255then inc(poz);
end;
getcomnorm:=a;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function getcomdebug:word;
var i,a:word;
begin
a:=getcomnorm;
for i:=1 to byte(znak[a,0]) do debugtextln(byte(znak[a,i]));
if a or 1=13 then begin debugnewline;end;
getcomdebug:=a;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setdebug;
begin
@getcom:=@getcomdebug;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function testcom:word;
var a:word;
begin
a:=byte(comm^[poz]);
if a in shifted then
case a of
127:a:=256+byte(comm^[poz+1]);
247:a:=512+byte(comm^[poz+1]);
end;
testcom:=a;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function testdisp:boolean;
begin
testdisp:=(poz>1)and(comm^[poz-1]=12);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function number:double;
function exp(e:integer):double;
begin
exp:=system.exp(e*system.ln(10));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXX}
label s0,st,s1,l,sn,e1,e2,k,err;
var man,mul:double;
    ex,sigexp:integer;
    com:word;
begin
if radix<>0 then begin number:=nnumber(radix);exit;end;
man:=1;mul:=1;ex:=0;sigexp:=1;
s0:com:=testcom;
   case com of
   48..57:begin getcom;man:=com-48;goto sn;end;
   byte('.'):begin getcom;man:=0;goto st;end;
   cexp:begin getcom;goto e1;end;
   else goto err;
   end;
sn:com:=testcom;
   case com of
   byte('.'):begin getcom;goto st;end;
   48..57:begin getcom;man:=10*man+com-48;goto sn;end;
   cexp:begin getcom;goto e1;end;
   else goto k;
   end;
st:com:=testcom;mul:=0.1*mul;
   case com of
   48..57:begin getcom;man:=man+mul*(com-48);goto s1;end;
   cexp:begin getcom;goto e1;end;
   else goto k;
   end;
s1:com:=testcom;mul:=0.1*mul;
   case com of
   48..57:begin getcom;man:=man+mul*(com-48);goto s1;end;
   cexp:begin getcom;goto e1;end;
   else goto k;
   end;
e1:com:=testcom;
   case com of
   cplus:begin getcom;goto e1;end;
   cmin,csmin:begin getcom;sigexp:=-sigexp;goto e1;end;
   48..57:begin getcom;ex:=com-48;goto e2;end;
   else goto err;
   end;
e2:com:=testcom;
   case com of
   48..57:begin getcom;ex:=10*ex+com-48;goto k;end;
   else goto k;
   end;
k:number:=man*exp(ex*sigexp);exit;
err:seterror(SynERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function nnumber(radix:byte):double;
label s0,sn,k,err;
var numm:double;
    com:word;c:byte;
begin
s0:com:=testcom;
   case com of
   48..57:begin c:=com-48;getcom;if c>=radix then goto err;numm:=c;goto sn;end;
   ca..cf:begin c:=com-ca+10;getcom;if 16>radix then goto err;numm:=c;goto sn;end;
   else goto err;
   end;
sn:com:=testcom;
   case com of
   48..57:begin getcom;c:=com-48;if c>=radix then goto err;numm:=radix*numm+c;goto sn;end;
   ca..cf:begin getcom;c:=com-ca+10;numm:=radix*numm+c;
          if 16>radix then goto err;goto sn;end;
   else goto k;
   end;
k:if (radix<>10)and(numm>maxlongint)then numm:=numm-maxlongint-2.0-maxlongint;
     if radix=2 then begin
                     if numm>32767 then numm:=-65536+numm;
                     if(numm<-32768)or(numm>32767) then seterror(MaERROR);
                     end;
     if (numm<-2147483647)or(numm>2147483647)then seterror(MaERROR);
     nnumber:=numm;exit;
err:seterror(SynERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure getnumero(var t:tnumero);
var r:tresult;
begin
parse13(r);if r.mode<>0 then begin free(r);seterror(MaERROR);t:=zeronum;exit;end;
if not zero(r.re) then comp.deleno(r.im,r.re);
fractonum(r.im);
if system.abs(r.im.x)>presnost then seterror(MaERROR);
t:=r.re;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function param:double;
var t:tnumero;
begin
getnumero(t);fractonum(t);param:=t.x;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function intparam:integer;
var t:double;
begin
t:=param;
if(t<-maxint)or(t>maxint)then seterror(ArgERROR) else intparam:=trunc(t+presnost);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function selectvar:integer;
var c:word;
    d:double;
begin
c:=testcom;
if c<>byte('[') then begin selectvar:=0;exit;end;
getcom;
d:=param;
if testcom=byte(']') then getcom;
if system.abs(d)<maxint then selectvar:=trunc(d) else seterror(MemERROR);

end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function getlistindex:word;
var d:integer;
begin
if getcom<>byte('[') then begin seterror(SynERROR);exit;end;
d:=intparam;if boolean(error) then exit;
if testcom=byte(']') then getcom;
if (d<256)and(d>=1) then getlistindex:=d else seterror(ArgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function getmatindex:word;
var c:word;
    d:integer;
begin
if getcom<>byte('[') then begin seterror(SynERROR);exit;end;
d:=intparam;if boolean(error) then exit;
if getcom<>byte(',') then begin seterror(SynERROR);exit;end;
if (d<256)and(d>=1) then c:=d else seterror(ArgERROR);
d:=intparam;if boolean(error) then exit;
if testcom=byte(']') then getcom;
if (d<256)and(d>=1) then getmatindex:=c shl 8 +d else seterror(ArgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure getlist(var r:tresult);
var l:plist;
    c:word;
    i:byte;
begin
getcom;
c:=getcom;
if(c<55)and(c>48)then l:=@lists^[c-49]
else if c=cans then l:=@listans else begin seterror(SynERROR);exit;end;
c:=testcom;
if c=byte('[') then begin
                    i:=getlistindex;if boolean(error)then exit;
                    if i>l^.dim then begin seterror(ArgERROR);exit;end;
                    r.mode:=0;r.im:=zeronum;r.re:=l^.data^[i-1];
                    exit;end;
if l^.dim=0 then begin seterror(DimERROR);exit;end;
r.mode:=1;r.list.dim:=l^.dim;
newnumero(r.list.data,l^.dim);if boolean(error) then exit;
for c:=0 to l^.dim-1 do r.list.data^[c]:=l^.data^[c];
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure getmat(var r:tresult);
var m:pmat;
    c:word;
    i:word;
begin
getcom;
c:=getcom;
if(c<91)and(c>64)then m:=@matrix[c-64]
else if c=cans then m:=@matrix[0] else begin seterror(SynERROR);exit;end;
c:=testcom;
if c=byte('[') then begin
                    i:=getmatindex;if boolean(error)then exit;
                    if lo(i)>=m^.columns+1 then begin seterror(ArgERROR);exit;end;
                    if hi(i)>=m^.lines+1 then begin seterror(ArgERROR);exit;end;
                    i:=hi(i)+m^.lines*lo(i)-m^.lines-1;
                    r.mode:=0;r.im:=zeronum;r.re:=m^.data^[i];
                    exit;end;
if(m^.columns=0)or(m^.lines=0)then begin seterror(DimERROR);exit;end;
r.mode:=2;r.mat.lines:=m^.lines;r.mat.columns:=m^.columns;
i:=m^.lines*m^.columns;
newnumero(r.mat.data,i);if boolean(error) then exit;
for c:=0 to i-1 do r.mat.data^[c]:=m^.data^[c];
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function valueof(t:tnumero):double;
begin
fractonum(t);
valueof:=t.x;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure seq(var r:tresult);
var v:pvar;
    start,krok,x:tnumero;
    pozs,poze:word;
    cil,d:double;
    i:integer;
begin
getcom;
pozs:=poz;
graphmode:=true;param;graphmode:=false;
if getcom<>byte(',') then begin seterror(SynERROR);exit;end;
i:=getcom;
case i of
65..90:v:=@variables^[i-65];
cr:v:=@varr;
cfi:v:=@varfi;
else begin seterror(SynERROR);exit;end;
end;
if getcom<>byte(',') then begin seterror(SynERROR);exit;end;
getnumero(start);
if getcom<>byte(',') then seterror(SynERROR);if boolean(error)then exit;
cil:=param;
if getcom<>byte(',') then seterror(SynERROR);if boolean(error)then exit;
getnumero(krok);if boolean(error)then exit;
if valueof(krok)=0 then begin seterror(MemERROR);exit;end;
if testcom=byte(')') then getcom;
poze:=poz;

d:=(cil-valueof(start))/valueof(krok);
if d<0 then begin seterror(ArgERROR);exit;end;
if d>=255 then begin seterror(DimERROR);exit;end;
i:=trunc(d)+1;
r.mode:=1;r.list.dim:=i;
newnumero(r.list.data,i);if boolean(error) then exit;
v^.im:=zeronum;
i:=0;v^.re:=start;cil:=cil+0.2*valueof(krok);
repeat
poz:=pozs;
getnumero(x);if boolean(error) then exit;
r.list.data^[i]:=x;
comp.plus(v^.re,krok);inc(i);
until valueof(v^.re)>cil;
if i<>r.list.dim then seterror(SysERROR);
poz:=poze;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure suma(var r:tresult);
var v:pvar;
    start,krok,x:tnumero;
    pozs,poze,i:word;
    cil,d:double;

begin
getcom;
pozs:=poz;
if graphmode then param else begin graphmode:=true;param;graphmode:=false;end;
if getcom<>byte(',') then begin seterror(SynERROR);exit;end;
i:=getcom;
case i of
65..90:v:=@variables^[i-65];
cr:v:=@varr;
cfi:v:=@varfi;
else begin seterror(SynERROR);exit;end;
end;
if getcom<>byte(',') then begin seterror(SynERROR);exit;end;
getnumero(start);
if getcom<>byte(',') then seterror(SynERROR);if boolean(error)then exit;
cil:=param;
if testcom<>byte(',') then krok:=onenum
else begin getcom;
getnumero(krok);if boolean(error)then exit;
if valueof(krok)=0 then begin seterror(MaERROR);exit;end;
end;
if testcom=byte(')') then getcom;
poze:=poz;

d:=(cil-valueof(start))/valueof(krok);
if d<0 then begin seterror(MaERROR);exit;end;
r.mode:=0;
r.im:=zeronum;r.re:=zeronum;
v^.im:=zeronum;
v^.re:=start;cil:=cil+0.2*valueof(krok);
repeat
poz:=pozs;
getnumero(x);if boolean(error) then exit;
comp.plus(r.re,x);
comp.plus(v^.re,krok);
until valueof(v^.re)>cil;
poz:=poze;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure zderivuj(var r:tresult;v:pvar;var start,krok:tnumero;pozs:word);
begin
poz:=pozs;
r.mode:=0;
v^.im:=zeronum;v^.re:=start;
comp.plus(v^.re,krok);
poz:=pozs;
getnumero(r.re);
comp.minus(v^.re,krok);comp.minus(v^.re,krok);
poz:=pozs;
getnumero(r.im);
comp.plus(v^.re,krok);
if boolean(error)then exit;
comp.minus(r.re,r.im);
r.im:=zeronum;
comp.deleno(r.re,krok);
if boolean(error)then exit;
fractonum(r.re);r.re.x:=r.re.x/2;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure integral(var r:tresult);
var v:pvar;
    start,cil,krok,x:double;
    pozs,poze,i,j,k:word;
begin
getcom;
pozs:=poz;
if graphmode then param else begin graphmode:=true;param;graphmode:=false;end;
if getcom<>byte(',') then seterror(SynERROR);
v:=@variables^[23];
start:=param;
if getcom<>byte(',') then seterror(SynERROR);
cil:=param;
if boolean(error)then exit;i:=6;
if testcom=byte(',') then begin
getcom;i:=intparam;if(i<1)or(i>9)then begin seterror(ArgERROR);exit;end;end;
if testcom=byte(')') then getcom;i:=i shl(i-1);poze:=poz;
krok:=(cil-start)/i;
v^.im:=zeronum;v^.re.mode:=0;v^.re.x:=start;
poz:=pozs;x:=param;
if boolean(error)then exit;
k:=4;
for j:=1 to i-1 do
begin
v^.re.x:=v^.re.x+krok;
poz:=pozs;
x:=x+k*param;
if boolean(error)then exit;
k:=6-k;
end;
poz:=pozs;
v^.re.x:=v^.re.x+krok;
x:=x+param;
if boolean(error)then exit;
r.mode:=0;
r.im:=zeronum;
r.re.mode:=0;
r.re.x:=x/(3*i)*(cil-start);
poz:=poze;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure SDP(var r:tresult);
var d:double;
begin
getcom;
d:=param;
if testcom=byte(')')then getcom;
r.mode:=0;
r.im:=zeronum;
r.re.mode:=0;
if d<0 then
if d<-15 then r.re.x:=0 else r.re.x:=PQR(-15,d)else
if d>5 then r.re.x:=1 else r.re.x:=0.5+PQR(0,d)
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure SDQ(var r:tresult);
var d:double;
begin
getcom;
d:=system.abs(param);
if testcom=byte(')')then getcom;
r.mode:=0;
r.im:=zeronum;
r.re.mode:=0;
if d>5 then r.re.x:=0.5 else r.re.x:=PQR(0,d)
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure SDR(var r:tresult);
var d:double;
begin
getcom;
d:=param;
if testcom=byte(')')then getcom;
r.mode:=0;
r.im:=zeronum;
r.re.mode:=0;
if d<0 then
if d<-5 then r.re.x:=1 else r.re.x:=0.5+PQR(d,0)else
if d>15 then r.re.x:=0 else r.re.x:=PQR(d,15)
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure deriv(var r:tresult);
var v:pvar;
    start,krok,x:tnumero;
    pozs,poze,i:word;
    d:double;

begin
getcom;
pozs:=poz;
if graphmode then param else begin graphmode:=true;param;graphmode:=false;end;
if getcom<>byte(',') then begin seterror(SynERROR);exit;end;
v:=@variables^[23];
getnumero(start);
if testcom<>byte(',') then begin
krok:=start;fractonum(krok);if zero(krok) then krok.x:=1e-10 else krok.x:=krok.x*1e-10;end
else begin getcom;getnumero(krok);end;
if testcom=byte(')') then getcom;
poze:=poz;
if boolean(error)then exit;
zderivuj(r,v,start,krok,pozs);
poz:=poze;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure zderivuj2(var r:tresult;v:pvar;var start:tnumero;pozs:word);
{manual 70}
var krok:tnumero;
    i:word;

begin
r.mode:=0;
v^.im:=zeronum;v^.re:=start;
r.re.mode:=0;r.im:=zeronum;
krok:=start;fractonum(krok);krok.x:=krok.x/5;if krok.x=0 then krok.x:=2e-5;
krok.x:=krok.x/390625;

comp.minus(v^.re,krok);comp.minus(v^.re,krok);
poz:=pozs;r.re.x:=-param;

comp.plus(v^.re,krok);
poz:=pozs;
r.re.x:=r.re.x+16*param;

comp.plus(v^.re,krok);
poz:=pozs;
r.re.x:=r.re.x-30*param;

comp.plus(v^.re,krok);
poz:=pozs;
r.re.x:=r.re.x+16*param;

comp.plus(v^.re,krok);
poz:=pozs;
r.re.x:=r.re.x-param;

r.re.x:=r.re.x/(12*system.sqr(krok.x));
comp.minus(v^.re,krok);comp.minus(v^.re,krok);
if boolean(error)then exit;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure deriv2(var r:tresult);{manual 70}
var v:pvar;
    start:tnumero;
    pozs,poze,i:word;

begin
getcom;
pozs:=poz;
if graphmode then param else begin graphmode:=true;param;graphmode:=false;end;
if getcom<>byte(',') then begin seterror(SynERROR);exit;end;
v:=@variables^[23];
getnumero(start);
if testcom=byte(',') then begin
getcom;i:=intparam;if(i<1)or(i>15)then seterror(ArgERROR);end;
if testcom=byte(')') then getcom;
poze:=poz;
if boolean(error)then exit;
zderivuj2(r,v,start,pozs);
poz:=poze;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure solve(var r:tresult);
var spoz,epoz,i:word;
    f1,t:tnumero;v:pvar;
    liml,limh:double;
begin
getcom;spoz:=poz;v:=@variables^[23];
liml:=-1e100;limh:=-liml;
if graphmode then param else begin graphmode:=true;param;graphmode:=false;end;
if getcom<>byte(',')then seterror(SynERROR);
getnumero(v^.re);v^.im:=zeronum;
if testcom=byte(',')then begin
getcom;
liml:=param;
if getcom<>byte(',')then seterror(SynERROR);
limh:=param;
end;
if testcom=byte(')')then getcom;
epoz:=poz;i:=0;
repeat
t:=v^.re;fractonum(t);if t.x=0 then t.x:=1e-10 else t.x:=t.x*1e-10;
zderivuj(r,v,v^.re,t,spoz);
poz:=spoz;getnumero(t);f1:=t;
comp.deleno(f1,r.re);
minus(v^.re,f1);
if(i>200)or(valueof(v^.re)<liml)or(valueof(v^.re)>limh)then seterror(MaERROR);
if boolean(error)then exit;
inc(i);
until system.abs(valueof(t))<1e-9;
poz:=epoz;
r.re:=v^.re;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure fminmax(var r:tresult;max:boolean);
var spoz,epoz:word;
    t,y,t0,y0:tnumero;v:pvar;
    liml,limh,krok:double;
    i,j:integer;
begin
getcom;spoz:=poz;v:=@variables^[23];i:=9;
if graphmode then param else begin graphmode:=true;param;graphmode:=false;end;
if getcom<>byte(',')then seterror(SynERROR);
liml:=param;
if getcom<>byte(',')then seterror(SynERROR);
limh:=param;
if testcom=byte(',')then begin getcom;i:=intparam;end;
if testcom=byte(')')then getcom;
if boolean(error)then exit;
epoz:=poz;
v^.im:=zeronum;v^.re.mode:=0;
v^.re.x:=liml;
i:=2 shl i;
krok:=(limh-liml)/i;
t0:=v^.re;
poz:=spoz;
getnumero(y0);y:=y0;

for j:=2 to i do begin
v^.re.x:=v^.re.x+krok;
poz:=spoz;
getnumero(y);
if max then if valueof(y)>=valueof(y0)then begin y0:=y;t0:=v^.re;end else
       else if valueof(y)<=valueof(y0)then begin y0:=y;t0:=v^.re;end;
if boolean(error)then exit;
end;
v^.re:=t0;
i:=0;
repeat
t:=v^.re;fractonum(t);if t.x=0 then t.x:=1e-10 else t.x:=t.x*1e-10;
zderivuj(r,v,v^.re,t,spoz);t0:=r.re;
poz:=spoz;zderivuj2(r,v,v^.re,spoz);t0:=t;
comp.deleno(t0,r.re);
minus(v^.re,t0);
if(valueof(v^.re)<liml)or(valueof(v^.re)>limh)then seterror(MaERROR);
if boolean(error)then exit;
inc(i);
until (i=20)or(system.abs(valueof(t))<1e-9);



poz:=spoz;
r.mode:=1;
r.list.dim:=2;
newnumero(r.list.data,r.list.dim);
if boolean(error)then exit;
r.list.data^[0]:=v^.re;getnumero(r.list.data^[1]);
poz:=epoz;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure mattolist(var r:tresult);
var c:word;
    m:pmat;
begin
getcom;if testcom=cmat then getcom;
c:=getcom;
case c of
65..90:m:=@matrix[c-64];
cans  :m:=@matrix[0];
else begin seterror(SynERROR);exit;end;
end;
if getcom<>byte(',')then begin seterror(SynERROR);exit;end;
c:=intparam;if c=0 then seterror(ArgERROR) else
chroust.mattolist(r,m,c-1);
if testcom=byte(')') then getcom;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure listtomat(var r:tresult);
var c:word;
    l:plist;
begin
getcom;if testcom=clist then getcom;
c:=getcom;
case c of
49..54:l:=@lists^[c-49];
cans  :l:=@listans;
else begin seterror(SynERROR);exit;end;
end;
chroust.listtomat(r,l);
while testcom=byte(',') do
begin
getcom;if testcom=clist then getcom;
c:=getcom;
case c of
49..54:l:=@lists^[c-49];
cans  :l:=@listans;
else begin seterror(SynERROR);exit;end;
end;
chroust.appendtomat(r,l);
end;
if testcom=byte(')') then getcom;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure getfresult(var r:tresult);
var p:ptable;
    columns,i,j:byte;
begin
getcom;
if ftable=nil then begin seterror(MemERROR);exit;end;
p:=ftable;columns:=0;
while p<>nil do begin inc(columns);p:=p^.next;end;
p:=ftable;
r.mode:=2;
r.mat.lines:=ftable^.dim;
r.mat.columns:=columns;
newnumero(r.mat.data,r.mat.lines*columns);
if boolean(error)then exit;
for i:=0 to columns-1 do
begin
for j:=0 to r.mat.lines-1 do
if p^.data^[j].mode=2 then begin seterror(DimERROR);free(r);exit;end
else r.mat.data^[j+r.mat.lines*i]:=p^.data^[j];
p:=p^.next;
end;
if p<>nil then seterror(SysERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parse0(var r:tresult);
var c:word;
pom:byte;
begin
c:=testcom;
case c of
byte('A')..byte('Z'):begin pom:=getcom-byte('A');inc(pom,selectvar);
             if (pom<0)or(pom>defined) then begin seterror(MemERROR);exit;end;
             r.mode:=0;r.re:=variables^[pom].re;r.im:=variables^[pom].im;end;
ca..cf,cexp,byte('0')..byte('9'),byte('.'):begin r.mode:=0;
             r.re.mode:=0;r.re.x:=number;r.im.mode:=0;r.im.x:=0;exit;end;
cr:  begin getcom;r.mode:=0;r.re:=varr.re;  r.im:=varr.im;end;
cfi: begin getcom;r.mode:=0;r.re:=varfi.re; r.im:=varfi.im;end;
cans:begin getcom;r.mode:=0;r.re:=varans.re;r.im:=varans.im;end;
cpi :begin getcom;r.mode:=0;r.re.mode:=0;r.re.x:=system.pi;r.im:=zeronum;end;
cran:begin getcom;r.mode:=0;r.re.mode:=0;r.re.x:=random;r.im:=zeronum;end;
ci  :begin getcom;r.mode:=0;r.re:=zeronum;r.im:=onenum;end;
cgetkey:begin getcom;r.mode:=0;r.re.mode:=0;r.re.x:=keyboard.getkey;r.im.mode:=0;r.im.x:=0;end;
byte('('):begin getcom;parse13(r);if testcom=byte(')') then getcom;end;
byte('{'):begin getcom;parselist(r);if testcom=byte('}') then getcom;end;
byte('['):parsematrix(r);
clist:getlist(r);
cmat:getmat(r);
cfresult:getfresult(r);
cxmin..crighttscl,cfstart..crpitch,ca0..ca2,cb0..cbnStart:begin r.mode:=0;r.re.mode:=0;r.im.mode:=0;r.im.x:=0;
                 case getcom of
                 cxmin:r.re.x:=graf.xmin;
                 cxmax:r.re.x:=graf.xmax;
                 cxscl:r.re.x:=graf.xscl;
                 cymin:r.re.x:=graf.ymin;
                 cymax:r.re.x:=graf.ymax;
                 cyscl:r.re.x:=graf.yscl;
                 ctmin:r.re.x:=graf.tmin;
                 ctmax:r.re.x:=graf.tmax;
                 ctptch:r.re.x:=graf.tptch;
                 crightxmin:r.re.x:=graf.rightxmin;
                 crightxmax:r.re.x:=graf.rightxmax;
                 crightxscl:r.re.x:=graf.rightxscl;
                 crightymin:r.re.x:=graf.rightymin;
                 crightymax:r.re.x:=graf.rightymax;
                 crightyscl:r.re.x:=graf.rightyscl;
                 crighttmin:r.re.x:=graf.righttmin;
                 crighttmax:r.re.x:=graf.righttmax;
                 crighttscl:r.re.x:=graf.righttptch;
                 cxfct:r.re.x:=graf.xfct;
                 cyfct:r.re.x:=graf.yfct;
                 cdstart:r.re.x:=dstart;
                 cdend:r.re.x:=dend;
                 cdpitch:r.re.x:=dpitch;
                 crstart:r.re.x:=rstart;
                 crend:r.re.x:=rend;
                 crpitch:r.re.x:=rpitch;
                 cfstart:r.re.x:=fstart;
                 cfend:r.re.x:=fend;
                 cfpitch:r.re.x:=fpitch;
                 ca0    :begin r.re.x:=ra0;exit;end;
                 ca1    :begin r.re.x:=ra1;exit;end;
                 ca2,canStart:begin r.re.x:=ra2;exit;end;
                 cb0    :begin r.re.x:=rb0;exit;end;
                 cb1    :begin r.re.x:=rb1;exit;end;
                 cb2,cbnStart:begin r.re.x:=rb2;exit;end;
                 else seterror(SynERROR);
                 end;
          end;
cf1..cf6 :begin getcom;getfunc(r,c-cf1);end;
496..500 :getgraphfunc(r);
else seterror(SynERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parse1(var r:tresult);
var p:tnumero;
    y:tresult;
c:word;
i,j:double;
begin
y.mode:=0;if boolean(error)then exit;
c:=testcom;
case c of
cseq:seq(r);
cidentity:begin getcom;parse13(r);identity(r);end;
cpol,crec:begin getcom;parse13(r);
           if getcom<>byte(',') then begin seterror(SynERROR);exit;end;
           parse13(y);if boolean(error)then exit;
           if testcom=byte(')') then getcom;
           if c=cpol then pol(r,y) else rec(r,y);
           end;
clmin,clmax,
cmean,cmedian:begin getcom;parse13(r);if testcom<>byte(',')then
              case c of
              clmin:minl1(r);clmax:maxl1(r);
              cmean:mean1(r);cmedian:median1(r);
              end else begin
              getcom;parse13(y);
              case c of
              clmin:minl2(r,y);clmax:maxl2(r,y);
              cmean:mean2(r,y);cmedian:median2(r,y);
              end;free(y);end;
              if testcom=byte(')')then getcom;
              end;
csum,cprod,
ccuml,cpercent:begin getcom;parse13(r);
              case c of
              csum:suml(r);cprod:prodl(r);
              ccuml:cumll(r);cpercent:percentl(r);
              end;end;
caugment:begin getcom;parse13(r);
         if getcom<>byte(',') then begin seterror(SynERROR);exit;end;
         parse13(y);augment(r,y);if testcom=byte(')')then getcom;end;
cmattolist:mattolist(r);
clisttomat:listtomat(r);
cfsum:suma(r);
cderiv:deriv(r);
cderiv2:deriv2(r);
141:integral(r);
csdp:sdp(r);
csdq:sdq(r);
csdr:sdr(r);
csolve:solve(r);
cfmin:fminmax(r,false);
cfmax:fminmax(r,true);
else parse0(r);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parsedms(var r:tresult);
var x:double;
begin
if r.mode<>0 then seterror(MaERROR);
if not zero(r.im) then seterror(MaERROR);
x:=number/60;
if getcom<>cdms then seterror(SynERROR);
if boolean(error) then exit;
case testcom of
ca..cf,cexp,byte('0')..byte('9'),byte('.'):
begin getcom;x:=x+number/3600;if getcom<>cdms then seterror(SynERROR);
      if boolean(error) then exit;end;
end;
fractonum(r.re);r.re.x:=r.re.x+x;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parse2(var r:tresult);
var c:word;
x:tresult;
begin
parse1(r);if boolean(error)then exit;
repeat
c:=testcom;
case c of
cfemto..cexa:begin getcom;x.mode:=0;x.re.mode:=0;x.im.mode:=0;x.im.x:=0;
                   x.re.x:=system.exp((3*(c-5.0-byte(c<ckilo)))*system.ln(10));
             nasob(r,x);
             end;
csqr:begin getcom;sqr(r);end;
cinv:begin getcom;inv(r);end;
cfakan:begin getcom;fakan(r);end;
cdms:begin getcom;parsedms(r);end;
cdegu:begin getcom;chroust.fromdeg(r);end;
cradu:begin getcom;chroust.fromrad(r);end;
cgradu:begin getcom;chroust.fromgra(r);end;
     else exit;
end;

until false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parse3(var r:tresult);
var c:word;
y:tresult;
begin
y.mode:=0;
parse2(r);if boolean(error)then exit;
repeat;
c:=testcom;
case c of
cna,cnroot:begin getcom;parse2(y);if c=cna then pow(r,y) else begin root(y,r);r:=y;end;end;
           else begin free(y);exit;end;
end;
until false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parse4(var r:tresult);
var c:word;
rr,rrr:tresult;
begin
rr.mode:=0;rrr.mode:=0;
parse3(r);if boolean(error)then exit;
c:=testcom;
if c<>czlomek then exit;

getcom;if r.mode<>0 then begin seterror(SynERROR);exit;end;

parse3(rr);if rr.mode<>0 then begin seterror(SynERROR);free(rr);exit;end;
numtofrac(rr.re);numtofrac(rr.im);
c:=testcom;
if c<>czlomek then begin vydel(r,rr);
   exit;end;
getcom;
parse3(rrr);if rrr.mode<>0 then begin seterror(SynERROR);free(rrr);exit;end;
c:=testcom;
if C=czlomek then begin seterror(SynERROR);exit;end;
numtofrac(rrr.re);numtofrac(rrr.im);
vydel(rr,rrr);secti(r,rr);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parse5(var r:tresult);
var c:word;
rr:tresult;
b:boolean;
begin
parse4(r);b:=false;
repeat
if boolean(error)then exit;
rr.mode:=0;
c:=testcom;
case c of
byte('A')..byte('Z'),cAns,cpi,cran,cr,cfi,ci,byte('{'),byte('['),cf1..cf6,
clist,cmat,cderiv..cmedian,ctrn,cpol,crec,clmax,cidentity..ccuml,496..500,cfsum,
cderiv,cderiv2,141,csdp,csdq,csdr,cxmin..crighttscl,cfstart..crpitch,
ca0,ca1,ca2,canStart,cb0,cb1,cb2,cbnStart:begin parse4(rr);
nasob(r,rr);end;
else b:=true;
end;
free(rr);
until b;

end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parse6(var r:tresult);
var c:word;
begin
c:=testcom;if boolean(error)then exit;
case c of
csin:begin getcom;parse6(r);sin(r)end;
ccos:begin getcom;parse6(r);cos(r)end;
ctan:begin getcom;parse6(r);tan(r)end;
crh :begin getcom;r.mode:=0;r.re.mode:=0;r.im.mode:=0;r.im.x:=0;r.re.x:=nnumber(16);end;
cln :begin getcom;parse6(r);ln(r)end;
csqrt:begin getcom;parse6(r);sqrt(r)end;
casin:begin getcom;parse6(r);asin(r)end;
cacos:begin getcom;parse6(r);acos(r)end;
catan:begin getcom;parse6(r);atan(r)end;
crd :begin getcom;r.mode:=0;r.re.mode:=0;r.im.mode:=0;r.im.x:=0;r.re.x:=nnumber(10);end;
clog :begin getcom;parse6(r);log(r)end;
c3rt :begin getcom;parse6(r);sqrt3(r)end;
cabs :begin getcom;parse6(r);abs(r)end;
csinh :begin getcom;parse6(r);sinh(r)end;
ccosh :begin getcom;parse6(r);cosh(r)end;
ctanh :begin getcom;parse6(r);tanh(r)end;
cro   :begin getcom;r.mode:=0;r.re.mode:=0;r.im.mode:=0;r.im.x:=0;r.re.x:=nnumber(8);end;
cena :begin getcom;parse6(r);e(r)end;
cint :begin getcom;parse6(r);int(r)end;
cnot :begin getcom;parse6(r);bnot(r)end;
clnot:begin getcom;parse6(r);lnot(r)end;
casinh:begin getcom;parse6(r);asinh(r)end;
cacosh:begin getcom;parse6(r);acosh(r)end;
catanh:begin getcom;parse6(r);atanh(r)end;
crb   :begin getcom;r.mode:=0;r.re.mode:=0;r.im.mode:=0;r.im.x:=0;r.re.x:=nnumber(2);end;
c10   :begin getcom;parse6(r);exp10(r)end;
cfrac :begin getcom;parse6(r);frac(r)end;
cneg,cmin,csmin:begin getcom;parse6(r);neg(r)end;
cplus:begin getcom;parse6(r)end;
cdet: begin getcom;parse6(r);det(r);end;
ctrn: begin getcom;parse6(r);trn(r);end;
cdim: begin getcom;parse6(r);dim(r);end;
carg: begin getcom;parse6(r);arg(r);end;
crep: begin getcom;parse6(r);rep(r);end;
cimp: begin getcom;parse6(r);imp(r);end;
cconjg:begin getcom;parse6(r);conj(r);end;
else parse5(r);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parse7(var r:tresult);
var c:word;
rr:tresult;
b:boolean;
begin
rr.mode:=0;
parse6(r);b:=false;
repeat
if boolean(error)then exit;
c:=testcom;
case c of
byte('('),csin,ccos,ctan,crh,cln,csqrt,casin,cacos,catan,crd,clog,c3rt,cabs,csinh,
ccosh,ctanh,cro,cena,cint,cnot,clnot,casinh,cacosh,catanh,crb,c10,cfrac,cneg,
cdim,carg,crep,cimp,cconjg:
            begin parse6(rr);
            nasob(r,rr);end;
else b:=true;
end;
until b;
free(rr);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parse8(var r:tresult);
var c:word;
rr:tresult;
manas:boolean;
begin
parse7(r);manas:=false;if boolean(error)then exit;
repeat
c:=testcom;rr.mode:=0;
case c of
cperm:begin getcom;parse7(rr);perm(r,rr);end;
ccomb:begin getcom;parse7(rr);komb(r,rr);end;
else manas:=true;
end;
free(rr);
until manas;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parse9(var r:tresult);
var c:word;
rr:tresult;
manas:boolean;
begin
parse8(r);manas:=false;if boolean(error)then exit;
repeat
c:=testcom;rr.mode:=0;
case c of
ckrat:begin getcom;parse8(rr);nasob(r,rr);end;
cdeln:begin getcom;parse8(rr);vydel(r,rr);end;
else manas:=true;
end;
free(rr);
until manas;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parse10(var r:tresult);
var c:word;
rr:tresult;
manas:boolean;
begin
parse9(r);manas:=false;if boolean(error)then exit;
repeat
c:=testcom;rr.mode:=0;
case c of
cplus:begin getcom;parse9(rr);secti(r,rr);end;
cmin:begin getcom;parse9(rr);odecti(r,rr);end;
else manas:=true;
end;
free(rr);
until manas;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parse11(var r:tresult);
var c:word;
rr:tresult;
manas:boolean;
begin
parse10(r);manas:=false;if boolean(error)then exit;
repeat
c:=testcom;rr.mode:=0;
case c of
byte('='):begin getcom;parse10(rr);rovno(r,rr);end;
byte('<'):begin getcom;parse10(rr);mensi(r,rr);end;
byte('>'):begin getcom;parse10(rr);vetsi(r,rr);end;
cmensir  :begin getcom;parse10(rr);mensirov(r,rr);end;
cvetsir  :begin getcom;parse10(rr);vetsirov(r,rr);end;
cnerov   :begin getcom;parse10(rr);nerovno(r,rr);end;
else manas:=true;
end;
free(rr);
until manas;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parse12(var r:tresult);
var c:word;
rr:tresult;
manas:boolean;
begin
parse11(r);manas:=false;if boolean(error)then exit;
repeat
c:=testcom;rr.mode:=0;
case c of
cband:begin getcom;parse11(rr);band(r,rr);end;
cland:begin getcom;parse11(rr);land(r,rr);end;
else manas:=true;
end;
free(rr);
until manas;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parse13(var r:tresult);
var c:word;
rr:tresult;
manas:boolean;
begin
parse12(r);manas:=false;if boolean(error)then exit;
repeat
c:=testcom;rr.mode:=0;
case c of
cbor:begin getcom;parse12(rr);bor(r,rr);end;
clor:begin getcom;parse12(rr);lor(r,rr);end;
cxor:begin getcom;parse12(rr);bxor(r,rr);end;
cxnor:begin getcom;parse12(rr);bxnor(r,rr);end;
else manas:=true;
end;
free(rr);
until manas;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure loadf(var p:pcomm;c:byte);
var f:file;
size:word;
s:string[20];
begin
s:='F'+char(c+49)+'.cas';
assign(f,s);reset(f,1);
size:=filesize(f);
if ioresult<>0 then begin seterror(SynERROR);exit;end;
getmemory(p,size+1);blockread(f,p^,size);close(f);
p^[size]:=255;
if p^[0]=58 then p:=pointer(51+longint(p));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure getfunc(var r:tresult;fn:byte);
var f:file;
oldp:pcomm;oldpoz,com:word;
begin
if funct[fn]=nil then loadf(funct[fn],fn);
{inc(stprog);
if stprog>11 then begin NeERROR:=true;exit;end;}
oldpoz:=poz;poz:=0;
oldp:=comm;comm:=funct[fn];
parse13(r);
com:=testcom;
if com<>255 then seterror(SynERROR);
{dec(stprog);}
poz:=oldpoz;comm:=oldp;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure getgraphfunc(var r:tresult);
var oldp:pcomm;oldpoz,com,index:word;
search:boolean;
begin
search:=getcom=499;
index:=trunc(nnumber(10));
if(index<1)or(index>30)then seterror(SynERROR);dec(index);
if graphvars[index].size=0 then seterror(SynERROR);
if boolean(error)then
exit;
oldpoz:=poz;poz:=0;
oldp:=comm;comm:=graphvars[index].data;
com:=0;
if search then while com<>246 do
begin com:=getcom;if com=255 then break;end;
parse13(r);
com:=testcom;
if(com<>255)and(com<>246)then seterror(SynERROR);
if boolean(error)then exit;
poz:=oldpoz;comm:=oldp;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parse(var r:tresult);
begin
parse13(r);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parselist(var r:tresult);
var pom:pnumarr;
    i,index:byte;
begin
index:=0;
newnumero(pom,255);if boolean(error) then exit;
repeat
getnumero(pom^[index]);
if boolean(error) then begin oldnumero(pom,255);exit;end;
if testcom<>byte(',') then break;getcom;
if index=255 then begin seterror(DimERROR);oldnumero(pom,255);exit;end;
inc(index);
until false;
r.mode:=1;r.list.dim:=index+1;
newnumero(r.list.data,r.list.dim);
for i:=0 to index do
r.list.data^[i]:=pom^[i];
oldnumero(pom,255);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parsematrix(var r:tresult);
var pom:pnumarr;
    limit,row,col:byte;
    posun:word;
    const maxsize=2500;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function parserow:byte;
var index:byte;
begin
index:=0;
repeat
getnumero(pom^[posun+index]);if boolean(error) then exit;
inc(index);
if testcom<>byte(',') then break;getcom;
if index=limit then begin seterror(DimERROR);exit;end;
until false;
if col<>0 then if index<>col then begin seterror(DimERROR);exit;end;
inc(posun,index);
parserow:=index;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function last:boolean;
var c,p:word;
begin
p:=poz;c:=getcom;
if c=byte(']') then begin last:=testcom<>byte('[');exit;end;
if c=cto then begin poz:=p;last:=true;exit;end;
if((c or 1)<>13)and(c<>58)and(c<>255)then begin seterror(SynERROR);exit;end;
if testcom=byte('[') then begin last:=false;exit;end;
poz:=p;last:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin
getcom;{='['}limit:=255;
newnumero(pom,maxsize);posun:=0;col:=0;row:=0;
repeat if getcom<>byte('[') then begin oldnumero(pom,maxsize);seterror(SynERROR);exit;end;
col:=parserow;inc(row);if posun+col>maxsize then seterror(MemERROR);
if boolean(error) then begin oldnumero(pom,maxsize);exit;end;
until last;
if testcom=byte(']')then getcom;
r.mode:=2;r.mat.lines:=col;r.mat.columns:=row;
newnumero(r.mat.data,posun);
for posun:=posun-1 downto 0 do
r.mat.data^[posun]:=pom^[posun];
oldnumero(pom,maxsize);
trn(r);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
var i,j:byte;
begin
new(variables);
for i:=0 to defined do with variables^[i] do begin
re:=zeronum;im:=zeronum;end;
with varr do begin
re:=zeronum;im:=zeronum;end;
with varfi do begin
re:=zeronum;im:=zeronum;end;
with varans do begin
re:=zeronum;im:=zeronum;end;
for i:=0 to 5 do
for j:=0 to 5 do
files[i][j].dim:=0;
for j:=0 to 26 do
with matrix[j] do begin lines:=0;columns:=0;end;
listans.dim:=0;
@getcom:=@getcomnorm;
for i:=0 to 29 do
    with graphvars[i] do begin
     grtype:=0;color:=graf.cblue;selected:=0;
     data:=nil;size:=0;end;
for i:=0 to 1 do
     with recurvars[i] do begin
     rectype:=0;color:=graf.cblue;selected:=0;
     data:=nil;size:=0;end;

end.