{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
unit chroust;
interface
uses comp;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
type
     pnumarr=^tnumarr;
     tnumarr=array[byte] of tnumero;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
     plist=^tlist;
     tlist=record       {seznam}
     dim:word;
     data:pnumarr;
     end;
     tlists=array[0..5]of tlist;{6 seznamu v souboru}
     plists=^tlists;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
     tsort=array[0..5]of plist;{seznamy pro trideni}
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
     pmat=^tmat;                {matice}
     tmat=record
     lines,columns:byte;
     data:pnumarr;
     end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
     presult=^tresult;           {vysledek}
     tresult=record              {je bud}
     case mode:byte of
          0:(re,im:tnumero);     {komplexni cislo}
          1:(list:tlist);        {nebo seznam (1D pole)}
          2:(mat:tmat);          {a nebo matice (2D pole)}
     end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
     pvar=^tvar;                 {promenna je komplexni}
     tvar=record
          re,im:tnumero;
     end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure newnumero(var p;size:word);{alokace pameti pro ciselne pole}
procedure oldnumero(var p;size:word);
procedure secti(var x,y:tresult);{funkce vraci vysledek v 1. argumentu}
procedure odecti(var x,y:tresult);
procedure nasob(var x,y:tresult);
procedure vydel(var x,y:tresult);
procedure sin(var x:tresult);
procedure cos(var x:tresult);
procedure tan(var x:tresult);
procedure asin(var x:tresult);
procedure acos(var x:tresult);
procedure atan(var x:tresult);
procedure sinh(var x:tresult);
procedure cosh(var x:tresult);
procedure tanh(var x:tresult);
procedure asinh(var x:tresult);
procedure acosh(var x:tresult);
procedure atanh(var x:tresult);
procedure ln(var x:tresult);
procedure e(var x:tresult);
procedure log(var x:tresult);
procedure exp10(var x:tresult);
procedure sqrt(var x:tresult);
procedure sqr(var x:tresult);
procedure sqrt3(var x:tresult);
procedure pow(var f,e:tresult);
procedure root(var f,e:tresult);
procedure abs(var x:tresult);
procedure arg(var x:tresult);
procedure fakan(var x:tresult);
procedure int(var x:tresult);
procedure frac(var x:tresult);
procedure intg(var x:tresult);
procedure inv(var x:tresult);
procedure neg(var x:tresult);
procedure fromdeg(var x:tresult);
procedure fromrad(var x:tresult);
procedure fromgra(var x:tresult);
procedure perm(var x,y:tresult);
procedure komb(var x,y:tresult);
procedure bnot(var x:tresult);
procedure lnot(var x:tresult);
procedure rovno(var x,y:tresult);
procedure nerovno(var x,y:tresult);
procedure mensi(var x,y:tresult);
procedure vetsi(var x,y:tresult);
procedure mensirov(var x,y:tresult);
procedure vetsirov(var x,y:tresult);
procedure band(var x,y:tresult);
procedure land(var x,y:tresult);
procedure bor(var x,y:tresult);
procedure lor(var x,y:tresult);
procedure bxor(var x,y:tresult);
procedure bxnor(var x,y:tresult);


procedure pol(var x,y:tresult);
procedure rec(var x,y:tresult);
procedure minl1(var x:tresult);
procedure maxl1(var x:tresult);
procedure minl2(var x,y:tresult);
procedure maxl2(var x,y:tresult);
procedure suml(var x:tresult);
procedure prodl(var x:tresult);
procedure cumll(var x:tresult);
procedure percentl(var x:tresult);
procedure mean1(var x:tresult);
procedure mean2(var x,y:tresult);
procedure median1(var x:tresult);
procedure median2(var x,y:tresult);
procedure filll(var l:tlist;x:tresult);
procedure fillm(var m:tmat;x:tresult);
procedure free(var x:tresult);
procedure trn(var x:tresult);
procedure det(var r:tresult);
procedure invmat(var r:tresult);
procedure identity(var r:tresult);
procedure augment(var x,y:tresult);
procedure nasobmat(var x,y:tresult);
procedure dim(var r:tresult);
procedure rep(var r:tresult);
procedure imp(var r:tresult);
procedure conj(var r:tresult);
procedure mattolist(var r:tresult;m:pmat;c:word);
procedure listtomat(var r:tresult;l:plist);
procedure appendtomat(var r:tresult;l:plist);
procedure mulrow(m:pmat;k:tnumero;c:word);
procedure mulrowplus(m:pmat;k:tnumero;c1,c2:word);
procedure plusrow(m:pmat;c1,c2:word);
procedure swap(m:pmat;c1,c2:word);
procedure sort(var l:tsort;down:boolean);
procedure getmemory(var p;size:longint);
procedure freememory(var p;size:longint);
implementation
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function ERROR:boolean;
begin
ERROR:=boolean(comp.error) or graphmode and grapherror;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure getmemory(var p;size:longint);
const dopryc=pointer($A000 shl 16);{pokud dojde pamet a presto se dozaduju
dalsi, prekreslim si obrzovku,ale program nespadne}
begin
if(size>=maxavail)or(size>65535)then begin pointer(p):=dopryc;seterror(MemERROR);exit;end;
getmem(pointer(p),size);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure freememory(var p;size:longint);
begin
if(size>65535)then begin seterror(SysERROR);exit;end;
if size>0 then freemem(pointer(p),size);
pointer(p):=nil;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure newnumero(var p;size:word);
const mynil=pointer($A000 shl 16);
begin
if size>65535 div sizeof(tnumero) then begin pointer(p):=mynil;seterror(MemERROR);exit;end;
size:=size*sizeof(tnumero);
getmemory(pointer(p),size);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure oldnumero(var p;size:word);
begin
if size>65535 div sizeof(tnumero) then begin seterror(SysERROR);exit;end;
size:=size*sizeof(tnumero);
freemem(pointer(p),size);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure secti(var x,y:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:case y.mode of
       0:begin plus(x.re,y.re);plus(x.im,y.im);exit;end;
       1:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.list.dim-1 do plus(y.list.data^[i],x.re);
               x:=y;y.mode:=0;
         end;
       2:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.mat.lines*y.mat.columns-1 do plus(y.mat.data^[i],x.re);
               x:=y;y.mode:=0;end;
   end;
1:case y.mode of
       0:begin if not zero(y.im) then begin seterror(MaERROR);exit;end;
                for i:=0 to x.list.dim-1 do plus(x.list.data^[i],y.re);
          end;
       1:if y.list.dim<>x.list.dim then begin seterror(DimERROR);exit;end
       else for i:=0 to x.list.dim-1 do plus(x.list.data^[i],y.list.data^[i]);
       2:begin seterror(MaERROR);exit;end;
   end;
2:begin if(x.mode<>2)or(x.mat.lines<>y.mat.lines)or(x.mat.columns<>y.mat.columns)then
        begin seterror(MaERROR);exit;end;
        for i:=0 to x.mat.lines*x.mat.columns-1 do plus(x.mat.data^[i],y.mat.data^[i]);
        free(y);end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure odecti(var x,y:tresult);
begin
neg(y);secti(x,y);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure nasob(var x,y:tresult);
var i:word;
a,b,c,d:tnumero;
begin
if ERROR then exit;
case x.mode of
0:case y.mode of
       0:begin a:=x.re;d:=y.im;
               krat(a,y.re);krat(d,x.im);minus(a,d);
               krat(y.re,x.im);krat(x.re,y.im);plus(y.re,x.re);
               x.im:=y.re;x.re:=a;exit;end;
       1:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.list.dim-1 do krat(y.list.data^[i],x.re);
               x:=y;y.mode:=0;
         end;
       2:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.mat.lines*y.mat.columns-1 do krat(y.mat.data^[i],x.re);
               x:=y;y.mode:=0;
         end;
   end;
1:case y.mode of
       0:begin if not zero(y.im) then begin seterror(MaERROR);exit;end;
                for i:=0 to x.list.dim-1 do krat(x.list.data^[i],y.re);
          end;
       1:if y.list.dim<>x.list.dim then begin seterror(DimERROR);exit;end
       else for i:=0 to x.list.dim-1 do krat(x.list.data^[i],y.list.data^[i]);
       2:begin seterror(MaERROR);exit;end;
   end;
2:case y.mode of
       0:begin if not zero(y.im) then begin seterror(MaERROR);exit;end;
                for i:=0 to x.mat.lines*x.mat.columns-1 do krat(x.mat.data^[i],y.re);
          end;
       1:seterror(MaERROR);
       2:begin nasobmat(x,y);free(y);end;
       end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure vydel(var x,y:tresult);
var i:word;
a,b,c,d:tnumero;
begin
if ERROR then exit;
case x.mode of
0:case y.mode of
       0:begin comp.inv(y.re,y.im);
               a:=x.re;d:=y.im;
               krat(a,y.re);krat(d,x.im);minus(a,d);
               krat(y.re,x.im);krat(x.re,y.im);plus(y.re,x.re);
               x.im:=y.re;x.re:=a;exit;end;
       1:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.list.dim-1 do deleno(y.list.data^[i],x.re);
               x:=y;y.mode:=0;
         end;
       2:begin seterror(MaERROR);exit;end;
   end;
1:case y.mode of
       0:begin if not zero(y.im) then begin seterror(MaERROR);exit;end;
                for i:=0 to x.list.dim-1 do deleno(x.list.data^[i],y.re);
          end;
       1:if y.list.dim<>x.list.dim then begin seterror(DimERROR);exit;end
       else for i:=0 to x.list.dim-1 do deleno(x.list.data^[i],y.list.data^[i]);
       2:begin seterror(MaERROR);exit;end;
   end;
2:begin seterror(MaERROR);exit;end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure sin(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.sin(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.sin(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure cos(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.cos(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.cos(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure tan(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.tan(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.tan(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure asin(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.asin(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.asin(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure acos(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.acos(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.acos(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure atan(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.atan(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.atan(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure sinh(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.sinh(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.sinh(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure cosh(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.cosh(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.cosh(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure tanh(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.tanh(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.tanh(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure asinh(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.asinh(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.asinh(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure acosh(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.acosh(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.acosh(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure atanh(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.atanh(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.atanh(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure fact(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.fact(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.fact(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure ln(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.ln(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.ln(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure e(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.e(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.e(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure log(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.log(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.log(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure exp10(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.exp10(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.exp10(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure sqrt(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:comp.sqrt(x.re,x.im);
1:for i:=0 to x.list.dim-1 do comp.sqrt(x.list.data^[i],zeronum);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure sqr(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:comp.sqr(x.re,x.im);
1:for i:=0 to x.list.dim-1 do comp.sqr(x.list.data^[i],zeronum);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure sqrt3(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.sqrt3(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.sqrt3(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure powmatrix(var x,y:tresult);
var i,j:longint;
begin
fractonum(y.re);
if not zero(y.im)or(y.re.x<1)or(y.re.x>maxlongint)then begin seterror(MaERROR);exit;end;
i:=trunc(y.re.x);
y:=x;
newnumero(y.mat.data,y.mat.lines*y.mat.columns);
for j:=0 to y.mat.lines*y.mat.columns-1 do
y.mat.data^[j]:=x.mat.data^[j];
for j:=2 to i do nasobmat(x,y);
free(y);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure pow(var f,e:tresult);
var i:word;
begin
if ERROR then exit;
case f.mode of
0:if not zero(f.im) then seterror(MaERROR) else
       case e.mode of
       0:if zero(e.im) then comp.pow(f.re,e.re)else seterror(MaERROR);
       1,2:seterror(MaERROR);
  end;
1:case e.mode of
       0:if zero(e.im) then for i:=0 to f.list.dim-1 do
         comp.pow(f.list.data^[i],e.re)else seterror(MaERROR);
       1:if e.list.dim<>f.list.dim then seterror(DimERROR) else
         for i:=0 to f.list.dim-1 do comp.pow(f.list.data^[i],e.list.data^[i]);
       2:seterror(MaERROR);
  end;
2:case e.mode of
       0:powmatrix(f,e);
       1,2:seterror(MaERROR);
  end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure root(var f,e:tresult);
var i:word;
begin
if ERROR then exit;
case f.mode of
0:if not zero(f.im) then seterror(MaERROR) else
       case e.mode of
       0:if zero(e.im) then comp.root(f.re,e.re)else seterror(MaERROR);
       1,2:seterror(MaERROR);
  end;
1:case e.mode of
       0:if zero(e.im) then for i:=0 to f.list.dim-1 do
         comp.root(f.list.data^[i],e.re)else seterror(MaERROR);
       1:if e.list.dim<>f.list.dim then seterror(DimERROR) else
         for i:=0 to f.list.dim-1 do comp.root(f.list.data^[i],e.list.data^[i]);
       2:seterror(MaERROR);
  end;
2:case e.mode of
       0:seterror(MaERROR);{matice ^!!}
       1,2:seterror(MaERROR);
  end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure abs(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:comp.abs(x.re,x.im);
1:for i:=0 to x.list.dim-1 do comp.abs(x.list.data^[i],zeronum);
2:for i:=0 to x.mat.columns*x.mat.lines-1 do comp.abs(x.mat.data^[i],zeronum);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure arg(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:comp.arg(x.re,x.im);
1,2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure fakan(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.fakan(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.fakan(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure int(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:begin comp.int(x.re);comp.int(x.im);end;
1:for i:=0 to x.list.dim-1 do comp.int(x.list.data^[i]);
2:for i:=0 to x.mat.columns*x.mat.lines-1 do comp.int(x.mat.data^[i]);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure fromdeg(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:begin comp.fromdeg(x.re);comp.fromdeg(x.im);end;
1:for i:=0 to x.list.dim-1 do comp.fromdeg(x.list.data^[i]);
2:for i:=0 to x.mat.columns*x.mat.lines-1 do comp.fromdeg(x.mat.data^[i]);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure fromrad(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:begin comp.fromrad(x.re);comp.fromrad(x.im);end;
1:for i:=0 to x.list.dim-1 do comp.fromrad(x.list.data^[i]);
2:for i:=0 to x.mat.columns*x.mat.lines-1 do comp.fromrad(x.mat.data^[i]);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure fromgra(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:begin comp.fromgra(x.re);comp.fromgra(x.im);end;
1:for i:=0 to x.list.dim-1 do comp.fromgra(x.list.data^[i]);
2:for i:=0 to x.mat.columns*x.mat.lines-1 do comp.fromgra(x.mat.data^[i]);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure frac(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:begin comp.frac(x.re);comp.frac(x.im);end;
1:for i:=0 to x.list.dim-1 do comp.frac(x.list.data^[i]);
2:for i:=0 to x.mat.columns*x.mat.lines-1 do comp.frac(x.mat.data^[i]);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure intg(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:begin comp.intg(x.re);comp.intg(x.im);end;
1:for i:=0 to x.list.dim-1 do comp.intg(x.list.data^[i]);
2:for i:=0 to x.mat.columns*x.mat.lines-1 do comp.intg(x.mat.data^[i]);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure inv(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:comp.inv(x.re,x.im);
1:for i:=0 to x.list.dim-1 do comp.inv(x.list.data^[i],zeronum);
2:invmat(x);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure neg(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:begin comp.neg(x.re);comp.neg(x.im);end;
1:for i:=0 to x.list.dim-1 do comp.neg(x.list.data^[i]);
2:for i:=0 to x.mat.lines*x.mat.columns-1 do comp.neg(x.mat.data^[i]);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure perm(var x,y:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:case y.mode of
       0:begin if not(zero(x.im)and zero(y.im))then begin seterror(MaERROR);exit;end;
                comp.perm(x.re,y.re);exit;end;
       1:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.list.dim-1 do comp.perm(y.list.data^[i],x.re);
               x:=y;y.mode:=0;
         end;
       2:begin seterror(MaERROR);exit;end;
   end;
1:case y.mode of
       0:begin if not zero(y.im) then begin seterror(MaERROR);exit;end;
                for i:=0 to x.list.dim-1 do comp.perm(x.list.data^[i],y.re);
          end;
       1:if y.list.dim<>x.list.dim then begin seterror(DimERROR);exit;end
       else for i:=0 to x.list.dim-1 do comp.perm(x.list.data^[i],y.list.data^[i]);
       2:begin seterror(MaERROR);exit;end;
   end;
2:begin seterror(MaERROR);exit;end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure komb(var x,y:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:case y.mode of
       0:begin if not(zero(x.im)and zero(y.im))then begin seterror(MaERROR);exit;end;
                comp.komb(x.re,y.re);exit;end;
       1:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.list.dim-1 do comp.komb(y.list.data^[i],x.re);
               x:=y;y.mode:=0;
         end;
       2:begin seterror(MaERROR);exit;end;
   end;
1:case y.mode of
       0:begin if not zero(y.im) then begin seterror(MaERROR);exit;end;
                for i:=0 to x.list.dim-1 do comp.komb(x.list.data^[i],y.re);
          end;
       1:if y.list.dim<>x.list.dim then begin seterror(DimERROR);exit;end
       else for i:=0 to x.list.dim-1 do comp.komb(x.list.data^[i],y.list.data^[i]);
       2:begin seterror(MaERROR);exit;end;
   end;
2:begin seterror(MaERROR);exit;end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure bnot(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.bnot(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.bnot(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure lnot(var x:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:if zero(x.im) then comp.lnot(x.re)else seterror(MaERROR);
1:for i:=0 to x.list.dim-1 do comp.lnot(x.list.data^[i]);
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure rovno(var x,y:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:case y.mode of
       0:begin comp.rovno(x.re,y.re);comp.rovno(x.im,y.im);comp.land(x.re,x.im);x.im.x:=0;exit;end;
       1:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.list.dim-1 do comp.rovno(y.list.data^[i],x.re);
               x:=y;y.mode:=0;
         end;
       2:begin seterror(DimERROR);exit;end;
   end;
1:case y.mode of
       0:begin if not zero(y.im) then begin seterror(MaERROR);exit;end;
                for i:=0 to x.list.dim-1 do comp.rovno(x.list.data^[i],y.re);
          end;
       1:if y.list.dim<>x.list.dim then begin seterror(DimERROR);exit;end
       else for i:=0 to x.list.dim-1 do comp.rovno(x.list.data^[i],y.list.data^[i]);
       2:begin seterror(MaERROR);exit;end;
   end;
2:begin seterror(DimERROR);exit;end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure nerovno(var x,y:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:case y.mode of
       0:begin comp.nerovno(x.re,y.re);comp.nerovno(x.im,y.im);comp.lor(x.re,x.im);x.im.x:=0;exit;end;
       1:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.list.dim-1 do comp.nerovno(y.list.data^[i],x.re);
               x:=y;y.mode:=0;
         end;
       2:begin seterror(DimERROR);exit;end;
   end;
1:case y.mode of
       0:begin if not zero(y.im) then begin seterror(MaERROR);exit;end;
                for i:=0 to x.list.dim-1 do comp.nerovno(x.list.data^[i],y.re);
          end;
       1:if y.list.dim<>x.list.dim then begin seterror(DimERROR);exit;end
       else for i:=0 to x.list.dim-1 do comp.nerovno(x.list.data^[i],y.list.data^[i]);
       2:begin seterror(DimERROR);exit;end;
   end;
2:begin seterror(DimERROR);exit;end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure mensi(var x,y:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:case y.mode of
       0:begin if not zero(x.im) or not zero(y.im)then begin seterror(MaERROR);exit;end;
       comp.mensi(x.re,y.re);exit;end;
       1:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.list.dim-1 do comp.mensi(y.list.data^[i],x.re);
               x:=y;y.mode:=0;
         end;
       2:begin seterror(DimERROR);exit;end;
   end;
1:case y.mode of
       0:begin if not zero(y.im) then begin seterror(MaERROR);exit;end;
                for i:=0 to x.list.dim-1 do comp.mensi(x.list.data^[i],y.re);
          end;
       1:if y.list.dim<>x.list.dim then begin seterror(DimERROR);exit;end
       else for i:=0 to x.list.dim-1 do comp.mensi(x.list.data^[i],y.list.data^[i]);
       2:begin seterror(DimERROR);exit;end;
   end;
2:begin seterror(DimERROR);exit;end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure vetsi(var x,y:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:case y.mode of
       0:begin if not zero(x.im) or not zero(y.im)then begin seterror(MaERROR);exit;end;
       comp.vetsi(x.re,y.re);exit;end;
       1:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.list.dim-1 do comp.vetsi(y.list.data^[i],x.re);
               x:=y;y.mode:=0;
         end;
       2:begin seterror(DimERROR);exit;end;
   end;
1:case y.mode of
       0:begin if not zero(y.im) then begin seterror(MaERROR);exit;end;
                for i:=0 to x.list.dim-1 do comp.vetsi(x.list.data^[i],y.re);
          end;
       1:if y.list.dim<>x.list.dim then begin seterror(DimERROR);exit;end
       else for i:=0 to x.list.dim-1 do comp.vetsi(x.list.data^[i],y.list.data^[i]);
       2:begin seterror(DimERROR);exit;end;
   end;
2:begin seterror(DimERROR);exit;end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure mensirov(var x,y:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:case y.mode of
       0:begin if not zero(x.im) or not zero(y.im)then begin seterror(MaERROR);exit;end;
       comp.mensirov(x.re,y.re);exit;end;
       1:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.list.dim-1 do comp.mensirov(y.list.data^[i],x.re);
               x:=y;y.mode:=0;
         end;
       2:begin seterror(DimERROR);exit;end;
   end;
1:case y.mode of
       0:begin if not zero(y.im) then begin seterror(MaERROR);exit;end;
                for i:=0 to x.list.dim-1 do comp.mensirov(x.list.data^[i],y.re);
          end;
       1:if y.list.dim<>x.list.dim then begin seterror(DimERROR);exit;end
       else for i:=0 to x.list.dim-1 do comp.mensirov(x.list.data^[i],y.list.data^[i]);
       2:begin seterror(DimERROR);exit;end;
   end;
2:begin seterror(DimERROR);exit;end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure vetsirov(var x,y:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:case y.mode of
       0:begin if not zero(x.im) or not zero(y.im)then begin seterror(MaERROR);exit;end;
       comp.vetsirov(x.re,y.re);exit;end;
       1:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.list.dim-1 do comp.vetsirov(y.list.data^[i],x.re);
               x:=y;y.mode:=0;
         end;
       2:begin seterror(DimERROR);exit;end;
          end;
1:case y.mode of
       0:begin if not zero(y.im) then begin seterror(MaERROR);exit;end;
                for i:=0 to x.list.dim-1 do comp.vetsirov(x.list.data^[i],y.re);
          end;
       1:if y.list.dim<>x.list.dim then begin seterror(DimERROR);exit;end
       else for i:=0 to x.list.dim-1 do comp.vetsirov(x.list.data^[i],y.list.data^[i]);
       2:begin seterror(DimERROR);exit;end;
   end;
2:begin seterror(DimERROR);exit;end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure band(var x,y:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:case y.mode of
       0:begin if not zero(x.im) or not zero(y.im)then begin seterror(MaERROR);exit;end;
       comp.band(x.re,y.re);exit;end;
       1:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.list.dim-1 do comp.band(y.list.data^[i],x.re);
               x:=y;y.mode:=0;
         end;
       2:begin seterror(DimERROR);exit;end;
   end;
1:case y.mode of
       0:begin if not zero(y.im) then begin seterror(MaERROR);exit;end;
                for i:=0 to x.list.dim-1 do comp.band(x.list.data^[i],y.re);
          end;
       1:if y.list.dim<>x.list.dim then begin seterror(DimERROR);exit;end
       else for i:=0 to x.list.dim-1 do comp.band(x.list.data^[i],y.list.data^[i]);
       2:begin seterror(DimERROR);exit;end;
   end;
2:begin seterror(DimERROR);exit;end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure land(var x,y:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:case y.mode of
       0:begin if not zero(x.im) or not zero(y.im)then begin seterror(MaERROR);exit;end;
       comp.land(x.re,y.re);exit;end;
       1:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.list.dim-1 do comp.land(y.list.data^[i],x.re);
               x:=y;y.mode:=0;
         end;
       2:begin seterror(DimERROR);exit;end;
   end;
1:case y.mode of
       0:begin if not zero(y.im) then begin seterror(MaERROR);exit;end;
                for i:=0 to x.list.dim-1 do comp.land(x.list.data^[i],y.re);
          end;
       1:if y.list.dim<>x.list.dim then begin seterror(DimERROR);exit;end
       else for i:=0 to x.list.dim-1 do comp.land(x.list.data^[i],y.list.data^[i]);
       2:begin seterror(DimERROR);exit;end;
   end;
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure bor(var x,y:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:case y.mode of
       0:begin if not zero(x.im) or not zero(y.im)then begin seterror(MaERROR);exit;end;
       comp.bor(x.re,y.re);exit;end;
       1:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.list.dim-1 do comp.bor(y.list.data^[i],x.re);
               x:=y;y.mode:=0;
         end;
       2:seterror(MaERROR);
   end;
1:case y.mode of
       0:begin if not zero(y.im) then begin seterror(MaERROR);exit;end;
                for i:=0 to x.list.dim-1 do comp.bor(x.list.data^[i],y.re);
          end;
       1:if y.list.dim<>x.list.dim then begin seterror(DimERROR);exit;end
       else for i:=0 to x.list.dim-1 do comp.bor(x.list.data^[i],y.list.data^[i]);
       2:begin seterror(MaERROR);exit;end;
   end;
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure lor(var x,y:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:case y.mode of
       0:begin if not zero(x.im) or not zero(y.im)then begin seterror(MaERROR);exit;end;
       comp.lor(x.re,y.re);exit;end;
       1:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.list.dim-1 do comp.lor(y.list.data^[i],x.re);
               x:=y;y.mode:=0;
         end;
       2:seterror(MaERROR);
   end;
1:case y.mode of
       0:begin if not zero(y.im) then begin seterror(MaERROR);exit;end;
                for i:=0 to x.list.dim-1 do comp.lor(x.list.data^[i],y.re);
          end;
       1:if y.list.dim<>x.list.dim then begin seterror(DimERROR);exit;end
       else for i:=0 to x.list.dim-1 do comp.lor(x.list.data^[i],y.list.data^[i]);
       2:begin seterror(MaERROR);exit;end;
   end;
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure bxor(var x,y:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:case y.mode of
       0:begin if not zero(x.im) or not zero(y.im)then begin seterror(MaERROR);exit;end;
       comp.bxor(x.re,y.re);exit;end;
       1:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.list.dim-1 do comp.bxor(y.list.data^[i],x.re);
               x:=y;y.mode:=0;
         end;
       2:seterror(MaERROR);
   end;
1:case y.mode of
       0:begin if not zero(y.im) then begin seterror(MaERROR);exit;end;
                for i:=0 to x.list.dim-1 do comp.bxor(x.list.data^[i],y.re);
          end;
       1:if y.list.dim<>x.list.dim then begin seterror(DimERROR);exit;end
       else for i:=0 to x.list.dim-1 do comp.bxor(x.list.data^[i],y.list.data^[i]);
       2:begin seterror(MaERROR);exit;end;
   end;
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure bxnor(var x,y:tresult);
var i:word;
begin
if ERROR then exit;
case x.mode of
0:case y.mode of
       0:begin if not zero(x.im) or not zero(y.im)then begin seterror(MaERROR);exit;end;
       comp.bxnor(x.re,y.re);exit;end;
       1:begin if not zero(x.im) then begin seterror(MaERROR);exit;end;
               for i:=0 to y.list.dim-1 do comp.bxnor(y.list.data^[i],x.re);
               x:=y;y.mode:=0;
         end;
       2:seterror(MaERROR);
   end;
1:case y.mode of
       0:begin if not zero(y.im) then begin seterror(MaERROR);exit;end;
                for i:=0 to x.list.dim-1 do comp.bxnor(x.list.data^[i],y.re);
          end;
       1:if y.list.dim<>x.list.dim then begin seterror(DimERROR);exit;end
       else for i:=0 to x.list.dim-1 do comp.bxnor(x.list.data^[i],y.list.data^[i]);
       2:begin seterror(MaERROR);exit;end;
   end;
2:seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function testlist(var x:tresult):boolean;
begin
testlist:=true;
if (x.mode<>1) then begin seterror(MaERROR);exit;end;
if (x.list.dim=0) then begin seterror(DimERROR);exit;end;
testlist:=false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function jemensi(a,b:tnumero):boolean;
begin
fractonum(a);fractonum(b);
jemensi:=a.x<b.x;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure pol(var x,y:tresult);
var ab,ar:tnumero;
begin
if (x.mode<>0)or(y.mode<>0)then begin free(x);free(y);seterror(MaERROR);exit;end;
if not zero(x.im)or not zero(x.im)then begin seterror(MaERROR);exit;end;
ab:=x.re;comp.abs(ab,y.re);
if zero(ab)then seterror(MaERROR);if error then exit;
ar:=x.re;comp.arg(ar,y.re);
x.mode:=1;x.list.dim:=2;newnumero(x.list.data,2);
x.list.data^[0]:=ab;
x.list.data^[1]:=ar;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure rec(var x,y:tresult);
var xx,yy:tnumero;
begin
if (x.mode<>0)or(y.mode<>0)then begin free(x);free(y);seterror(MaERROR);exit;end;
if not zero(x.im)or not zero(x.im)then begin seterror(MaERROR);exit;end;
xx:=y.re;comp.cos(xx);comp.krat(xx,x.re);
yy:=y.re;comp.sin(yy);comp.krat(yy,x.re);
if error then exit;
x.mode:=1;x.list.dim:=2;newnumero(x.list.data,2);
x.list.data^[0]:=xx;
x.list.data^[1]:=yy;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure minl1(var x:tresult);
var i:byte;
t:tnumero;
begin
if testlist(x) then exit;
t:=x.list.data^[0];
for i:=0 to x.list.dim-1 do
if jemensi(x.list.data^[i],t) then t:=x.list.data^[i];
free(x);
x.mode:=0;
x.im:=zeronum;
x.re:=t;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure maxl1(var x:tresult);
var i:byte;
t:tnumero;
begin
if testlist(x) then exit;
t:=x.list.data^[0];
for i:=0 to x.list.dim-1 do
if jemensi(t,x.list.data^[i]) then t:=x.list.data^[i];
free(x);
x.mode:=0;
x.im:=zeronum;
x.re:=t;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure minl2(var x,y:tresult);
var i:byte;
t:tnumero;
begin
if testlist(x) then exit;if testlist(y) then exit;
if x.list.dim<>y.list.dim then begin seterror(DimERROR);exit;end;
for i:=0 to x.list.dim-1 do
if jemensi(y.list.data^[i],x.list.data^[i]) then x.list.data^[i]:=y.list.data^[i];
free(y);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure maxl2(var x,y:tresult);
var i:byte;
t:tnumero;
begin
if testlist(x) then exit;if testlist(y) then exit;
if x.list.dim<>y.list.dim then begin seterror(DimERROR);exit;end;
for i:=0 to x.list.dim-1 do
if jemensi(x.list.data^[i],y.list.data^[i]) then x.list.data^[i]:=y.list.data^[i];
free(y);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure suml(var x:tresult);
var i:byte;
t:tnumero;
begin
if testlist(x) then exit;
t:=zeronum;
for i:=0 to x.list.dim-1 do
begin fractonum(x.list.data^[i]);plus(t,x.list.data^[i]);end;
fractonum(t);
free(x);x.mode:=0;x.im:=zeronum;x.re:=t;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure prodl(var x:tresult);
var i:byte;
t:tnumero;
begin
if testlist(x) then exit;
t:=onenum;
for i:=0 to x.list.dim-1 do
begin fractonum(x.list.data^[i]);krat(t,x.list.data^[i]);end;
fractonum(t);
free(x);x.mode:=0;x.im:=zeronum;x.re:=t;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure cumll(var x:tresult);
var i:byte;
t:tnumero;
begin
if testlist(x) then exit;
t:=zeronum;
for i:=0 to x.list.dim-1 do
begin fractonum(x.list.data^[i]);
plus(t,x.list.data^[i]);x.list.data^[i]:=t;end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure percentl(var x:tresult);
var i:byte;
t:tnumero;
begin
if testlist(x) then exit;
t:=zeronum;
for i:=0 to x.list.dim-1 do
begin fractonum(x.list.data^[i]);plus(t,x.list.data^[i]);
if jemensi(x.list.data^[i],zeronum) then begin seterror(MaERROR);exit;end;
end;
t.x:=100/t.x;
for i:=0 to x.list.dim-1 do krat(x.list.data^[i],t);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure mean1(var x:tresult);
var i:word;
t:tnumero;
begin
if testlist(x) then exit;
i:=x.list.dim;
suml(x);
x.re.x:=x.re.x/i;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure mean2(var x,y:tresult);
var i:byte;
t:tnumero;
begin
if testlist(x) then exit;if testlist(y) then exit;
if x.list.dim<>y.list.dim then begin seterror(DimERROR);exit;end;
t:=zeronum;
for i:=0 to x.list.dim-1 do
begin fractonum(x.list.data^[i]);fractonum(y.list.data^[i]);
krat(x.list.data^[i],y.list.data^[i]);
plus(t,x.list.data^[i]);end;
suml(y);
fractonum(t);
t.x:=t.x/y.re.x;
free(x);x.mode:=0;x.im:=zeronum;x.re:=t;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure median2(var x,y:tresult);
var i,j:byte;
l:tsort;
t,v:double;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function valueof(t:tnumero):double;
begin
fractonum(t);
valueof:=t.x;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin
if testlist(x) then exit;if testlist(y) then exit;
if x.list.dim<>y.list.dim then begin seterror(DimERROR);exit;end;
l[0]:=@x.list;l[1]:=@y.list;
for i:=2 to 5 do l[i]:=nil;
sort(l,true);
i:=0;j:=i;
while j<x.list.dim do
begin
fractonum(x.list.data^[i]);fractonum(y.list.data^[i]);
t:=x.list.data^[j].x;
inc(i);
while (i<x.list.dim)and(valueof(x.list.data^[i])=t)do begin
y.list.data^[j].x:=valueof(y.list.data^[i])+y.list.data^[j].x;
x.list.data^[i]:=zeronum;y.list.data^[i]:=zeronum;inc(i);end;
j:=i;
end;
l[0]:=@y.list;l[1]:=@x.list;sort(l,true);
t:=x.list.data^[0].x;v:=y.list.data^[0].x;i:=1;
while (i<x.list.dim)and(v=y.list.data^[i].x)do
begin t:=t+x.list.data^[i].x;inc(i);end;
t:=t/i;
free(x);free(y);
x.mode:=0;x.im:=zeronum;x.re.mode:=0;x.re.x:=t;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure median1(var x:tresult);
var i:word;
y:tresult;
begin
if testlist(x) then exit;
y:=x;
newnumero(y.list.data,y.list.dim);
if boolean(error)then exit;
for i:=0 to y.list.dim-1 do y.list.data^[i]:=onenum;
median2(x,y);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure filll(var l:tlist;x:tresult);
var i:word;
t:tnumero;
begin
if (x.mode<>0)then begin free(x);seterror(MaERROR);exit;end;
if not zero(x.im)then begin seterror(MaERROR);exit;end;
if l.dim=0then begin seterror(DimERROR);exit;end;
for i:=0 to l.dim-1 do l.data^[i]:=x.re;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure fillm(var m:tmat;x:tresult);
var i:word;
t:tnumero;
begin
if (x.mode<>0)then begin free(x);seterror(MaERROR);exit;end;
if not zero(x.im)then begin seterror(MaERROR);exit;end;
if m.lines*m.columns=0then begin seterror(DimERROR);exit;end;
for i:=0 to m.lines*m.columns-1 do m.data^[i]:=x.re;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure augment(var x,y:tresult);
var r:tresult;
    i,j:word;
begin
if(x.mode<>2)or(y.mode<>2)then begin seterror(SynERROR);exit;end;
if x.mat.lines<>y.mat.lines then begin seterror(DimERROR);exit;end;
i:=x.mat.columns+y.mat.columns;
if i>255 then begin seterror(DimERROR);exit;end;
r.mode:=2;r.mat.lines:=x.mat.lines;r.mat.columns:=i;
newnumero(r.mat.data,i*r.mat.lines);
for i:=0 to x.mat.lines*x.mat.columns-1 do
r.mat.data^[i]:=x.mat.data^[i];
for j:=0 to y.mat.lines*y.mat.columns-1 do
begin inc(i);r.mat.data^[i]:=y.mat.data^[j];end;
free(x);free(y);x:=r;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure free(var x:tresult);
begin
case x.mode of
0: exit;
1: freememory(x.list.data,x.list.dim*sizeof(tnumero));
2: freememory(x.mat.data,x.mat.lines*x.mat.columns*sizeof(tnumero));
else seterror(SysERROR);
end;
x.mode:=0;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure trn(var x:tresult);
var trans:pnumarr;
    i,j:word;
    d:double;
begin
if x.mode<>2 then begin seterror(SynERROR);exit;end;
newnumero(trans,x.mat.lines*x.mat.columns);
if error then exit;
with x.mat do for i:=0 to lines-1 do
for j:=0 to columns-1 do trans^[i*columns+j]:=data^[j*lines+i];
i:=x.mat.lines;x.mat.lines:=x.mat.columns;x.mat.columns:=i;
with x.mat do for i:=0 to lines-1 do
for j:=0 to columns-1 do data^[i*columns+j]:=trans^[i*columns+j];
oldnumero(trans,x.mat.lines*x.mat.columns);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure det(var r:tresult);
var w,n,i,j,k:byte;
    a,pom:double;
    znova:boolean;
begin
if r.mode<>2 then begin seterror(SysERROR);exit;end;
n:=r.mat.lines;
if(n=0)or(r.mat.columns<>n)then begin seterror(DimERROR);exit;end;
for w:=0 to n*n-1 do fractonum(r.Mat.data^[w]);
znova:=false;
For I:=1 To n-1 do
For J:=0 To I-1 do
If not(comp.zero(r.Mat.data^[J+J*n])) then begin
a:=-r.Mat.data^[J+I*n].x/r.Mat.data^[J+J*n].x;
For K:=0 To N-1 do begin
pom:=a*r.Mat.data^[J*n+K].x;
r.Mat.data^[I*n+K].x:=r.Mat.data^[I*n+K].x+pom;
end;
end else znova:=true;

if znova then
for I:=n-2 downto 0 do
for J:=n-1 downto I+1 do
If not(comp.zero(r.Mat.data^[J+J*n])) then begin
a:=-r.Mat.data^[J+I*n].x/r.Mat.data^[J+J*n].x;
For K:=0 To N do
begin
pom:=a*r.Mat.data^[J*n+K].x;
r.Mat.data^[I*n+K].x:=r.Mat.data^[I*n+K].x+pom;
end;
end;
A:=1;
For I:=0 To n-1 do
a:=a*r.mat.data^[I+n*I].x;
free(r);r.mode:=0;r.im:=zeronum;r.re.mode:=0;r.re.x:=a;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure invmat(var r:tresult);
var w,n,i,j,pp,k:byte;
    a,pom:double;
    inv:tresult;
    znova:boolean;
begin
if r.mode<>2 then begin seterror(SysERROR);exit;end;
n:=r.mat.lines;
if(n=0)or(r.mat.columns<>n)then begin seterror(DimERROR);exit;end;
if n=1 then begin comp.inv(r.mat.data^[0],zeronum);exit;end;
for w:=0 to n*n-1 do fractonum(r.Mat.data^[w]);
inv.mode:=0;inv.im:=zeronum;inv.re.mode:=0;inv.re.x:=n;
identity(inv);

for pp:=0 to 3 do begin
znova:=false;
For I:=1 To n-1 do
For J:=0 To I-1 do
If not(comp.zero(r.Mat.data^[J+J*n])) then begin
a:=-r.Mat.data^[I+J*n].x/r.Mat.data^[J+J*n].x;
For K:=0 To N-1 do begin
pom:=a*r.Mat.data^[K*n+J].x;
r.Mat.data^[K*n+I].x:=r.Mat.data^[K*n+I].x+pom;
pom:=a*inv.Mat.data^[K*n+J].x;
inv.Mat.data^[K*n+I].x:=inv.Mat.data^[K*n+I].x+pom;
end;
end else znova:=true;

for I:=n-2 downto 0 do
for J:=n-1 downto I+1 do
If not(comp.zero(r.Mat.data^[J+J*n])) then begin
a:=-r.Mat.data^[I+J*n].x/r.Mat.data^[J+J*n].x;
For K:=0 To N-1 do
begin
pom:=a*r.Mat.data^[K*n+J].x;
r.Mat.data^[K*n+I].x:=r.Mat.data^[K*n+I].x+pom;
pom:=a*inv.Mat.data^[K*n+J].x;
inv.Mat.data^[K*n+I].x:=inv.Mat.data^[K*n+I].x+pom;
end;
end else znova:=true;
if not znova then break;
end;
if znova then begin seterror(MaERROR);free(r);free(inv);exit;end;
for i:=0 to n-1 do
begin
a:=r.Mat.data^[I*n+I].x;
for j:=0 to n-1 do
inv.Mat.data^[J*n+I].x:=inv.Mat.data^[J*n+I].x/a;
end;
free(r);
r:=inv;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure identity(var r:tresult);
var i,j,k,n:word;
begin
if (r.mode<>0)then begin free(r);seterror(MaERROR);exit;end;
if not zero(r.im)then begin seterror(MaERROR);exit;end;
fractonum(r.re);r.re.x:=system.int(r.re.x+1e-10);
if (r.re.x<1)or(r.re.x>68)then begin seterror(ArgERROR);exit;end;
n:=trunc(r.re.x);
r.mode:=2;r.mat.lines:=n;r.mat.columns:=n;newnumero(r.mat.data,n*n);
r.mat.data^[0]:=onenum;
i:=0;
for j:=0 to n-2 do
begin
for k:=0 to n-1 do
begin inc(i);r.mat.data^[i]:=zeronum;
end;
inc(i);r.mat.data^[i]:=onenum;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure nasobmat(var x,y:tresult);
var z:tresult;
    i,j,k:byte;
    pom,pom2:tnumero;
begin
if(x.mode<>2)or(y.mode<>2)then begin seterror(SysERROR);exit;end;
if x.mat.columns<>y.mat.lines then begin seterror(MaERROR);
exit;end;
z.mode:=2;z.mat.lines:=x.mat.lines;z.mat.columns:=y.mat.columns;
newnumero(z.mat.data,z.mat.lines*z.mat.columns);if error then exit;

for i:=0 to x.mat.lines-1 do
 for j:=0 to y.mat.columns-1 do
 begin
  pom:=zeronum;
  for k:=0 to x.mat.columns-1 do
  begin
   pom2:=x.mat.data^[x.mat.lines*k+i];
   comp.krat(pom2,y.mat.data^[y.mat.lines*j+k]);
   plus(pom,pom2);
  end;
  z.mat.data^[z.mat.lines*j+i]:=pom;
end;
free(x);
x:=z;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure dim(var r:tresult);
var i,j:byte;
begin
case r.mode of
1:begin i:=r.list.dim;free(r);r.im:=zeronum;r.re.mode:=0;r.re.x:=i;end;
2:begin i:=r.mat.lines;j:=r.mat.columns;free(r);
        r.mode:=1;r.list.dim:=2;newnumero(r.list.data,2);
        r.list.data^[0].mode:=0;r.list.data^[1].mode:=0;
        r.list.data^[0].x:=i;r.list.data^[1].x:=j;end;
else seterror(MaERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure rep(var r:tresult);
begin
if r.mode<>0 then begin seterror(MaERROR);exit;end;
r.im:=zeronum;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure imp(var r:tresult);
begin
if r.mode<>0 then begin seterror(MaERROR);exit;end;
r.re:=r.im;r.im:=zeronum;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure conj(var r:tresult);
begin
if r.mode<>0 then begin seterror(MaERROR);exit;end;
comp.neg(r.im);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure mattolist(var r:tresult;m:pmat;c:word);
var i,j:word;
begin
if(m^.lines=0)or(m^.columns<=c)then begin seterror(DimERROR);exit;end;
r.mode:=1;
r.list.dim:=m^.lines;
newnumero(r.list.data,r.list.dim);if error then exit;
j:=c*m^.lines;
for i:=0 to r.list.dim-1 do
r.list.data^[i]:=m^.data^[i+j];
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure listtomat(var r:tresult;l:plist);
var i:word;
begin
if(l^.dim=0)then begin seterror(DimERROR);exit;end;
r.mode:=2;
r.mat.lines:=l^.dim;r.mat.columns:=1;
newnumero(r.mat.data,r.mat.lines);if error then exit;
for i:=0 to r.mat.lines-1 do
r.mat.data^[i]:=l^.data^[i];
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure appendtomat(var r:tresult;l:plist);
var i,j:word;
    pom:pnumarr;
begin
if r.mode<>2 then begin seterror(SysERROR);exit;end;
if(r.mat.lines<>l^.dim)then begin seterror(DimERROR);exit;end;
newnumero(pom,r.mat.lines*(r.mat.columns+1));if error then exit;
for i:=0 to r.mat.lines*r.mat.columns-1 do
pom^[i]:=r.mat.data^[i];
inc(i);
for j:=0 to r.mat.lines-1 do
pom^[i+j]:=l^.data^[j];
oldnumero(r.mat.data,r.mat.lines*r.mat.columns);
r.mat.data:=pom;
inc(r.mat.columns);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure mulrow(m:pmat;k:tnumero;c:word);
var i:word;
begin
if(m^.lines<c)or(m^.columns=0)then begin seterror(DimERROR);exit;end;
dec(c);
for i:=0 to m^.columns-1 do
comp.krat(m^.data^[i*m^.lines+c],k);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure plusrow(m:pmat;c1,c2:word);
var i:word;
begin
if(m^.lines<c1)or(m^.lines<c2)or(m^.columns=0)then begin seterror(DimERROR);exit;end;
dec(c1);dec(c2);
for i:=0 to m^.columns-1 do
comp.plus(m^.data^[i*m^.lines+c2],m^.data^[i*m^.lines+c1]);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure mulrowplus(m:pmat;k:tnumero;c1,c2:word);
var i:word;
t:tnumero;
begin
if(m^.lines<c1)or(m^.lines<c2)or(m^.columns=0)then begin seterror(DimERROR);exit;end;
dec(c1);dec(c2);
for i:=0 to m^.columns-1 do
begin
t:=m^.data^[i*m^.lines+c1];
krat(t,k);
comp.plus(m^.data^[i*m^.lines+c2],t);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure swap(m:pmat;c1,c2:word);
var i:word;
    t:tnumero;
begin
if(m^.lines<c1)or(m^.lines<c2)or(m^.columns=0)then begin seterror(DimERROR);exit;end;
dec(c1);dec(c2);
for i:=0 to m^.columns-1 do
begin
t:=m^.data^[i*m^.lines+c1];
m^.data^[i*m^.lines+c1]:=m^.data^[i*m^.lines+c2];
m^.data^[i*m^.lines+c2]:=t;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure sort(var l:tsort;down:boolean);
var t:tnumero;
i,j,k:word;
e,f:boolean;
begin
for k:=1 to 5 do if l[k]=nil then begin dec(k);break;end;
j:=l[0]^.dim;
if j=0 then begin seterror(DimERROR);exit;end;
for i:=1 to k do if j<>l[i]^.dim then begin seterror(DimERROR);exit;end;
repeat
f:=true;
for i:=1 to l[0]^.dim-1 do begin
if down then e:=jemensi(l[0]^.data^[i-1],l[0]^.data^[i])else e:=jemensi(l[0]^.data^[i],l[0]^.data^[i-1]);
if e then begin
     f:=false;
     for j:=0 to k do begin
         t:=l[j]^.data^[i];
         l[j]^.data^[i]:=l[j]^.data^[i-1];
         l[j]^.data^[i-1]:=t;
         end;
     end;
end;
until f;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
end.
