{$A+,B-,D+,E+,F+,G+,I-,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
unit executer;
interface
uses crt,dos,font,comp,chroust,parser,graf,enexecut;
type tdisp=record     {co se ma zobrazit po tokenu -disp- (#12)}
     name:byte;
     case mode:byte of
     0:();            {Done}
     1:(v:pvar);      {cislo-vysledek}
     2:(l:plist);     {list}
     3:(m:pmat);      {matice}
     4,5:();          {vypis,plot}
     6:(p:ptable);    {disptable,...}
     255:();          {0=> nebo Dsz 1}
     end;
     pcache=^tcache;  {cache pro jiz nactene podprogramy}
     tcache=record
     name:string[80];
     buf:pcomm;
     next:pcache;
     end;

     tplot=procedure(x,y:double);
var totalfertig,fertig:boolean;  {priznaky ukonceni programu}
    disp:tdisp;
{pole pro programy 0..9,A..Z,r,theta}
const progs:array[0..12+byte('Z')-byte('A')] of pcomm
=(nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,
nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,nil,
nil,nil,nil,nil,nil,nil,nil,nil,nil,nil);
zdrzovacka:word=0;   {cekani po kazdem prikazu}
tracemode:boolean=false;
cache:pcache=nil;
{chybove vypisy}
const ermsg:array[0..10]of string[3]=
('Ma ','Syn','Go ','Ne ','Arg', 'Com','Mem','Dim','Stk','Sys','Prg');
const stprog:byte=0; {uroven vnoreni podprogramu}
{function error:boolean;}
procedure testend;
procedure er;
procedure run(s:string;sub:boolean);
procedure runb(s:byte;sub:boolean);
procedure lbl;
procedure gotolbl;
procedure prog;
procedure setrange;
procedure setfactor;
procedure cls;
procedure mcl;
procedure scl;
procedure setdeg;
procedure setrad;
procedure setgra;
procedure setdec;
procedure sethex;
procedure setbin;
procedure setoct;
procedure setnorm;
procedure setfix;
procedure setsci;
procedure seteng;
procedure graphy;
procedure graphx;
procedure graphint;
procedure graphv;
procedure graphm;
procedure graphr;
procedure graphxy;
procedure plot;
procedure line;
procedure isz;
procedure dsz;
procedure rnd;
procedure vypis;
procedure komentar;
procedure parsecom;
procedure defm;
procedure done;
procedure docolor;
procedure otaznik;
function autodelay:word;
procedure dispbreak;
procedure DrawGraph;
procedure kresligrafy(mask:byte);
implementation
uses disparr,keyboard;
{rozskakovaci tabulka, 768 polozek}
const tabfunc:array[0..767]of procedure=
(er,er,er,er,er,er,er,er,er,er,er,er,er,er,er,parsecom,
{16}er,er,er,er,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,
parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,
{32}er,er,vypis,er,er,er,er,komentar,parsecom,er,er,er,er,er,parsecom,er,
{48}parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,
parsecom,parsecom,parsecom,parsecom,er,er,er,er,er,otaznik,er,
{65}parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,
{71}parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,
{78}parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,
{85}parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,
{91}parsecom,er,er,er,er,er,{97=a}er,er,er,er,er,er,er,er,er,er,er,er,
{109}er,er,er,er,er,er,er,er,er,er,er,er,er,er,parsecom,er,er,{126}er,er,
parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,er,
{137}parsecom,er,er,er,parsecom,parsecom,parsecom,parsecom,parsecom,
{146}parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,er,er,
{156}parsecom,er,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,
{165}parsecom,parsecom,parsecom,er,er,er,er,er,parsecom,parsecom,parsecom,
{176}er,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,er,er,
{186}er,er,er,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,
{196}parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,er,er,parsecom,
{206}parsecom,parsecom,parsecom,cls,mcl,rnd,setdec,sethex,setbin,setoct,scl,setnorm,
{218}setdeg,setrad,setgra,seteng,parsecom,parsecom,plot,line,lbl,setfix,setsci,
{229}defm,er,er,dsz,isz,setfactor,setrange,gotolbl,prog,graphy,graphint,graphv,graphm,
{242}graphv,graphm,graphr,graphxy,er,er,er,er,er,{251}parsecom,parsecom,parsecom,parsecom,done,
{prefixovane tokeny 127}
parsecom,parsecom,parsecom ,er,parsecom,parsecom,parsecom,er,parsecom,parsecom,parsecom,
parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,er,parsecom,parsecom,
parsecom,er,parsecom,parsecom,parsecom,er,er,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,
parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,
er,setPLorange,setPLBlue,setPLGreen,docolor,docolor,docolor,doOrangeG,doBlueG,doGreenG,er,er,er,er,
er,er,parsecom,parsecom,mulrow,mulrowplus,rowplus,Swap,parsecom,fill,parsecom,parsecom,parsecom,parsecom,
parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,er,er,er,er,er,er,er,er,er,er,
er,er,er,er,parsecom,parsecom,parsecom,parsecom,er,er,er,er,er,er,er,
er,er,er,er,er,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,er{'x'},
er,er,er,er,er,er,er,parsecom,parsecom,parsecom,er,er,er,er,er,er,
er,er,er,er,er,er,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,
parsecom,parsecom,parsecom,er{'List X'},er{'List Y'},er,er,er,er,er,er,parsecom,parsecom,
parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,parsecom,er,
er,er,er,parsecom,er,er,er,er,er{'Simp'},er,er,er,er{'Int/'},er{'Rmdr'},er,er,er,
er,er,er,er,er,er,er,er,er,er,er,er,er,er,er,er,er,
er,er,er,er,er,er,er,er,er,er,er,er,er,er,er,er,er,
er,er,er,er,er,er,er,er,er,er,er,er,er,parsecom,parsecom,parsecom,parsecom,parsecom,
er,er,er,er,er,er,er,er,er,er,er,
{prefixovane tokeny 247}
doif,er,doElse,Ifend,doFor,er,er,Next,doWhile,WhileEnd,doDo,
LpWhile,Return,dobreak,Stop,er,Locate,Send,Receive,er,er,er,
er,er,ClrText,ClrGraph,ClrList,er,er,er,er,er,DrawGraph,
er,DrawDyna,DrawStat,DrawFTGCon,DrawFTGPlt,DrawRCon,DrawRPlt,
DrawRSumCon,DrawRSumPlt,DrawWeb,er,er,er,DispFTbl,DispRTbl,
AutoSimp,ManSimp,er,er,er,er,er,er,er{MixedFrac},er{ImproperFrac},
er,er,er,er,er,er,Variable1,Variable2,er,er,
er,er,er,er,er,er,SGph1,SGph2,SGph3,er,er,er,er,er,er,er,er,er,er,er,
er,er,er,er,er,er,er,er,SWindAuto,SWindMan,GraphX,selgraphtype,
selgraphtype,selgraphtype,er,selgraphtype,er,er,selgraphtype,selgraphtype,selgraphtype,selgraphtype,er,
er,GConnect,GPlot,DualGraph,DualGtoT,DualTG,DualOff,er,er,BGNone,BGPict,
GridOff,GridDot,GridLine,GridOn,er,er,Dvar,NrmSpeed,FastSpeed,SlowSpeed,StopGo,
DynaCon,DynaStop,er,VarRange,er,Simul,Poly,er,er,er,er,
anType,an1Type,an2Type,StoPict,RclPict,StoGMEM,RclGMEM,StoVWin,RclVWin,er,er,
er,er,er,er,er,Tangent,Normal,Inverse,Vertical,Horizontal,Text,
Circle,FLine,PlotOn,PlotOff,PlotChg,PxlOn,PxlOff,PxlChg,PxlLine,PxlTest,SortA,
SortD,VarList,VarList,VarList,VarList,VarList,VarList,setFile,setFile,setFile,setFile,
setFile,setFile,er,er,FuncOn,SimulOn,AxesOn,CoordOn,LabelOn,DerivOn,LocusOn,
sumdispOn,GSelOn,TSelOn,DSelOn,RSelOn,DrawOn,er,er,er,FuncOff,SimulOff,
AxesOff,CoordOff,LabelOff,DerivOff,LocusOff,sumdispOff,GSelOff,TSelOff,DSelOff,RSelOff,DrawOff,
er,er,er,er,er,er,er,er,er,er,er,er,er,er,er,er,er,er,er,er,er,er,
er,er,er,er,er,er,er,er,er,er,er,er,er);
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure stri(var s1,s2:string21;var v:tvar);
var ss,sss:string21;
begin
s1:=numtostr(v.re);
s2:='';if not zero(v.im) then s2:=numtostr(v.im)+'';
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure dodisp;
var s1,s2:string21;
    i,j:byte;c:char;
begin
if disp.mode=1 then begin
stri(s1,s2,disp.v^);
while s1[0]<#21 do s1:=' '+s1;
if s2<>'' then begin
if s2[1]<>'-' then s2:='+'+s2;
while s2[0]<#21 do s2:=' '+s2;
end;
for i:=1 to byte(s1[0]) do textln(byte(s1[i]));
if s2<>'' then for i:=1 to byte(s2[0]) do textln(byte(s2[i]));
end
else
begin
graf.color:=graf.cgreen;
if disp.mode<>4 then begin s1:='Done';
j:=12;if size>96 then inc(j,5);for i:=1 to j do textln(32);
for i:=1 to byte(s1[0]) do textln(byte(s1[i]));end;
end;
j:=8;if size>96 then inc(j,5);for i:=1 to j do textln(32);
s1:='- Disp -';graf.color:=graf.cgreen;
for i:=1 to byte(s1[0]) do textln(byte(s1[i]));
case disp.mode of
2,3:dispmat(disp);
5  :traceplot;
6  :disptable(disp);
255:;
else repeat c:=readkey; if c=#27 then dispbreak;until c=#13;
end;
dec(ty,8);inc(j,8);
for i:=1 to j do textln(32);
dec(ty,8);
graf.color:=graf.cblue;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure scrollto(errpoz:word);
var c:word;
begin
poz:=0;
while poz<=errpoz do
begin
c:=getcom;if c=255 then break;
for i:=1 to byte(font.znak[c,0]) do textln(byte(font.znak[c,i]));
if (c or 1)=13 then newline;
end;
while (readkey=#0)do ;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure disperror(e:byte);
var s:string21;
    i,j:byte;
    c:word;
begin
e:=e shr 1;
j:=3;if size>96 then inc(j,2);for i:=1 to j do textln(32);
s:=ermsg[e];for i:=1 to byte(s[0]) do textln(byte(s[i]));
s:=' ERROR';for i:=1 to byte(s[0]) do textln(byte(s[i]));newline;
j:=2;if size>96 then inc(j,2);for i:=1 to j do textln(32);
s:='Step ';for i:=1 to byte(s[0]) do textln(byte(s[i]));
str(errpoz-1:5,s);for i:=1 to byte(s[0]) do textln(byte(s[i]));newline;
while (readkey=#0)do ;
scrollto(errpoz);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure dispbreak;
var s:string21;
    i,j:byte;
begin
graf.color:=graf.cblue;
j:=3;if size>96 then inc(j,2);for i:=1 to j do textln(32);
s:='   Break ';for i:=1 to byte(s[0]) do textln(byte(s[i]));newline;
j:=2;if size>96 then inc(j,2);for i:=1 to j do textln(32);
s:='Step ';for i:=1 to byte(s[0]) do textln(byte(s[i]));
str(poz:5,s);for i:=1 to byte(s[0]) do textln(byte(s[i]));newline;
while (readkey=#0)do ;
scrollto(poz);
closegraph;donekey;halt;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure dispbatt;
var s:string21;
    i,j:byte;
begin
j:=1;if size>96 then inc(j,2);for i:=1 to j do textln(32);
s:='Low Battery';for i:=1 to byte(s[0]) do textln(byte(s[i]));newline;
j:=2;if size>96 then inc(j,2);for i:=1 to j do textln(32);
s:='Step ';for i:=1 to byte(s[0]) do textln(byte(s[i]));
str(errpoz:5,s);for i:=1 to byte(s[0]) do textln(byte(s[i]));newline;
readkey;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function zero(x:tvar):boolean;
begin
fractonum(x.re);fractonum(x.im);
if(x.im.x<>0) then seterror(MaERROR);
zero:=(system.abs(x.re.x)<1e-10)
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function error:boolean;
begin
error:=boolean(comp.error);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure loadp(var p:pcomm;c:byte);
var f:file;
size:word;
s:string[20];
begin
case c of
cr:s:='progr.cas';
cfi:s:='progfi.cas';
else s:='prog'+char(c)+'.cas';
end;
assign(f,s);reset(f,1);
if ioresult<>0 then begin seterror(GoERROR);exit;end;
size:=filesize(f);
getmemory(p,size+1);if boolean(error)then exit;
blockread(f,p^,size);close(f);
p^[size]:=255;
if p^[0]=58 then p:=pointer(51+longint(p));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure loadf(var p:pcomm;s:string);
var f:file;
size:word;
begin
assign(f,s+'.cas');reset(f,1);
if ioresult<>0 then begin seterror(GoERROR);exit;end;
size:=filesize(f);
getmemory(p,size+1);if boolean(error)then exit;
blockread(f,p^,size);close(f);
p^[size]:=255;
if p^[0]=58 then p:=pointer(51+longint(p));
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure runbuffer;
var oloopstack:ploopstack;
    olspoz:byte;
    oifstack:pifstack;
    oifspoz:word;
begin
oloopstack:=loopstack;olspoz:=lspoz;new(loopstack);lspoz:=0;
oifstack:=ifstack;oifspoz:=ifspoz;new(ifstack);ifspoz:=0;
inc(stprog);

fertig:=false;
repeat
tabfunc[testcom];delay(zdrzovacka);
graf.color:=graf.cblue;
if not boolean(error) and not fertig and testdisp then dodisp;
disp.mode:=0;
if tracemode or keypressed then if readkey=#27 then dispbreak;
until fertig or error;
if totalfertig then exit;
if error then begin disperror(comp.error);totalfertig:=true;end;
dec(stprog);
dispose(loopstack);loopstack:=oloopstack;lspoz:=olspoz;
dispose(ifstack);ifstack:=oifstack;ifspoz:=oifspoz;


end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure run(s:string;sub:boolean);
var f:file;
oldp,p:pcomm;oldpoz:word;
pc,ppc:pcache;
begin
oldpoz:=poz;oldp:=comm;
if s='' then begin seterror(ArgERROR);exit;end;
pc:=cache;
if pc=nil then begin
     loadf(comm,s);if boolean(error)then exit;
     new(cache);cache^.next:=nil;
     cache^.buf:=comm;cache^.name:=s;
     end
else begin
     while pc^.next<>nil do begin if pc^.name=s then break;pc:=pc^.next;end;
     if pc^.name=s then comm:=pc^.buf
     else begin
     loadf(comm,s);if boolean(error)then exit;
     new(ppc);pc^.next:=ppc;ppc^.next:=nil;
     ppc^.buf:=comm;ppc^.name:=s;end;
end;
poz:=0;
runbuffer;
fertig:=false;
poz:=oldpoz;comm:=oldp;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure runb(s:byte;sub:boolean);
var f:file;
oldp:pcomm;oldpoz:word;
index:byte;
begin
index:=s-48;
if index>9 then dec(index,7);
if index>36 then dec(index,114);
if progs[index]=nil then loadp(progs[index],s);
if boolean(error)then exit;
oldpoz:=poz;poz:=0;
oldp:=comm;comm:=progs[index];
runbuffer;
fertig:=false;
poz:=oldpoz;comm:=oldp;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure jump(c:word);
label st,nc,err,vp,lb,ok;
var com,oldpoz:word;
begin
oldpoz:=poz;fertig:=false;
poz:=0;
goto nc;
st:com:=getcomnorm;
   case com of
   12,13,58  :goto nc;
   255       :goto err;
   byte('"') :goto vp;
   else goto st;
   end;

nc:com:=getcomnorm;
   case com of
   12,13,58  :goto nc;
   255       :goto err;
   byte('"') :goto vp;
   226       :goto lb;
   else goto st;
   end;

vp:com:=getcomnorm;
   case com of
   255       :goto err;
   byte('"') :goto st;
   else goto vp;
   end;

lb:com:=getcomnorm;
   if com <>c then goto st;
   com:=getcom;
   case com of
   12,13,58:goto ok;
   255     :begin fertig:=true;goto ok;end;
   else goto st;
   end;

err:seterror(GoERROR);poz:=oldpoz;exit;

ok:
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure jumpcom;
label st,vp,ende,ok;
var com,oldpoz:word;
begin

st:com:=getcom;
   case com of
   12,13,58  :goto ok;
   255       :goto ende;
   byte('"') :goto vp;
   else goto st;
   end;


vp:com:=getcom;
   case com of
   255       :goto ende;
   byte('"') :goto st;
   else goto vp;
   end;

ende:fertig:=true;

ok:
disp.mode:=255;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure testend;
begin
case getcom of
12,13,58:;
255:fertig:=true;
else seterror(SynERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure er;
begin
getcom;
seterror(SynERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure lbl;
begin
getcom;
case getcom of
48..57,65..90,cr,cfi:testend;
else seterror(SynERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure gotolbl;
var  c:word;
begin
getcom;c:=getcom;
case c of
48..57,65..90,cr,cfi:begin testend;jump(c);end;
else seterror(SynERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure prog;
var
s:string[20];
c:word;
begin
getcom;s:='';if stprog>50 then begin seterror(NeERROR);exit;end;
c:=getcom;
case c of
48..57,65..90,cr,cfi:begin testend;runb(c,true);end;
byte('"'):begin s:='';while testcom<>byte('"') do s:=s+chr(getcom);getcom;testend;
                if not boolean(error) then run(s,true);end;
else seterror(SynERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setrange;
var x:array[1..9]of double;
i,c:word;
r:tresult;
begin
getcom;
c:=testcom;
x[1]:=xmin;x[2]:=xmax;x[3]:=xscl;
x[4]:=ymin;x[5]:=ymax;x[6]:=yscl;
x[7]:=tmin;x[8]:=tmax;x[9]:=tptch;
for i:=1 to 9 do
begin
c:=testcom;
case c of
44:getcom;
12,13,58,255:break;
else begin x[i]:=param;if testcom=44 then getcom;end;
end;
end;
testend;
if error then exit;
graf.range(x[1],x[2],x[3],x[4],x[5],x[6],x[7],x[8],x[9]);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setfactor;
var xf,yf: double; c:word;
begin
getcom;
xf:=param;yf:=xf;if error then exit;
c:=testcom;
if c=byte(',') then begin
getcom;yf:=param;if error then exit;end;
testend;
graf.factor(xf,yf);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure cls;
begin
getcom;
testend;
if error then exit;
graf.cls;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure mcl;
var i:byte;
begin
getcom;
testend;if error then exit;
for i:=0 to defined do with variables^[i] do begin re.mode:=0;re.x:=0;im:=re;end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure scl;
begin
seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setdeg;
begin
getcom;
testend;
comp.setdeg;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setrad;
begin
getcom;
testend;
comp.setrad;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setgra;
begin
getcom;
testend;
comp.setgra;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setdec;
begin
getcom;
testend;
comp.setdec;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure sethex;
begin
getcom;
testend;
comp.sethex;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setbin;
begin
getcom;
testend;
comp.setbin;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setoct;
begin
getcom;
testend;
comp.setoct;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setnorm;
begin
getcom;
testend;
comp.setnorm;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setfix;
var c:word;
begin
getcom;
c:=getcom;
if (c<48)or(c>57) then seterror(ArgERROR);
testend;
comp.setfix(c-48);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure setsci;
var c:word;
begin
getcom;
c:=getcom;
if (c<48)or(c>57) then seterror(ArgERROR);
testend;
comp.setsci(c-48);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure seteng;
begin
getcom;
seterror(PrgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure kresligraf(plot:tplot;x1,x2:double);
var lx1,lx2,xs,y:double;
    gpoz,epoz:word;
    pl,err:boolean;


begin
graphmode:=true;
lx1:=-1e100;lx2:=-lx1;
gpoz:=poz;
param;if error then exit;
epoz:=poz;
if getcom=byte(',') then begin if getcom=byte('[') then begin
                    graphmode:=false;
                    y:=param;lx1:=y;
                    if error then exit;
                    if getcom<>byte(',') then begin seterror(SynERROR);exit;end;
                    y:=param;lx2:=y;
                    if lx2<lx1 then seterror(MaERROR);
                    if error then exit;
                    if testcom=byte(']') then getcom;
                    graphmode:=true;
                    end;end else poz:=epoz;
testend;
epoz:=poz;
xs:=(x2-x1)/(size-1);
variables^[23].im:=zeronum;variables^[24].im:=zeronum;
err:=true;
with variables^[23].re do begin
mode:=0;x:=x1;
while x<=x2+0.2*xs do begin
poz:=gpoz;grapherror:=false;
y:=param;
if error then exit;
if not grapherror and(x>=lx1)and(x<=lx2)then begin
pl:=ploted;ploted:=false;plot(x,y);
if not err and connect and pl and ploted then graf.line;
end
else begin grapherror:=true;if @plot<>@graf.plot then graf.clear(x);end;
err:=grapherror;
x:=x+xs;
end;
end;
poz:=epoz;
graphmode:=false;

end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure graphint;
var x1,x2,d1,d2,xs,y:double;
    gpoz,epoz:word;
    pl,err:boolean;
    r:tresult;
begin
gpoz:=poz;
integral(r);
testend;
if boolean(error)then exit;
varans.re:=r.re;
varans.im:=r.im;
epoz:=poz;
poz:=gpoz;
getcom;
gpoz:=poz;

graphmode:=true;
x1:=graf.xmin;x2:=graf.xmax;
param;
getcom;{=byte(',')}
grapherror:=false;
d1:=param;
getcom;{=byte(',')}
d2:=param;
if d2<d1 then begin
xs:=d1;d1:=d2;d2:=xs;
end;
graphmode:=true;
xs:=(x2-x1)/(size-1);
variables^[23].im:=zeronum;variables^[24].im:=zeronum;
err:=true;
with variables^[23].re do begin
mode:=0;x:=x1;
while x<=x2+0.2*xs do begin
poz:=gpoz;grapherror:=false;
y:=param;
if error then exit;
if not grapherror then begin
pl:=ploted;ploted:=false;if(x>=d1)and(x<=d2)then intplot(x,y)else graf.plot(x,y);
if not err and connect and pl and ploted then graf.line;
end;
err:=grapherror;
x:=x+xs;
end;
end;
poz:=epoz;
graphmode:=false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure graphx;
begin
getcom;
kresligraf(graf.plotx,graf.ymin,graf.ymax);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure graphy;
begin
getcom;
kresligraf(graf.plot,graf.xmin,graf.xmax);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure graphv;
begin
getcom;
kresligraf(graf.plotm,graf.xmin,graf.xmax);graf.filling:=false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure graphm;
begin
getcom;
kresligraf(graf.plotv,graf.xmin,graf.xmax);graf.filling:=false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure kreslir;
var t1,t2,xx,y,pitch:double;
    gpoz,epoz:word;
    pl,err:boolean;
    pom:tnumero;

begin
graphmode:=true;
t1:=graf.tmin;t2:=graf.tmax;
gpoz:=poz;
param;if error then exit;
epoz:=poz;
if getcom=byte(',') then begin if getcom=byte('[') then begin
                    graphmode:=false;
                    t1:=param;
                    if error then exit;
                    if getcom<>byte(',') then begin seterror(SynERROR);exit;end;
                    t2:=param;
                    if error then exit;
                    if testcom=byte(']') then getcom;
                    graphmode:=true;
                    end;end else poz:=epoz;
epoz:=poz;pitch:=graf.tptch;if t2<t1 then pitch:=-pitch;
varfi.im:=zeronum;variables^[23].im:=zeronum;variables^[24].im:=zeronum;
err:=true;
with varfi.re do begin
mode:=0;x:=t1;
while x<=t2 do begin
poz:=gpoz;grapherror:=false;
y:=param;if error then exit;
pom:=varfi.re;comp.cos(pom);
xx:=y*pom.x;pom:=varfi.re;comp.sin(pom);
y:=y*pom.x;
if error then exit;

if not grapherror then begin
pl:=ploted;ploted:=false;graf.plot(xx,y);
if not err and connect and pl and ploted then graf.line;
end;
err:=grapherror;
x:=x+tptch;
end;
end;
poz:=epoz;
graphmode:=false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure graphr;
begin
getcom;
kreslir;
testend;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure kreslixy(normal:boolean);
var t1,t2,xx,y,tpitch:double;
    c,gpoz,epoz:word;
    pl,err:boolean;
    pom:tnumero;

begin
graphmode:=true;
t1:=graf.tmin;t2:=graf.tmax;
gpoz:=poz;
param;c:=getcom;
if c<>byte(',') then if normal or(c<>246)then begin seterror(SynERROR);exit;end;
if error then exit;
param;if normal then if testcom=byte(')') then getcom;
if error then exit;
epoz:=poz;
if getcom=byte(',') then begin if getcom=byte('[') then begin
                    graphmode:=false;
                    t1:=param;
                    if error then exit;
                    if getcom<>byte(',') then begin seterror(SynERROR);exit;end;
                    t2:=param;
                    if error then exit;
                    if testcom=byte(']') then getcom;
                    graphmode:=true;
                    end;end else poz:=epoz;
epoz:=poz;tpitch:=graf.tptch;if t2<t1 then tpitch:=-tpitch;
variables^[19].im:=zeronum;variables^[23].im:=zeronum;variables^[24].im:=zeronum;
err:=true;
with variables^[19].re do begin
mode:=0;x:=t1;
while x<=t2+0.2*tpitch do begin
poz:=gpoz;grapherror:=false;
xx:=param;if error then exit;getcom;{=','}
y:=param;if error then exit;
if error then exit;
if not grapherror then begin
pl:=ploted;ploted:=false;graf.plot(xx,y);
if not err and connect and pl and ploted then graf.line;
end;
err:=grapherror;
x:=x+tpitch;
end;
end;
poz:=epoz;
graphmode:=false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure graphxy;
begin
getcom;
kreslixy(true);
testend;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure plot;
var x,y:double;
begin
getcom;
case testcom of
12,13,58,255:begin x:=graf.getx(64);y:=graf.gety(32);end;
else begin
x:=param;
if getcom<>44 then seterror(SynERROR);
if error then exit;
y:=param;
end;end;
testend;
if error then exit;
graf.plot(x,y);if not ploted then exit;
variables^[23].re.mode:=0;variables^[23].re.x:=graf.getx(0);variables^[23].im:=zeronum;
variables^[24].re.mode:=0;variables^[24].re.x:=graf.gety(0);variables^[24].im:=zeronum;
disp.mode:=5;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure line;
begin
begin
getcom;
testend;
if error then exit;
graf.line;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure isz;
var c:word;
begin
getcom;
c:=getcom;
case c of
65..90:begin c:=c-65+selectvar;testend;
             if (c<0)or(c>defined) then seterror(MemERROR);
             if boolean(error) then exit;
             plus(variables^[c].re,onenum);if zero(variables^[c]) then jumpcom;end;
cr    :begin testend;if boolean(error) then exit;
      plus(varr.re,onenum);if zero(varr) then jumpcom;end;
cfi   :begin testend;if boolean(error) then exit;
      plus(varfi.re,onenum);if zero(varfi) then jumpcom;end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure dsz;
var c:word;
begin
getcom;
c:=getcom;
case c of
65..90:begin c:=c-65+selectvar;testend;
             if (c<0)or(c>defined) then seterror(MemERROR);
             if boolean(error) then exit;
             minus(variables^[c].re,onenum);if zero(variables^[c]) then jumpcom;end;
cr    :begin testend;if boolean(error) then exit;
      minus(varr.re,onenum);if zero(varr) then jumpcom;end;
cfi   :begin testend;if boolean(error) then exit;
      minus(varfi.re,onenum);if zero(varfi) then jumpcom;end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure rnd;
begin
getcom;testend;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure opravduvypis(p1,p2:word);
var c,opoz:word;
    i:byte;
begin
opoz:=poz;poz:=p1;
while poz<p2 do
begin c:=getcom;
for i:=1 to byte(font.znak[c,0]) do begin textln(byte(font.znak[c,i]));
if (c or 1)=13 then newline;end;
end;
poz:=opoz;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure stogrmem(p1,p2:word);
const cgY=496;cgr=497;cgXt=498;cgYt=499;cgX=500;
{grtype+611:-}cYtype=611;crtype=612;cParamType=613;cXcType=615;
cYvType=618;cYmType=619;cYvrType=620;cYmrType=621;
var i,typ,index:word;
    carka:byte;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure prvnicast;
var i,j,carkapoz,pp:word;
    pom:pcomm;
begin
carkapoz:=0;
with graphvars[index] do begin
while(data^[carkapoz]<>246)and(data^[carkapoz]<>255)do inc(carkapoz);
pp:=carkapoz+1;while(data^[pp]<>246)and(data^[pp]<>255)do inc(pp);
getmemory(pom,size-carkapoz+p2-p1+1);if boolean(error)then exit;
for i:=0 to p2-p1 do pom^[i]:=comm^[p1+i];
for j:=0 to pp-carkapoz do pom^[i+j]:=data^[carkapoz+j];
freememory(data,size);size:=size-carkapoz+p2-p1+1;
data:=pom;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure druhacast;
var i,j,carkapoz,pp:word;
    pom:pcomm;
begin
carkapoz:=0;
with graphvars[index] do begin
while(data^[carkapoz]<>246)and(data^[carkapoz]<>255)do inc(carkapoz);
pp:=carkapoz+1;while(data^[pp]<>246)and(data^[pp]<>255)do inc(pp);
getmemory(pom,size-pp+carkapoz+p2-p1+2);if boolean(error)then exit;
for i:=0 to carkapoz do
pom^[i]:=data^[i];pom^[i]:=246;inc(i);
for j:=0 to p2-p1-1 do
pom^[i+j]:=comm^[p1+j];
pom^[i+j+1]:=255;
freememory(data,size);size:=size-carkapoz+p2-p1+2;
data:=pom;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
begin
getcom;carka:=0;
typ:=getcom;
if(typ<496)or(typ>500)then begin seterror(SynERROR);exit;end;
index:=trunc(nnumber(10));
if(index<1)or(index>30)then seterror(SynERROR);
if error then exit;
dec(index);
testend;if error then exit;
case typ of
cgr:typ:=crtype-611;
cgx:typ:=cxctype-611;
cgxt:if graphvars[index].grtype=cparamtype-611 then begin prvnicast;exit;end
        else typ:=cparamtype-611;
cgyt:if graphvars[index].grtype=cparamtype-611 then begin druhacast;exit;end
        else begin typ:=cparamtype-611;inc(carka);end;
else typ:=graphtype;
end;
with graphvars[index] do begin
grtype:=typ;color:=graf.cblue;selected:=byte(p2-p1<>0);
freememory(data,size);if p2=p1 then begin size:=0;exit;end;
size:=p2-p1+1+carka;getmemory(data,size);if boolean(error)then exit;
for i:=0 to p2-p1-1 do data^[i+carka]:=comm^[p1+i];
data^[i+1+carka]:=255;if boolean(carka)then data^[0]:=246;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function autodelay:word;
var i,a,c1,c2,d1,d2:word;
begin
gettime(a,a,c1,d1);
for a:=0 to 15 do for i:=0 to 65535 do;
gettime(a,a,c2,d2);
if c2<c1 then inc(c2,60);
d1:=(c2-c1)*100+d2-d1;
if d1<20 then autodelay:=20 else autodelay:=400 div d1;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function timer:double;
var a,b,c,d:word;
begin
gettime(a,b,c,d);
timer:=0.01*d+c+60.0*b+3600.0*a;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure komentar;
var c:word;
const timer0:double=0;
begin
getcom;
if testcom=byte('$') then
 begin getcom;
case testcom of
byte('V'):begin getcom;
   case testcom of
   byte('+'),cplus:begin getcom;testend;@getcom:=@getcomdebug;exit;end;
   byte('-'),153:begin getcom;testend;@getcom:=@getcomnorm;exit;end;
   end;end;
byte('T'):begin getcom;
   case testcom of
   byte('+'),cplus:begin getcom;testend;tracemode:=true;exit;end;
   byte('-'),153:begin getcom;testend;tracemode:=false;exit;end;
   end;end;
byte('W'):begin getcom;zdrzovacka:=trunc(nnumber(10));testend;exit;end;
byte('A'):begin getcom;zdrzovacka:=autodelay;testend;exit;end;
byte('S'):begin getcom;testend;timer0:=timer;exit;end;
byte('R'):begin getcom;testend;timer0:=0;exit;end;
byte('E'):begin getcom;testend;varans.im:=zeronum;
                varans.re.mode:=0;varans.re.x:=timer-timer0;exit;
          end;
 end;
end;
repeat
c:=getcom;
until(c or 1=13)or(c=58)or(c=255);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure newmat(var r:tresult);
var i,j,c:word;
    m:pmat;
begin
getcom;
if getcom<>cmat then begin seterror(SynERROR);exit;end;
c:=getcom;if(c<65)or(c>90)then seterror(SynERROR);
testend;
if r.list.dim<>2then seterror(DimERROR);
for i:=0 to 1 do begin
fractonum(r.list.data^[i]);
if (r.list.data^[i].x<0)or(r.list.data^[i].x>=256)then seterror(DimERROR);
end;
if boolean(error) then exit;
i:=trunc(r.list.data^[0].x);
j:=trunc(r.list.data^[1].x);
m:=@matrix[c-64];
oldnumero(m^.data,m^.lines*m^.columns);
free(r);
m^.lines:=i;m^.columns:=j;
newnumero(m^.data,m^.lines*m^.columns);
if boolean(error)then exit;
for c:=0 to i*j-1 do m^.data^[c]:=zeronum;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure storelist(var r:tresult);
var c:word;
begin
if testcom<>14 then begin
oldnumero(listans.data,listans.dim);
listans.dim:=r.list.dim;
listans.data:=r.list.data;
r.mode:=0;
disp.mode:=2;disp.l:=@listans;
testend;exit;end;
getcom;
if testcom=326 then begin newmat(r);exit;end;
if getcom<>clist then begin seterror(SynERROR);exit;end;
c:=getcom;if(c<49)or(c>54)then begin seterror(SynERROR);exit;end;
testend;c:=c-49;if boolean(error)then begin free(r);exit;end;
oldnumero(lists^[c].data,lists^[c].dim);
lists^[c].dim:=r.list.dim;
lists^[c].data:=r.list.data;
r.mode:=0;
disp.mode:=0;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure storematrix(var r:tresult);
var c:word;
begin
c:=0;
if testcom=14 then begin
getcom;if getcom<>cmat then begin seterror(SynERROR);free(r);exit;end;
c:=getcom;
if(c<65)or(c>90)then begin seterror(SynERROR);free(r);exit;end;
c:=c-64;end;
testend;if boolean(error)then begin free(r);exit;end;

with matrix[c] do begin
oldnumero(data,lines*columns);
lines:=r.mat.lines;columns:=r.mat.columns;
data:=r.mat.data;r.mode:=0;end;
disp.mode:=3;disp.m:=@matrix[c];disp.name:=c;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure storetolist(var r:tresult);
var l:plist;
    c:word;
    i:byte;
begin
c:=getcom;
if(c<55)and(c>48)then l:=@lists^[c-49]
else if c=cans then l:=@listans else begin seterror(SynERROR);exit;end;
if testcom<>byte('[') then begin seterror(SynERROR);exit;end;
i:=getlistindex;testend;if boolean(error)then exit;
if i>l^.dim then begin seterror(ArgERROR);exit;end;
fractonum(r.im);if(r.im.x<>0) then begin seterror(MaERROR);exit;end;
l^.data^[i-1]:=r.re;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure storetomat(var r:tresult);
var m:pmat;
    c:word;
    i:word;
begin
c:=getcom;
if(c<91)and(c>64)then m:=@matrix[c-64]
else if c=cans then m:=@matrix[0] else begin seterror(SynERROR);exit;end;
if testcom<> byte('[') then begin seterror(SynERROR);exit;end;
i:=getmatindex;testend;if boolean(error)then exit;
if lo(i)>=m^.columns+1 then begin seterror(ArgERROR);exit;end;
if hi(i)>=m^.lines+1 then begin seterror(ArgERROR);exit;end;
fractonum(r.im);if(r.im.x<>0) then begin seterror(MaERROR);exit;end;
i:=hi(i)+m^.lines*lo(i)-m^.lines-1;
m^.data^[i]:=r.re;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure storevarible(var r:tresult;c:word);
const
cXmin=256;cXmax=257;cXscl=258;cYmin=260;cYmax=261;cYscl=262;cTmin=264;
cTmax=265;cTptch=266;cXfct=267;cYfct=268;cDStart=269;cDEnd=270;cDPitch=271;
cRightXmin=272;cRightXmax=273;cRightXscl=274;cDiv=275;cRightYmin=276;cRightYmax=277;
cRightYscl=278;cDTx=279;cRightTmin=280;cRightTmax=281;cRightTscl=282;
cFStart=401;cFEnd=402;cFpitch=403;cRStart=405;cREnd=406;cRpitch=407;
ca0=420;ca1=421;ca2=422;cb0=426;cb1=427;cb2=428;canStart=429;cbnStart=430;


begin
fractonum(r.im);fractonum(r.re);
if r.im.x<>0 then begin seterror(MaERROR);exit;end;
case c of
    cxmin:     graf.xmin      := r.re.x;
    cxmax:     graf.xmax      := r.re.x;
    cxscl:     graf.xscl      := r.re.x;
    cymin:     graf.ymin      := r.re.x;
    cymax:     graf.ymax      := r.re.x;
    cyscl:     graf.yscl      := r.re.x;
    ctmin:     graf.tmin      := r.re.x;
    ctmax:     graf.tmax      := r.re.x;
    ctptch:    graf.tptch     := r.re.x;
    crightxmin:graf.rightxmin := r.re.x;
    crightxmax:graf.rightxmax := r.re.x;
    crightxscl:graf.rightxscl := r.re.x;
    crightymin:graf.rightymin := r.re.x;
    crightymax:graf.rightymax := r.re.x;
    crightyscl:graf.rightyscl := r.re.x;
    crighttmin:graf.righttmin := r.re.x;
    crighttmax:graf.righttmax := r.re.x;
    crighttscl:graf.righttptch :=r.re.x;
    cxfct:     graf.xfct      := r.re.x;
    cyfct:     graf.yfct      := r.re.x;
    cdstart:begin dstart:= r.re.x;exit;end;
    cdend:begin   dend  := r.re.x;exit;end;
    cdpitch:begin dpitch:= r.re.x;exit;end;
    cfstart:begin fstart:= r.re.x;exit;end;
    cfend:begin   fend  := r.re.x;exit;end;
    cfpitch:begin fpitch:= r.re.x;exit;end;
    crstart:begin rstart:= r.re.x;exit;end;
    crend:begin   rend  := r.re.x;exit;end;
    crpitch:begin rpitch:= r.re.x;exit;end;
    ca0    :begin ra0:= r.re.x;exit;end;
    ca1    :begin ra1:= r.re.x;exit;end;
    ca2,canStart:begin ra2:= r.re.x;exit;end;
    cb0    :begin rb0:= r.re.x;exit;end;
    cb1    :begin rb1:= r.re.x;exit;end;
    cb2,cbnStart:begin rb2:= r.re.x;exit;end;
    else seterror(SynERROR);
end;
graf.cls;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure newlist(var r:tresult);
var i,c:word;
    l:plist;
begin
if getcom<>clist then begin seterror(SynERROR);exit;end;
c:=getcom;if(c<49)or(c>54)then seterror(SynERROR);
testend;
if not comp.zero(r.im)then seterror(MaERROR);
fractonum(r.re);
if(r.re.x<1)or(r.re.x>=256)then seterror(MaERROR);
if boolean(error) then exit;
i:=trunc(r.re.x);
l:=@lists^[c-49];
oldnumero(l^.data,l^.dim);
l^.dim:=i;
newnumero(l^.data,l^.dim);
if boolean(error) then exit;
for c:=0 to i-1 do l^.data^[c]:=zeronum;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure store(var r:tresult);
var c:word;
    pom,po:byte;
begin
c:=getcom;
case c of
byte('A')..byte('Z'):begin pom:=selectvar;pom:=c-byte('A')+pom;
    if(pom<0)or(pom>defined)then begin seterror(MemERROR);exit;end;po:=pom;
    if testcom=byte('~')then begin
        getcom;c:=getcom;po:=c-byte('A')+selectvar;
        if(po<0)or(po>defined)or(po<pom)then begin seterror(MemERROR);exit;end;
        end;testend;if error then exit;
    if r.mode<>0 then begin seterror(MaERROR);exit;end;
    disp.mode:=1;disp.v:=@variables^[pom];
    for c:=pom to po do begin
        variables^[c].re:=r.re;variables^[c].im:=r.im;
        end;
    end;
cr:begin testend;if error then exit;if r.mode<>0 then begin seterror(MaERROR);exit;end;
         disp.mode:=1;disp.v:=@varr;varr.re:=r.re;varr.im:=r.im;end;
cfi:begin testend;if error then exit;if r.mode<>0 then begin seterror(MaERROR);exit;end;
         disp.mode:=1;disp.v:=@varfi;varfi.re:=r.re;varfi.im:=r.im;end;
clist:storetolist(r);
cmat:storetomat(r);
256..282,401..407,420..422,426..430:begin testend;storevarible(r,c);end;
326:newlist(r);
else begin seterror(SynERROR);exit;end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure parsecom;
var r:tresult;
c:word;
begin
parse13(r);
case r.mode of
0:;
1:begin storelist(r);exit;end;
2:begin storematrix(r);exit;end;
else begin seterror(SysERROR);exit;end;
end;
c:=getcom;
case c of
58,12,13,255:begin disp.mode:=1;disp.v:=@varans;varans.re:=r.re;varans.im:=r.im;end;
14:store(r);
cimpl:begin if(r.mode<>0)or(not comp.zero(r.im))then begin seterror(SynERROR);exit;end;
            if comp.zero(r.re) then jumpcom;
      end;
else seterror(SynERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure defm;
var d:double;
    w,i:word;
    begin
getcom;
i:=testcom;
case i of
12,13,58,255:begin testend;exit;end;
end;
d:=number+25;
testend;
if (d>=25)and(d<=1525) then
begin
w:=trunc(d);
for i:=defined to w do with variables^[i] do
begin re.mode:=0;re.x:=0;im:=re;end;
defined:=w;
end
else
seterror(ArgERROR);
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure docolor;
begin
case getcom of
308:graf.color:=graf.corange;
309:graf.color:=graf.cblue;
310:graf.color:=graf.cgreen;
end;
case testcom of
byte('"'),238..245,610,672..686,224..225:tabfunc[testcom];
else seterror(SynERROR);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure otaznik;
var oldp,p:pcomm;oldpoz:word;
r:tresult;
begin
getcom;
if testcom<>14 then begin seterror(SynERROR);exit;end;
oldpoz:=poz;oldp:=comm;
getmemory(comm,21);if boolean(error)then exit;
while true do begin
textln(byte('?'));tx:=500;
editbuf(comm);
poz:=0;
parse13(r);
if comp.error=0 then break;
disperror(comp.error);
comp.error:=0;
graf.clrtext;
end;
fertig:=false;
freememory(comm,21);
poz:=oldpoz;comm:=oldp;
case r.mode of
0:begin getcom;store(r);end;
1:storelist(r);
2:storematrix(r);
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure vypis;
var c,p1,p2:word;{?->,""->}
    i:byte;
begin
getcom;disp.mode:=4;
p1:=poz;
while testcom<>byte('"') do
begin c:=getcom;
if c=255 then begin seterror(SynERROR);exit;end;
end;
p2:=poz;getcom;
c:=testcom;
case c of
12,13,58,255:begin opravduvypis(p1,p2);tx:=500;getcom;exit;end;
14         :begin stogrmem(p1,p2);exit;end;
byte('?')   :begin opravduvypis(p1,p2);otaznik;exit;end;
else         begin seterror(SynERROR);exit;end;
end;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure done;
begin
fertig:=true;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure kresligrafy(mask:byte);
var i:byte;
oldpoz:word;
oldcom:pcomm;
begin
graf.cls;
if boolean(error)then exit;
oldcom:=comm;oldpoz:=poz;
for i:=0 to 29 do
with graphvars[i] do
if(selected and mask<>0)and(size<>0)then begin
comm:=data;poz:=0;graf.color:=color;
case grtype of
0:kresligraf(graf.plot,graf.xmin,graf.xmax);
1:kreslir;
2:kreslixy(false);
3:kresligraf(graf.plotx,graf.ymin,graf.ymax);
7,9:begin kresligraf(graf.plotm,graf.xmin,graf.xmax);graf.filling:=false;end;
8,10:begin kresligraf(graf.plotv,graf.xmin,graf.xmax);graf.filling:=false;end;
else seterror(SysERROR);
end;
if boolean(error)then exit;
end;
comm:=oldcom;
poz:=oldpoz;
fertig:=false;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
procedure DrawGraph;
begin
getcom;
kresligrafy(1);
testend;
end;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}

end.